diff -pruN 1.3.1-1/appveyor.yml 1.4.0-1/appveyor.yml
--- 1.3.1-1/appveyor.yml	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/appveyor.yml	2018-05-01 17:12:07.000000000 +0000
@@ -1,10 +1,4 @@
 environment:
-
-  # SDK v7.0 MSVC Express 2008's SetEnv.cmd script will fail if the
-  # /E:ON and /V:ON options are not enabled in the batch script interpreter
-  # See: http://stackoverflow.com/a/13751649/163740
-  CMD_IN_ENV: "cmd /E:ON /V:ON /C obvci_appveyor_python_build_env.cmd"
-
   matrix:
     - TARGET_ARCH: x64
       CONDA_NPY: 111
@@ -12,12 +6,20 @@ environment:
       CONDA_INSTALL_LOCN: C:\\Miniconda-x64
 
     - TARGET_ARCH: x64
+      CONDA_NPY: 114
+      CONDA_PY: 27
+      CONDA_INSTALL_LOCN: C:\\Miniconda-x64
+
+    - TARGET_ARCH: x64
       CONDA_NPY: 111
       CONDA_PY: 36
-      CONDA_INSTALL_LOCN: C:\\Miniconda35-x64
+      CONDA_INSTALL_LOCN: C:\\Miniconda36-x64
+
+    - TARGET_ARCH: x64
+      CONDA_NPY: 114
+      CONDA_PY: 36
+      CONDA_INSTALL_LOCN: C:\\Miniconda36-x64
 
-# We always use a 64-bit machine, but can build x86 distributions
-# with the TARGET_ARCH variable.
 platform:
     - x64
 
@@ -33,24 +35,25 @@ install:
            throw "There are newer queued builds for this pull request, failing early." }
 
     # Add path, activate `conda` and update conda.
-    - cmd: set "PATH=%CONDA_INSTALL_LOCN%\\Scripts;%CONDA_INSTALL_LOCN%\\Library\\bin;%PATH%"
-    - cmd: set PYTHONUNBUFFERED=1
     - cmd: call %CONDA_INSTALL_LOCN%\Scripts\activate.bat
-    # for obvci_appveyor_python_build_env.cmd
-    - cmd: conda update --all --yes
-    - cmd: conda install anaconda-client=1.6.3 --yes
-    - cmd: conda install -c conda-forge --yes obvious-ci
-    # for msinttypes and newer stuff
-    - cmd: conda config --prepend channels conda-forge
-    - cmd: conda config --set show_channel_urls yes
-    - cmd: conda config --set always_yes true
-    # For building conda packages
-    - cmd: conda install --yes conda-build jinja2 anaconda-client
-    # this is now the downloaded conda...
-    - cmd: conda info -a
+    - cmd: conda config --set always_yes yes --set changeps1 no --set show_channel_urls true --set auto_update_conda false
+    - cmd: conda update conda
+    # We need to pin conda until https://github.com/conda/conda/issues/6556 is fixed.
+    - cmd: conda config --system --add pinned_packages defaults::conda
+    - cmd: conda config --add channels conda-forge --force
+
+    # Install conda-build.
+    - cmd: conda install conda-build
+
+    - cmd: set PYTHONUNBUFFERED=1
+  
+    - cmd: conda install vs2008_express_vc_python_patch
+    - cmd: call setup_x64.bat
+  
+    - cmd: conda info --all
 
 # Skip .NET project specific build phase.
 build: off
 
 test_script:
-    - "%CMD_IN_ENV% conda build conda.recipe --quiet"
+    - conda build conda.recipe
diff -pruN 1.3.1-1/Changelog 1.4.0-1/Changelog
--- 1.3.1-1/Changelog	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/Changelog	2018-05-01 17:12:07.000000000 +0000
@@ -1,3 +1,39 @@
+ version 1.4.0 (not yet released)
+=============================
+ * fixed bug in detection of CDF5 library support in setup.py (pull request
+   #736, issue #713).
+ * fixed reading of variables with zero-length dimensions in NETCDF3_CLASSIC
+   files (issue #743).
+ * allow integer-like objects in VLEN slices (not just python ints, issue
+   #526, pull request #757).
+ * treating _FillValue as a valid_min/valid_max was too surprising, despite
+   the fact the thet netcdf docs 'attribute best practices' suggests that
+   clients should to this.  Revert this change from issue #576 (issue #761).
+ * remove netcdftime, since it is now a separate package. date2num, num2date
+   and date2index still importable from netCDF4.
+ * fix 'Unreachable code' cython warning (issue #767).
+ * Change behavior of string attributes so that nc.stringatt = ['foo','bar']
+   produces an vlen string array attribute in NETCDF4, instead of concatenating
+   into a single string ('foobar').  In NETCDF3/NETCDF4_CLASSIC, an IOError
+   is now raised, instead of writing 'foobar'. Issue #770.
+ * fix loading of enum type names (issue #775).
+ * make sure missing_value applies only to scaled short integers if
+   auto-scaling is on (issue #777).
+ * automatically create views of compound types with character arrays as 
+   numpy strings (issue #773).  Can be disabled using
+   'set_auto_chartostring(False)'. Numpy structured
+   array dtypes with 'SN' string subtypes can now be used to
+   define netcdf compound types (they get converted to ('S1',N)
+   character array types automatically).
+ * always return masked array by default, even if there are no 
+   masked values (too surprising to get ndarray or MaskedArray depending
+   on slice, issue #785).
+ * treat valid_min/valid_max/_FillValue/missing_value as unsigned
+   integers if _Unsigned is set (to mimic behaviour of netcdf-java).
+   Conversion to unsigned type now occurs before masking and scale/offset
+   operation. Issue #794.
+ 
+
  version 1.3.1 (tag v1.3.1rel)
 =============================
  * add parallel IO capabilities.  netcdf-c and hdf5 must be compiled with MPI
diff -pruN 1.3.1-1/conda.recipe/bld.bat 1.4.0-1/conda.recipe/bld.bat
--- 1.3.1-1/conda.recipe/bld.bat	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/conda.recipe/bld.bat	2018-05-01 17:12:07.000000000 +0000
@@ -8,4 +8,4 @@ echo netCDF4_libdir = %LIBRARY_LIB% >> %
 echo netCDF4_incdir = %LIBRARY_INC% >> %SITECFG%
 
 "%PYTHON%" setup.py install --single-version-externally-managed  --record record.txt
-if errorlevel 1 exit 1
+if errorlevel 1 exit 1
\ No newline at end of file
diff -pruN 1.3.1-1/conda.recipe/build.sh 1.4.0-1/conda.recipe/build.sh
--- 1.3.1-1/conda.recipe/build.sh	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/conda.recipe/build.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-#!/bin/bash
-
-SETUPCFG=$SRC_DIR\setup.cfg
-
-echo "[options]" > $SETUPCFG
-echo "[directories]" >> $SETUPCFG
-echo "netCDF4_dir = $PREFIX" >> $SETUPCFG
-
-${PYTHON} setup.py install --single-version-externally-managed --record record.txt
diff -pruN 1.3.1-1/conda.recipe/meta.yaml 1.4.0-1/conda.recipe/meta.yaml
--- 1.3.1-1/conda.recipe/meta.yaml	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/conda.recipe/meta.yaml	2018-05-01 17:12:07.000000000 +0000
@@ -21,21 +21,24 @@ requirements:
     - cython
     - numpy x.x
     - msinttypes  # [win and py<35]
-    - hdf5 1.8.17|1.8.17.*
-    - libnetcdf 4.4.*
+    - hdf5 
+    - libnetcdf 
+    - cftime
   run:
     - python
     - setuptools
     - numpy x.x
-    - hdf5 1.8.17|1.8.17.*
-    - libnetcdf 4.4.*
+    - hdf5 
+    - libnetcdf 
+    - cython
+    - cftime
 
 test:
   source_files:
     - test
   imports:
     - netCDF4
-    - netcdftime
+    - cftime
   commands:
     - ncinfo -h
     - nc4tonc3 -h
diff -pruN 1.3.1-1/COPYING 1.4.0-1/COPYING
--- 1.3.1-1/COPYING	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/COPYING	2018-05-01 17:12:07.000000000 +0000
@@ -15,18 +15,6 @@ OTHER TORTIOUS ACTION, ARISING OUT OF OR
 PERFORMANCE OF THIS SOFTWARE.
 
 
-parts of pyiso8601 are included in netcdftime under the following license:
-
-Copyright (c) 2007 Michael Twomey
-
-Permission is hereby granted, free of charge, to any person obtaining a
-copy of this software and associated documentation files (the
-"Software"), to deal in the Software without restriction, including
-without limitation the rights to use, copy, modify, merge, publish,
-distribute, sublicense, and/or sell copies of the Software, and to
-permit persons to whom the Software is furnished to do so, subject to
-the following conditions:
-
 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.
 
diff -pruN 1.3.1-1/debian/changelog 1.4.0-1/debian/changelog
--- 1.3.1-1/debian/changelog	2017-10-31 06:37:16.000000000 +0000
+++ 1.4.0-1/debian/changelog	2018-05-16 04:50:56.000000000 +0000
@@ -1,3 +1,16 @@
+netcdf4-python (1.4.0-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Update copyright-format URL to use HTTPS.
+  * Update Vcs-* URLs for Salsa.
+  * Bump Standards-Version to 4.1.4, no changes.
+  * Add module import tests to autopkgtest configuration.
+  * Add python{,3}-cftime to build dependencies.
+  * Drop ancient X-Python-Version field.
+  * Strip trailing whitespace from control & rules files.
+
+ -- Bas Couwenberg <sebastic@debian.org>  Wed, 16 May 2018 06:50:56 +0200
+
 netcdf4-python (1.3.1-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 1.3.1-1/debian/control 1.4.0-1/debian/control
--- 1.3.1-1/debian/control	2017-10-31 06:36:59.000000000 +0000
+++ 1.4.0-1/debian/control	2018-05-07 19:20:54.000000000 +0000
@@ -7,9 +7,11 @@ Priority: optional
 Build-Depends: debhelper (>= 9),
                dh-python,
                python-all-dev (>= 2.6.6-3~),
+               python-cftime,
                python-setuptools,
                python-numpy,
                python3-all-dev,
+               python3-cftime,
                python3-setuptools,
                python3-numpy,
                cython,
@@ -18,11 +20,10 @@ Build-Depends: debhelper (>= 9),
                libnetcdf-dev (>= 1:4.4.0),
                netcdf-bin,
                chrpath
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/netcdf4-python.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/netcdf4-python.git
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/debian-gis-team/netcdf4-python/
+Vcs-Git: https://salsa.debian.org/debian-gis-team/netcdf4-python.git
 Homepage: http://unidata.github.io/netcdf4-python/
-X-Python-Version: >= 2.7
 
 Package: python-netcdf4
 Architecture: any
@@ -67,4 +68,3 @@ Description: Python 3 interface to the n
  containing vlens, and vlens containing compound types) are not supported.
  .
  This package contains the netCDF 4 module for Python 3.
-
diff -pruN 1.3.1-1/debian/copyright 1.4.0-1/debian/copyright
--- 1.3.1-1/debian/copyright	2016-11-29 18:28:07.000000000 +0000
+++ 1.4.0-1/debian/copyright	2018-01-20 21:24:13.000000000 +0000
@@ -1,4 +1,4 @@
-Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+Format: https://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
 Upstream-Name: netcdf4-python
 Upstream-Contact: Jeff Whitaker <jeffrey.s.whitaker@noaa.gov>
 Source: https://github.com/Unidata/netcdf4-python
diff -pruN 1.3.1-1/debian/rules 1.4.0-1/debian/rules
--- 1.3.1-1/debian/rules	2017-05-28 06:47:14.000000000 +0000
+++ 1.4.0-1/debian/rules	2018-05-07 19:20:59.000000000 +0000
@@ -38,4 +38,3 @@ override_dh_python2:
 override_dh_python3:
 	dh_python3 -ppython3-netcdf4
 	dh_numpy3 -ppython3-netcdf4
-
diff -pruN 1.3.1-1/debian/tests/control 1.4.0-1/debian/tests/control
--- 1.3.1-1/debian/tests/control	2017-09-25 06:34:07.000000000 +0000
+++ 1.4.0-1/debian/tests/control	2018-05-02 05:12:11.000000000 +0000
@@ -1,3 +1,11 @@
 # Test installability
 Depends: @
 Test-Command: /bin/true
+
+# Test module import (Python 2)
+Depends: python-all, python-netcdf4
+Test-Command: set -e ; for py in $(pyversions -r 2>/dev/null) ; do cd "$ADTTMP" ; echo "Testing with $py:" ; $py -c "import netCDF4; print(netCDF4)" ; done
+
+# Test module import (Python 3)
+Depends: python3-all, python3-netcdf4
+Test-Command: set -e ; for py in $(py3versions -r 2>/dev/null) ; do cd "$ADTTMP" ; echo "Testing with $py:" ; $py -c "import netCDF4; print(netCDF4)" ; done
diff -pruN 1.3.1-1/docs/netCDF4/index.html 1.4.0-1/docs/netCDF4/index.html
--- 1.3.1-1/docs/netCDF4/index.html	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/docs/netCDF4/index.html	2018-05-01 17:12:07.000000000 +0000
@@ -4,7 +4,7 @@
   <meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
 
     <title>netCDF4 API documentation</title>
-    <meta name="description" content="Version 1.3.1
+    <meta name="description" content="Version 1.4.0
 -------------
 - - - 
 
@@ -865,10 +865,8 @@ table {
 .codehilite .err { border: 1px solid #FF0000 } /* Error */
 .codehilite .k { color: #008000; font-weight: bold } /* Keyword */
 .codehilite .o { color: #666666 } /* Operator */
-.codehilite .ch { color: #408080; font-style: italic } /* Comment.Hashbang */
 .codehilite .cm { color: #408080; font-style: italic } /* Comment.Multiline */
 .codehilite .cp { color: #BC7A00 } /* Comment.Preproc */
-.codehilite .cpf { color: #408080; font-style: italic } /* Comment.PreprocFile */
 .codehilite .c1 { color: #408080; font-style: italic } /* Comment.Single */
 .codehilite .cs { color: #408080; font-style: italic } /* Comment.Special */
 .codehilite .gd { color: #A00000 } /* Generic.Deleted */
@@ -908,10 +906,8 @@ table {
 .codehilite .mh { color: #666666 } /* Literal.Number.Hex */
 .codehilite .mi { color: #666666 } /* Literal.Number.Integer */
 .codehilite .mo { color: #666666 } /* Literal.Number.Oct */
-.codehilite .sa { color: #BA2121 } /* Literal.String.Affix */
 .codehilite .sb { color: #BA2121 } /* Literal.String.Backtick */
 .codehilite .sc { color: #BA2121 } /* Literal.String.Char */
-.codehilite .dl { color: #BA2121 } /* Literal.String.Delimiter */
 .codehilite .sd { color: #BA2121; font-style: italic } /* Literal.String.Doc */
 .codehilite .s2 { color: #BA2121 } /* Literal.String.Double */
 .codehilite .se { color: #BB6622; font-weight: bold } /* Literal.String.Escape */
@@ -922,11 +918,9 @@ table {
 .codehilite .s1 { color: #BA2121 } /* Literal.String.Single */
 .codehilite .ss { color: #19177C } /* Literal.String.Symbol */
 .codehilite .bp { color: #008000 } /* Name.Builtin.Pseudo */
-.codehilite .fm { color: #0000FF } /* Name.Function.Magic */
 .codehilite .vc { color: #19177C } /* Name.Variable.Class */
 .codehilite .vg { color: #19177C } /* Name.Variable.Global */
 .codehilite .vi { color: #19177C } /* Name.Variable.Instance */
-.codehilite .vm { color: #19177C } /* Name.Variable.Magic */
 .codehilite .il { color: #666666 } /* Literal.Number.Integer.Long */
   </style>
 
@@ -1170,6 +1164,8 @@ table {
         
           
   <ul>
+    <li class="mono"><a href="#netCDF4.MFDataset.__init__">__init__</a></li>
+    <li class="mono"><a href="#netCDF4.MFDataset.close">close</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.createCompoundType">createCompoundType</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.createDimension">createDimension</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.createEnumType">createEnumType</a></li>
@@ -1181,6 +1177,7 @@ table {
     <li class="mono"><a href="#netCDF4.MFDataset.get_variables_by_attributes">get_variables_by_attributes</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.getncattr">getncattr</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.isopen">isopen</a></li>
+    <li class="mono"><a href="#netCDF4.MFDataset.ncattrs">ncattrs</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.renameAttribute">renameAttribute</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.renameDimension">renameDimension</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.renameGroup">renameGroup</a></li>
@@ -1195,9 +1192,6 @@ table {
     <li class="mono"><a href="#netCDF4.MFDataset.setncattr_string">setncattr_string</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.setncatts">setncatts</a></li>
     <li class="mono"><a href="#netCDF4.MFDataset.sync">sync</a></li>
-    <li class="mono"><a href="#netCDF4.MFDataset.__init__">__init__</a></li>
-    <li class="mono"><a href="#netCDF4.MFDataset.close">close</a></li>
-    <li class="mono"><a href="#netCDF4.MFDataset.ncattrs">ncattrs</a></li>
   </ul>
 
         </li>
@@ -1270,7 +1264,7 @@ table {
 
   <header id="section-intro">
   <h1 class="title"><span class="name">netCDF4</span> module</h1>
-  <h2>Version 1.3.1</h2>
+  <h2>Version 1.4.0</h2>
 <hr />
 <h1>Introduction</h1>
 <p>netcdf4-python is a Python interface to the netCDF C library.  </p>
@@ -1303,6 +1297,9 @@ types) are not supported.</p>
 <li><a href="http://cython.org">Cython</a>, version 0.21 or later.</li>
 <li><a href="https://pypi.python.org/pypi/setuptools">setuptools</a>, version 18.0 or
    later.</li>
+<li><a href="https://github.com/Unidata/cftime">cftime</a> for 
+ the time and date handling utility functions (<a href="#netCDF4.num2date"><code>num2date</code></a>,
+ <a href="#netCDF4.date2num"><code>date2num</code></a> and <a href="#netCDF4.date2index"><code>date2index</code></a>).</li>
 <li>The HDF5 C library version 1.8.4-patch1 or higher (1.8.x recommended)
  from <a href="ftp://ftp.hdfgroup.org/HDF5/current/src"></a>.
  <strong><em>netCDF version 4.4.1 or higher is recommended if using HDF5 1.10.x -
@@ -1368,6 +1365,7 @@ types) are not supported.</p>
 <li><a href="#section11">Variable-length (vlen) data types.</a></li>
 <li><a href="#section12">Enum data type.</a></li>
 <li><a href="#section13">Parallel IO.</a></li>
+<li><a href="#section14">Dealing with strings</a></li>
 </ol>
 <h2><div id='section1'>1) Creating/Opening/Closing a netCDF file.</h2>
 <p>To create a netCDF file from python, you simply call the <a href="#netCDF4.Dataset"><code>Dataset</code></a>
@@ -1397,8 +1395,8 @@ keyword in the <code>Dataset</code> cons
 accomplished via the <a href="#netCDF4.Dataset.close"><code>close</code></a> method of the <a href="#netCDF4.Dataset"><code>Dataset</code></a>
 instance.</p>
 <p>Here's an example:</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netCDF4</span> <span class="kn">import</span> <span class="n">Dataset</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;test.nc&quot;</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">,</span> <span class="n">format</span><span class="o">=</span><span class="s2">&quot;NETCDF4&quot;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netCDF4</span> <span class="kn">import</span> <span class="n">Dataset</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;test.nc&quot;</span><span class="p">,</span> <span class="s">&quot;w&quot;</span><span class="p">,</span> <span class="n">format</span><span class="o">=</span><span class="s">&quot;NETCDF4&quot;</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">data_model</span>
 <span class="n">NETCDF4</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
@@ -1424,13 +1422,13 @@ instances contained within the root grou
 the <code>groups</code> dictionary attribute of the <a href="#netCDF4.Dataset"><code>Dataset</code></a> instance.  Only
 <code>NETCDF4</code> formatted files support Groups, if you try to create a Group
 in a netCDF 3 file you will get an error message.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;test.nc&quot;</span><span class="p">,</span> <span class="s2">&quot;a&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">fcstgrp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s2">&quot;forecasts&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">analgrp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s2">&quot;analyses&quot;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;test.nc&quot;</span><span class="p">,</span> <span class="s">&quot;a&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">fcstgrp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s">&quot;forecasts&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">analgrp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s">&quot;analyses&quot;</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">groups</span>
-<span class="n">OrderedDict</span><span class="p">([(</span><span class="s2">&quot;forecasts&quot;</span><span class="p">,</span> 
+<span class="n">OrderedDict</span><span class="p">([(</span><span class="s">&quot;forecasts&quot;</span><span class="p">,</span> 
               <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Group</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4b7b0</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;analyses&quot;</span><span class="p">,</span> 
+             <span class="p">(</span><span class="s">&quot;analyses&quot;</span><span class="p">,</span> 
               <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Group</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4b970</span><span class="o">&gt;</span><span class="p">)])</span>
 </pre></div>
 
@@ -1442,8 +1440,8 @@ instances contained within that group. E
 <code>path</code> attribute that contains a simulated unix directory path to
 that group.  To simplify the creation of nested groups, you can
 use a unix-like path as an argument to <a href="#netCDF4.Dataset.createGroup"><code>createGroup</code></a>.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">fcstgrp1</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s2">&quot;/forecasts/model1&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">fcstgrp2</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s2">&quot;/forecasts/model2&quot;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">fcstgrp1</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s">&quot;/forecasts/model1&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">fcstgrp2</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createGroup</span><span class="p">(</span><span class="s">&quot;/forecasts/model2&quot;</span><span class="p">)</span>
 </pre></div>
 
 
@@ -1455,7 +1453,7 @@ returned.</p>
 <a href="#netCDF4.Dataset"><code>Dataset</code></a>. The function <code>walktree</code> is a Python generator that is used
 to walk the directory tree. Note that printing the <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a>
 object yields summary information about it's contents.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">def</span> <span class="nf">walktree</span><span class="p">(</span><span class="n">top</span><span class="p">):</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">def</span> <span class="nf">walktree</span><span class="p">(</span><span class="n">top</span><span class="p">):</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="n">values</span> <span class="o">=</span> <span class="n">top</span><span class="o">.</span><span class="n">groups</span><span class="o">.</span><span class="n">values</span><span class="p">()</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="k">yield</span> <span class="n">values</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">top</span><span class="o">.</span><span class="n">groups</span><span class="o">.</span><span class="n">values</span><span class="p">():</span>
@@ -1465,27 +1463,27 @@ object yields summary information about
 <span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">children</span> <span class="ow">in</span> <span class="n">walktree</span><span class="p">(</span><span class="n">rootgrp</span><span class="p">):</span>
 <span class="o">&gt;&gt;&gt;</span>      <span class="k">for</span> <span class="n">child</span> <span class="ow">in</span> <span class="n">children</span><span class="p">:</span>
 <span class="o">&gt;&gt;&gt;</span>          <span class="k">print</span> <span class="n">child</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
 <span class="n">root</span> <span class="n">group</span> <span class="p">(</span><span class="n">NETCDF4</span> <span class="nb">file</span> <span class="n">format</span><span class="p">):</span>
     <span class="n">dimensions</span><span class="p">:</span>
     <span class="n">variables</span><span class="p">:</span>
     <span class="n">groups</span><span class="p">:</span> <span class="n">forecasts</span><span class="p">,</span> <span class="n">analyses</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
 <span class="n">group</span> <span class="o">/</span><span class="n">forecasts</span><span class="p">:</span>
     <span class="n">dimensions</span><span class="p">:</span>
     <span class="n">variables</span><span class="p">:</span>
     <span class="n">groups</span><span class="p">:</span> <span class="n">model1</span><span class="p">,</span> <span class="n">model2</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
 <span class="n">group</span> <span class="o">/</span><span class="n">analyses</span><span class="p">:</span>
     <span class="n">dimensions</span><span class="p">:</span>
     <span class="n">variables</span><span class="p">:</span>
     <span class="n">groups</span><span class="p">:</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
 <span class="n">group</span> <span class="o">/</span><span class="n">forecasts</span><span class="o">/</span><span class="n">model1</span><span class="p">:</span>
     <span class="n">dimensions</span><span class="p">:</span>
     <span class="n">variables</span><span class="p">:</span>
     <span class="n">groups</span><span class="p">:</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
 <span class="n">group</span> <span class="o">/</span><span class="n">forecasts</span><span class="o">/</span><span class="n">model2</span><span class="p">:</span>
     <span class="n">dimensions</span><span class="p">:</span>
     <span class="n">variables</span><span class="p">:</span>
@@ -1506,19 +1504,19 @@ value is set to <code>None</code> or 0.
 <code>level</code> dimensions are unlimited.  Having more than one unlimited
 dimension is a new netCDF 4 feature, in netCDF 3 files there may be only
 one, and it must be the first (leftmost) dimension of the variable.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">level</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;level&quot;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">time</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">lat</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span> <span class="mi">73</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">lon</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;lon&quot;</span><span class="p">,</span> <span class="mi">144</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">level</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;level&quot;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">time</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;time&quot;</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">lat</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;lat&quot;</span><span class="p">,</span> <span class="mi">73</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">lon</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;lon&quot;</span><span class="p">,</span> <span class="mi">144</span><span class="p">)</span>
 </pre></div>
 
 
 <p>All of the <a href="#netCDF4.Dimension"><code>Dimension</code></a> instances are stored in a python dictionary.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span>
-<span class="n">OrderedDict</span><span class="p">([(</span><span class="s2">&quot;level&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b48030</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b481c0</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b480f8</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;lon&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b48a08</span><span class="o">&gt;</span><span class="p">)])</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span>
+<span class="n">OrderedDict</span><span class="p">([(</span><span class="s">&quot;level&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b48030</span><span class="o">&gt;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">&quot;time&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b481c0</span><span class="o">&gt;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">&quot;lat&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b480f8</span><span class="o">&gt;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">&quot;lon&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">_netCDF4</span><span class="o">.</span><span class="n">Dimension</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b48a08</span><span class="o">&gt;</span><span class="p">)])</span>
 </pre></div>
 
 
@@ -1526,7 +1524,7 @@ one, and it must be the first (leftmost)
 the current size of that dimension.
 The <a href="#netCDF4.Dimension.isunlimited"><code>isunlimited</code></a> method of a <a href="#netCDF4.Dimension"><code>Dimension</code></a> instance
 can be used to determine if the dimensions is unlimited, or appendable.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="nb">len</span><span class="p">(</span><span class="n">lon</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="nb">len</span><span class="p">(</span><span class="n">lon</span><span class="p">)</span>
 <span class="mi">144</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">lon</span><span class="o">.</span><span class="n">isunlimited</span><span class="p">()</span>
 <span class="bp">False</span>
@@ -1538,13 +1536,13 @@ can be used to determine if the dimensio
 <p>Printing the <a href="#netCDF4.Dimension"><code>Dimension</code></a> object
 provides useful summary info, including the name and length of the dimension,
 and whether it is unlimited.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">dimobj</span> <span class="ow">in</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span><span class="o">.</span><span class="n">values</span><span class="p">():</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">dimobj</span> <span class="ow">in</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span><span class="o">.</span><span class="n">values</span><span class="p">():</span>
 <span class="o">&gt;&gt;&gt;</span>    <span class="k">print</span> <span class="n">dimobj</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span> <span class="p">(</span><span class="n">unlimited</span><span class="p">):</span> <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;level&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">0</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span> <span class="p">(</span><span class="n">unlimited</span><span class="p">):</span> <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;time&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">0</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;lat&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">73</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;lon&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">144</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span> <span class="p">(</span><span class="n">unlimited</span><span class="p">):</span> <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;time&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">0</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span> <span class="p">(</span><span class="n">unlimited</span><span class="p">):</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&quot;level&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">0</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span> <span class="p">(</span><span class="n">unlimited</span><span class="p">):</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&quot;time&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">0</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&quot;lat&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">73</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&quot;lon&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">144</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dimension&quot;</span><span class="o">&gt;</span> <span class="p">(</span><span class="n">unlimited</span><span class="p">):</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&quot;time&quot;</span><span class="p">,</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">0</span>
 </pre></div>
 
 
@@ -1581,18 +1579,18 @@ can only be used if the file format is <
 coordinate variables. The <a href="#netCDF4.Dataset.createVariable"><code>createVariable</code></a>
 method returns an instance of the <a href="#netCDF4.Variable"><code>Variable</code></a> class whose methods can be
 used later to access and set variable data and attributes.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">times</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;f8&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">levels</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;level&quot;</span><span class="p">,</span><span class="s2">&quot;i4&quot;</span><span class="p">,(</span><span class="s2">&quot;level&quot;</span><span class="p">,))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">latitudes</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span><span class="s2">&quot;f4&quot;</span><span class="p">,(</span><span class="s2">&quot;lat&quot;</span><span class="p">,))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">longitudes</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;lon&quot;</span><span class="p">,</span><span class="s2">&quot;f4&quot;</span><span class="p">,(</span><span class="s2">&quot;lon&quot;</span><span class="p">,))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># two dimensions unlimited</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;temp&quot;</span><span class="p">,</span><span class="s2">&quot;f4&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;level&quot;</span><span class="p">,</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span><span class="s2">&quot;lon&quot;</span><span class="p">,))</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">times</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;f8&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">levels</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;level&quot;</span><span class="p">,</span><span class="s">&quot;i4&quot;</span><span class="p">,(</span><span class="s">&quot;level&quot;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">latitudes</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;lat&quot;</span><span class="p">,</span><span class="s">&quot;f4&quot;</span><span class="p">,(</span><span class="s">&quot;lat&quot;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">longitudes</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;lon&quot;</span><span class="p">,</span><span class="s">&quot;f4&quot;</span><span class="p">,(</span><span class="s">&quot;lon&quot;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># two dimensions unlimited</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;temp&quot;</span><span class="p">,</span><span class="s">&quot;f4&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;level&quot;</span><span class="p">,</span><span class="s">&quot;lat&quot;</span><span class="p">,</span><span class="s">&quot;lon&quot;</span><span class="p">,))</span>
 </pre></div>
 
 
 <p>To get summary info on a <a href="#netCDF4.Variable"><code>Variable</code></a> instance in an interactive session, just print it.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">temp</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">temp</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
 <span class="n">float32</span> <span class="n">temp</span><span class="p">(</span><span class="n">time</span><span class="p">,</span> <span class="n">level</span><span class="p">,</span> <span class="n">lat</span><span class="p">,</span> <span class="n">lon</span><span class="p">)</span>
     <span class="n">least_significant_digit</span><span class="p">:</span> <span class="mi">3</span>
     <span class="n">units</span><span class="p">:</span> <span class="n">K</span>
@@ -1602,21 +1600,21 @@ used later to access and set variable da
 
 
 <p>You can use a path to create a Variable inside a hierarchy of groups.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">ftemp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;/forecasts/model1/temp&quot;</span><span class="p">,</span><span class="s2">&quot;f4&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;level&quot;</span><span class="p">,</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span><span class="s2">&quot;lon&quot;</span><span class="p">,))</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">ftemp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;/forecasts/model1/temp&quot;</span><span class="p">,</span><span class="s">&quot;f4&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;level&quot;</span><span class="p">,</span><span class="s">&quot;lat&quot;</span><span class="p">,</span><span class="s">&quot;lon&quot;</span><span class="p">,))</span>
 </pre></div>
 
 
 <p>If the intermediate groups do not yet exist, they will be created.</p>
 <p>You can also query a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> instance directly to obtain <a href="#netCDF4.Group"><code>Group</code></a> or 
 <a href="#netCDF4.Variable"><code>Variable</code></a> instances using paths.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="p">[</span><span class="s2">&quot;/forecasts/model1&quot;</span><span class="p">]</span> <span class="c1"># a Group instance</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="p">[</span><span class="s">&quot;/forecasts/model1&quot;</span><span class="p">]</span> <span class="c"># a Group instance</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Group&quot;</span><span class="o">&gt;</span>
 <span class="n">group</span> <span class="o">/</span><span class="n">forecasts</span><span class="o">/</span><span class="n">model1</span><span class="p">:</span>
     <span class="n">dimensions</span><span class="p">(</span><span class="n">sizes</span><span class="p">):</span>
     <span class="n">variables</span><span class="p">(</span><span class="n">dimensions</span><span class="p">):</span> <span class="n">float32</span> <span class="n">temp</span><span class="p">(</span><span class="n">time</span><span class="p">,</span><span class="n">level</span><span class="p">,</span><span class="n">lat</span><span class="p">,</span><span class="n">lon</span><span class="p">)</span>
     <span class="n">groups</span><span class="p">:</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="p">[</span><span class="s2">&quot;/forecasts/model1/temp&quot;</span><span class="p">]</span> <span class="c1"># a Variable instance</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="p">[</span><span class="s">&quot;/forecasts/model1/temp&quot;</span><span class="p">]</span> <span class="c"># a Variable instance</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
 <span class="n">float32</span> <span class="n">temp</span><span class="p">(</span><span class="n">time</span><span class="p">,</span> <span class="n">level</span><span class="p">,</span> <span class="n">lat</span><span class="p">,</span> <span class="n">lon</span><span class="p">)</span>
 <span class="n">path</span> <span class="o">=</span> <span class="o">/</span><span class="n">forecasts</span><span class="o">/</span><span class="n">model1</span>
 <span class="n">unlimited</span> <span class="n">dimensions</span><span class="p">:</span> <span class="n">time</span><span class="p">,</span> <span class="n">level</span>
@@ -1627,12 +1625,12 @@ used later to access and set variable da
 
 <p>All of the variables in the <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> are stored in a
 Python dictionary, in the same way as the dimensions:</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">variables</span>
-<span class="n">OrderedDict</span><span class="p">([(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4ba70</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;level&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4bab0</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4baf0</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;lon&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4bb30</span><span class="o">&gt;</span><span class="p">),</span>
-             <span class="p">(</span><span class="s2">&quot;temp&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4bb70</span><span class="o">&gt;</span><span class="p">)])</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">variables</span>
+<span class="n">OrderedDict</span><span class="p">([(</span><span class="s">&quot;time&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4ba70</span><span class="o">&gt;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">&quot;level&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4bab0</span><span class="o">&gt;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">&quot;lat&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4baf0</span><span class="o">&gt;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">&quot;lon&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4bb30</span><span class="o">&gt;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">&quot;temp&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">Variable</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1b4bb70</span><span class="o">&gt;</span><span class="p">)])</span>
 </pre></div>
 
 
@@ -1648,16 +1646,16 @@ values to <a href="#netCDF4.Dataset"><co
 attributes are set by assigning values to <a href="#netCDF4.Variable"><code>Variable</code></a> instances
 variables. Attributes can be strings, numbers or sequences. Returning to
 our example,</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">time</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">description</span> <span class="o">=</span> <span class="s2">&quot;bogus example script&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">history</span> <span class="o">=</span> <span class="s2">&quot;Created &quot;</span> <span class="o">+</span> <span class="n">time</span><span class="o">.</span><span class="n">ctime</span><span class="p">(</span><span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">())</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">source</span> <span class="o">=</span> <span class="s2">&quot;netCDF4 python module tutorial&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">latitudes</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s2">&quot;degrees north&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">longitudes</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s2">&quot;degrees east&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">levels</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s2">&quot;hPa&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s2">&quot;K&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">times</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s2">&quot;hours since 0001-01-01 00:00:00.0&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">times</span><span class="o">.</span><span class="n">calendar</span> <span class="o">=</span> <span class="s2">&quot;gregorian&quot;</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">time</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">description</span> <span class="o">=</span> <span class="s">&quot;bogus example script&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">history</span> <span class="o">=</span> <span class="s">&quot;Created &quot;</span> <span class="o">+</span> <span class="n">time</span><span class="o">.</span><span class="n">ctime</span><span class="p">(</span><span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">())</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">source</span> <span class="o">=</span> <span class="s">&quot;netCDF4 python module tutorial&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">latitudes</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s">&quot;degrees north&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">longitudes</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s">&quot;degrees east&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">levels</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s">&quot;hPa&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s">&quot;K&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">times</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s">&quot;hours since 0001-01-01 00:00:00.0&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">times</span><span class="o">.</span><span class="n">calendar</span> <span class="o">=</span> <span class="s">&quot;gregorian&quot;</span>
 </pre></div>
 
 
@@ -1666,8 +1664,8 @@ our example,</p>
 attributes. This method is provided as a convenience, since using the
 built-in <code>dir</code> Python function will return a bunch of private methods
 and attributes that cannot (or should not) be modified by the user.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">ncattrs</span><span class="p">():</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="k">print</span> <span class="s2">&quot;Global attr&quot;</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="s2">&quot;=&quot;</span><span class="p">,</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">rootgrp</span><span class="p">,</span><span class="n">name</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">ncattrs</span><span class="p">():</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="k">print</span> <span class="s">&quot;Global attr&quot;</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="s">&quot;=&quot;</span><span class="p">,</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">rootgrp</span><span class="p">,</span><span class="n">name</span><span class="p">)</span>
 <span class="n">Global</span> <span class="n">attr</span> <span class="n">description</span> <span class="o">=</span> <span class="n">bogus</span> <span class="n">example</span> <span class="n">script</span>
 <span class="n">Global</span> <span class="n">attr</span> <span class="n">history</span> <span class="o">=</span> <span class="n">Created</span> <span class="n">Mon</span> <span class="n">Nov</span>  <span class="mi">7</span> <span class="mf">10.30</span><span class="p">:</span><span class="mi">56</span> <span class="mi">2005</span>
 <span class="n">Global</span> <span class="n">attr</span> <span class="n">source</span> <span class="o">=</span> <span class="n">netCDF4</span> <span class="n">python</span> <span class="n">module</span> <span class="n">tutorial</span>
@@ -1677,10 +1675,10 @@ and attributes that cannot (or should no
 <p>The <code>__dict__</code> attribute of a <a href="#netCDF4.Dataset"><code>Dataset</code></a>, <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Variable"><code>Variable</code></a>
 instance provides all the netCDF attribute name/value pairs in a python
 dictionary:</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="vm">__dict__</span>
-<span class="n">OrderedDict</span><span class="p">([(</span><span class="sa">u</span><span class="s2">&quot;description&quot;</span><span class="p">,</span> <span class="sa">u</span><span class="s2">&quot;bogus example script&quot;</span><span class="p">),</span>
-             <span class="p">(</span><span class="sa">u</span><span class="s2">&quot;history&quot;</span><span class="p">,</span> <span class="sa">u</span><span class="s2">&quot;Created Thu Mar  3 19:30:33 2011&quot;</span><span class="p">),</span>
-             <span class="p">(</span><span class="sa">u</span><span class="s2">&quot;source&quot;</span><span class="p">,</span> <span class="sa">u</span><span class="s2">&quot;netCDF4 python module tutorial&quot;</span><span class="p">)])</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">__dict__</span>
+<span class="n">OrderedDict</span><span class="p">([(</span><span class="s">u&quot;description&quot;</span><span class="p">,</span> <span class="s">u&quot;bogus example script&quot;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">u&quot;history&quot;</span><span class="p">,</span> <span class="s">u&quot;Created Thu Mar  3 19:30:33 2011&quot;</span><span class="p">),</span>
+             <span class="p">(</span><span class="s">u&quot;source&quot;</span><span class="p">,</span> <span class="s">u&quot;netCDF4 python module tutorial&quot;</span><span class="p">)])</span>
 </pre></div>
 
 
@@ -1690,12 +1688,12 @@ removes the attribute <code>foo</code> t
 <h2><div id='section6'>6) Writing data to and retrieving data from a netCDF variable.</h2>
 <p>Now that you have a netCDF <a href="#netCDF4.Variable"><code>Variable</code></a> instance, how do you put data
 into it? You can just treat it like an array and assign data to a slice.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">numpy</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">numpy</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">lats</span> <span class="o">=</span>  <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="o">-</span><span class="mi">90</span><span class="p">,</span><span class="mi">91</span><span class="p">,</span><span class="mf">2.5</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">lons</span> <span class="o">=</span>  <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="o">-</span><span class="mi">180</span><span class="p">,</span><span class="mi">180</span><span class="p">,</span><span class="mf">2.5</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">latitudes</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">lats</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">longitudes</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">lons</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;latitudes =</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span><span class="n">latitudes</span><span class="p">[:]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;latitudes =</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span><span class="n">latitudes</span><span class="p">[:]</span>
 <span class="n">latitudes</span> <span class="o">=</span>
 <span class="p">[</span><span class="o">-</span><span class="mf">90.</span>  <span class="o">-</span><span class="mf">87.5</span> <span class="o">-</span><span class="mf">85.</span>  <span class="o">-</span><span class="mf">82.5</span> <span class="o">-</span><span class="mf">80.</span>  <span class="o">-</span><span class="mf">77.5</span> <span class="o">-</span><span class="mf">75.</span>  <span class="o">-</span><span class="mf">72.5</span> <span class="o">-</span><span class="mf">70.</span>  <span class="o">-</span><span class="mf">67.5</span> <span class="o">-</span><span class="mf">65.</span>  <span class="o">-</span><span class="mf">62.5</span>
  <span class="o">-</span><span class="mf">60.</span>  <span class="o">-</span><span class="mf">57.5</span> <span class="o">-</span><span class="mf">55.</span>  <span class="o">-</span><span class="mf">52.5</span> <span class="o">-</span><span class="mf">50.</span>  <span class="o">-</span><span class="mf">47.5</span> <span class="o">-</span><span class="mf">45.</span>  <span class="o">-</span><span class="mf">42.5</span> <span class="o">-</span><span class="mf">40.</span>  <span class="o">-</span><span class="mf">37.5</span> <span class="o">-</span><span class="mf">35.</span>  <span class="o">-</span><span class="mf">32.5</span>
@@ -1710,19 +1708,19 @@ into it? You can just treat it like an a
 <p>Unlike NumPy's array objects, netCDF <a href="#netCDF4.Variable"><code>Variable</code></a>
 objects with unlimited dimensions will grow along those dimensions if you
 assign data outside the currently defined range of indices.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># append along two unlimited dimensions by assigning to slice.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">nlats</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span><span class="p">[</span><span class="s2">&quot;lat&quot;</span><span class="p">])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">nlons</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span><span class="p">[</span><span class="s2">&quot;lon&quot;</span><span class="p">])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;temp shape before adding data = &quot;</span><span class="p">,</span><span class="n">temp</span><span class="o">.</span><span class="n">shape</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># append along two unlimited dimensions by assigning to slice.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nlats</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span><span class="p">[</span><span class="s">&quot;lat&quot;</span><span class="p">])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nlons</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">rootgrp</span><span class="o">.</span><span class="n">dimensions</span><span class="p">[</span><span class="s">&quot;lon&quot;</span><span class="p">])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;temp shape before adding data = &quot;</span><span class="p">,</span><span class="n">temp</span><span class="o">.</span><span class="n">shape</span>
 <span class="n">temp</span> <span class="n">shape</span> <span class="n">before</span> <span class="n">adding</span> <span class="n">data</span> <span class="o">=</span>  <span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">73</span><span class="p">,</span> <span class="mi">144</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">numpy.random</span> <span class="kn">import</span> <span class="n">uniform</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">5</span><span class="p">,</span><span class="mi">0</span><span class="p">:</span><span class="mi">10</span><span class="p">,:,:]</span> <span class="o">=</span> <span class="n">uniform</span><span class="p">(</span><span class="n">size</span><span class="o">=</span><span class="p">(</span><span class="mi">5</span><span class="p">,</span><span class="mi">10</span><span class="p">,</span><span class="n">nlats</span><span class="p">,</span><span class="n">nlons</span><span class="p">))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;temp shape after adding data = &quot;</span><span class="p">,</span><span class="n">temp</span><span class="o">.</span><span class="n">shape</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;temp shape after adding data = &quot;</span><span class="p">,</span><span class="n">temp</span><span class="o">.</span><span class="n">shape</span>
 <span class="n">temp</span> <span class="n">shape</span> <span class="n">after</span> <span class="n">adding</span> <span class="n">data</span> <span class="o">=</span>  <span class="p">(</span><span class="mi">6</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">73</span><span class="p">,</span> <span class="mi">144</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># levels have grown, but no values yet assigned.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;levels shape after adding pressure data = &quot;</span><span class="p">,</span><span class="n">levels</span><span class="o">.</span><span class="n">shape</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># levels have grown, but no values yet assigned.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;levels shape after adding pressure data = &quot;</span><span class="p">,</span><span class="n">levels</span><span class="o">.</span><span class="n">shape</span>
 <span class="n">levels</span> <span class="n">shape</span> <span class="n">after</span> <span class="n">adding</span> <span class="n">pressure</span> <span class="n">data</span> <span class="o">=</span>  <span class="p">(</span><span class="mi">10</span><span class="p">,)</span>
 </pre></div>
 
@@ -1730,7 +1728,7 @@ assign data outside the currently define
 <p>Note that the size of the levels variable grows when data is appended
 along the <code>level</code> dimension of the variable <code>temp</code>, even though no
 data has yet been assigned to levels.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># now, assign data to levels dimension variable.</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># now, assign data to levels dimension variable.</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">levels</span><span class="p">[:]</span> <span class="o">=</span>  <span class="p">[</span><span class="mf">1000.</span><span class="p">,</span><span class="mf">850.</span><span class="p">,</span><span class="mf">700.</span><span class="p">,</span><span class="mf">500.</span><span class="p">,</span><span class="mf">300.</span><span class="p">,</span><span class="mf">250.</span><span class="p">,</span><span class="mf">200.</span><span class="p">,</span><span class="mf">150.</span><span class="p">,</span><span class="mf">100.</span><span class="p">,</span><span class="mf">50.</span><span class="p">]</span>
 </pre></div>
 
@@ -1743,7 +1741,7 @@ integer sequence indexing behaves differ
 than for numpy arrays.  Only 1-d boolean arrays and integer sequences are
 allowed, and these indices work independently along each dimension (similar
 to the way vector subscripts work in fortran).  This means that</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">2</span><span class="p">,</span><span class="mi">3</span><span class="p">],</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">2</span><span class="p">,</span><span class="mi">3</span><span class="p">]]</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">2</span><span class="p">,</span><span class="mi">3</span><span class="p">],</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">2</span><span class="p">,</span><span class="mi">3</span><span class="p">]]</span>
 </pre></div>
 
 
@@ -1759,20 +1757,20 @@ While this behaviour may cause some conf
 it provides a very powerful way to extract data from multidimensional netCDF
 variables by using logical operations on the dimension arrays to create slices.</p>
 <p>For example,</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">tempdat</span> <span class="o">=</span> <span class="n">temp</span><span class="p">[::</span><span class="mi">2</span><span class="p">,</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span><span class="mi">3</span><span class="p">,</span><span class="mi">6</span><span class="p">],</span> <span class="n">lats</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">,</span> <span class="n">lons</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">]</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">tempdat</span> <span class="o">=</span> <span class="n">temp</span><span class="p">[::</span><span class="mi">2</span><span class="p">,</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span><span class="mi">3</span><span class="p">,</span><span class="mi">6</span><span class="p">],</span> <span class="n">lats</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">,</span> <span class="n">lons</span><span class="o">&gt;</span><span class="mi">0</span><span class="p">]</span>
 </pre></div>
 
 
 <p>will extract time indices 0,2 and 4, pressure levels
 850, 500 and 200 hPa, all Northern Hemisphere latitudes and Eastern
 Hemisphere longitudes, resulting in a numpy array of shape  (3, 3, 36, 71).</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;shape of fancy temp slice = &quot;</span><span class="p">,</span><span class="n">tempdat</span><span class="o">.</span><span class="n">shape</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;shape of fancy temp slice = &quot;</span><span class="p">,</span><span class="n">tempdat</span><span class="o">.</span><span class="n">shape</span>
 <span class="n">shape</span> <span class="n">of</span> <span class="n">fancy</span> <span class="n">temp</span> <span class="nb">slice</span> <span class="o">=</span>  <span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">36</span><span class="p">,</span> <span class="mi">71</span><span class="p">)</span>
 </pre></div>
 
 
 <p><strong><em>Special note for scalar variables</em></strong>: To extract data from a scalar variable
-<code>v</code> with no associated dimensions, use <code>np.asarray(v)</code> or <code>v[...]</code>. The result
+<code>v</code> with no associated dimensions, use <code>numpy.asarray(v)</code> or <code>v[...]</code>. The result
 will be a numpy scalar array.</p>
 <h2><div id='section7'>7) Dealing with time coordinates.</h2>
 <p>Time coordinate values pose a special challenge to netCDF users.  Most
@@ -1781,18 +1779,20 @@ measure relative to a fixed date using a
 specified like <code>hours since YY-MM-DD hh:mm:ss</code>.  These units can be
 awkward to deal with, without a utility to convert the values to and
 from calendar dates.  The function called <a href="#netCDF4.num2date"><code>num2date</code></a> and <a href="#netCDF4.date2num"><code>date2num</code></a> are
-provided with this package to do just that.  Here's an example of how they
+provided with this package to do just that (starting with version 1.4.0, the 
+<a href="https://unidata.github.io/cftime">cftime</a> package must be installed
+separately).  Here's an example of how they
 can be used:</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># fill in times.</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># fill in times.</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span><span class="p">,</span> <span class="n">timedelta</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netCDF4</span> <span class="kn">import</span> <span class="n">num2date</span><span class="p">,</span> <span class="n">date2num</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">dates</span> <span class="o">=</span> <span class="p">[</span><span class="n">datetime</span><span class="p">(</span><span class="mi">2001</span><span class="p">,</span><span class="mi">3</span><span class="p">,</span><span class="mi">1</span><span class="p">)</span><span class="o">+</span><span class="n">n</span><span class="o">*</span><span class="n">timedelta</span><span class="p">(</span><span class="n">hours</span><span class="o">=</span><span class="mi">12</span><span class="p">)</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">temp</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">])]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">times</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">date2num</span><span class="p">(</span><span class="n">dates</span><span class="p">,</span><span class="n">units</span><span class="o">=</span><span class="n">times</span><span class="o">.</span><span class="n">units</span><span class="p">,</span><span class="n">calendar</span><span class="o">=</span><span class="n">times</span><span class="o">.</span><span class="n">calendar</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;time values (in units </span><span class="si">%s</span><span class="s2">): &quot;</span> <span class="o">%</span> <span class="n">times</span><span class="o">.</span><span class="n">units</span><span class="o">+</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span><span class="n">times</span><span class="p">[:]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;time values (in units </span><span class="si">%s</span><span class="s">): &quot;</span> <span class="o">%</span> <span class="n">times</span><span class="o">.</span><span class="n">units</span><span class="o">+</span><span class="s">&quot;</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span><span class="n">times</span><span class="p">[:]</span>
 <span class="n">time</span> <span class="n">values</span> <span class="p">(</span><span class="ow">in</span> <span class="n">units</span> <span class="n">hours</span> <span class="n">since</span> <span class="n">January</span> <span class="mi">1</span><span class="p">,</span> <span class="mo">0001</span><span class="p">):</span>
 <span class="p">[</span> <span class="mf">17533056.</span>  <span class="mf">17533068.</span>  <span class="mf">17533080.</span>  <span class="mf">17533092.</span>  <span class="mf">17533104.</span><span class="p">]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">dates</span> <span class="o">=</span> <span class="n">num2date</span><span class="p">(</span><span class="n">times</span><span class="p">[:],</span><span class="n">units</span><span class="o">=</span><span class="n">times</span><span class="o">.</span><span class="n">units</span><span class="p">,</span><span class="n">calendar</span><span class="o">=</span><span class="n">times</span><span class="o">.</span><span class="n">calendar</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;dates corresponding to time values:</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span><span class="n">dates</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;dates corresponding to time values:</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span><span class="n">dates</span>
 <span class="n">dates</span> <span class="n">corresponding</span> <span class="n">to</span> <span class="n">time</span> <span class="n">values</span><span class="p">:</span>
 <span class="p">[</span><span class="mi">2001</span><span class="o">-</span><span class="mo">03</span><span class="o">-</span><span class="mo">01</span> <span class="mo">00</span><span class="p">:</span><span class="mo">00</span><span class="p">:</span><span class="mo">00</span> <span class="mi">2001</span><span class="o">-</span><span class="mo">03</span><span class="o">-</span><span class="mo">01</span> <span class="mi">12</span><span class="p">:</span><span class="mo">00</span><span class="p">:</span><span class="mo">00</span> <span class="mi">2001</span><span class="o">-</span><span class="mo">03</span><span class="o">-</span><span class="mo">02</span> <span class="mo">00</span><span class="p">:</span><span class="mo">00</span><span class="p">:</span><span class="mo">00</span>
  <span class="mi">2001</span><span class="o">-</span><span class="mo">03</span><span class="o">-</span><span class="mo">02</span> <span class="mi">12</span><span class="p">:</span><span class="mo">00</span><span class="p">:</span><span class="mo">00</span> <span class="mi">2001</span><span class="o">-</span><span class="mo">03</span><span class="o">-</span><span class="mo">03</span> <span class="mo">00</span><span class="p">:</span><span class="mo">00</span><span class="p">:</span><span class="mo">00</span><span class="p">]</span>
@@ -1819,19 +1819,19 @@ the same variable (with the same unlimit
 must in be in <code>NETCDF3_64BIT_OFFSET</code>, <code>NETCDF3_64BIT_DATA</code>, <code>NETCDF3_CLASSIC</code> or
 <code>NETCDF4_CLASSIC</code> format (<code>NETCDF4</code> formatted multi-file
 datasets are not supported).</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">nf</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;mftest</span><span class="si">%s</span><span class="s2">.nc&quot;</span> <span class="o">%</span> <span class="n">nf</span><span class="p">,</span><span class="s2">&quot;w&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;x&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="n">x</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;x&quot;</span><span class="p">,</span><span class="s2">&quot;i&quot;</span><span class="p">,(</span><span class="s2">&quot;x&quot;</span><span class="p">,))</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">nf</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;mftest</span><span class="si">%s</span><span class="s">.nc&quot;</span> <span class="o">%</span> <span class="n">nf</span><span class="p">,</span><span class="s">&quot;w&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;x&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="n">x</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;x&quot;</span><span class="p">,</span><span class="s">&quot;i&quot;</span><span class="p">,(</span><span class="s">&quot;x&quot;</span><span class="p">,))</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">10</span><span class="p">]</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="n">nf</span><span class="o">*</span><span class="mi">10</span><span class="p">,</span><span class="mi">10</span><span class="o">*</span><span class="p">(</span><span class="n">nf</span><span class="o">+</span><span class="mi">1</span><span class="p">))</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
 </pre></div>
 
 
 <p>Now read all the files back in at once with <a href="#netCDF4.MFDataset"><code>MFDataset</code></a></p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netCDF4</span> <span class="kn">import</span> <span class="n">MFDataset</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">MFDataset</span><span class="p">(</span><span class="s2">&quot;mftest*nc&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s2">&quot;x&quot;</span><span class="p">][:]</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netCDF4</span> <span class="kn">import</span> <span class="n">MFDataset</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">MFDataset</span><span class="p">(</span><span class="s">&quot;mftest*nc&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&quot;x&quot;</span><span class="p">][:]</span>
 <span class="p">[</span> <span class="mi">0</span>  <span class="mi">1</span>  <span class="mi">2</span>  <span class="mi">3</span>  <span class="mi">4</span>  <span class="mi">5</span>  <span class="mi">6</span>  <span class="mi">7</span>  <span class="mi">8</span>  <span class="mi">9</span> <span class="mi">10</span> <span class="mi">11</span> <span class="mi">12</span> <span class="mi">13</span> <span class="mi">14</span> <span class="mi">15</span> <span class="mi">16</span> <span class="mi">17</span> <span class="mi">18</span> <span class="mi">19</span> <span class="mi">20</span> <span class="mi">21</span> <span class="mi">22</span> <span class="mi">23</span> <span class="mi">24</span>
  <span class="mi">25</span> <span class="mi">26</span> <span class="mi">27</span> <span class="mi">28</span> <span class="mi">29</span> <span class="mi">30</span> <span class="mi">31</span> <span class="mi">32</span> <span class="mi">33</span> <span class="mi">34</span> <span class="mi">35</span> <span class="mi">36</span> <span class="mi">37</span> <span class="mi">38</span> <span class="mi">39</span> <span class="mi">40</span> <span class="mi">41</span> <span class="mi">42</span> <span class="mi">43</span> <span class="mi">44</span> <span class="mi">45</span> <span class="mi">46</span> <span class="mi">47</span> <span class="mi">48</span> <span class="mi">49</span>
  <span class="mi">50</span> <span class="mi">51</span> <span class="mi">52</span> <span class="mi">53</span> <span class="mi">54</span> <span class="mi">55</span> <span class="mi">56</span> <span class="mi">57</span> <span class="mi">58</span> <span class="mi">59</span> <span class="mi">60</span> <span class="mi">61</span> <span class="mi">62</span> <span class="mi">63</span> <span class="mi">64</span> <span class="mi">65</span> <span class="mi">66</span> <span class="mi">67</span> <span class="mi">68</span> <span class="mi">69</span> <span class="mi">70</span> <span class="mi">71</span> <span class="mi">72</span> <span class="mi">73</span> <span class="mi">74</span>
@@ -1877,17 +1877,17 @@ retained (in this case bits=4).  Effecti
 'lossy' instead of 'lossless', that is some precision in the data is
 sacrificed for the sake of disk space.</p>
 <p>In our example, try replacing the line</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;temp&quot;</span><span class="p">,</span><span class="s2">&quot;f4&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;level&quot;</span><span class="p">,</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span><span class="s2">&quot;lon&quot;</span><span class="p">,))</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;temp&quot;</span><span class="p">,</span><span class="s">&quot;f4&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;level&quot;</span><span class="p">,</span><span class="s">&quot;lat&quot;</span><span class="p">,</span><span class="s">&quot;lon&quot;</span><span class="p">,))</span>
 </pre></div>
 
 
 <p>with</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;temp&quot;</span><span class="p">,</span><span class="s2">&quot;f4&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;level&quot;</span><span class="p">,</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span><span class="s2">&quot;lon&quot;</span><span class="p">,),</span><span class="n">zlib</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;temp&quot;</span><span class="p">,</span><span class="s">&quot;f4&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;level&quot;</span><span class="p">,</span><span class="s">&quot;lat&quot;</span><span class="p">,</span><span class="s">&quot;lon&quot;</span><span class="p">,),</span><span class="n">zlib</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
 </pre></div>
 
 
 <p>and then</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;temp&quot;</span><span class="p">,</span><span class="s2">&quot;f4&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;level&quot;</span><span class="p">,</span><span class="s2">&quot;lat&quot;</span><span class="p">,</span><span class="s2">&quot;lon&quot;</span><span class="p">,),</span><span class="n">zlib</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span><span class="n">least_significant_digit</span><span class="o">=</span><span class="mi">3</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">temp</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;temp&quot;</span><span class="p">,</span><span class="s">&quot;f4&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;level&quot;</span><span class="p">,</span><span class="s">&quot;lat&quot;</span><span class="p">,</span><span class="s">&quot;lon&quot;</span><span class="p">,),</span><span class="n">zlib</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span><span class="n">least_significant_digit</span><span class="o">=</span><span class="mi">3</span><span class="p">)</span>
 </pre></div>
 
 
@@ -1906,31 +1906,31 @@ are created from the corresponding numpy
 <a href="#netCDF4.Dataset.createCompoundType"><code>createCompoundType</code></a> method of a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> instance.
 Since there is no native complex data type in netcdf, compound types are handy
 for storing numpy complex arrays.  Here's an example:</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;complex.nc&quot;</span><span class="p">,</span><span class="s2">&quot;w&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">3</span> <span class="c1"># length of 1-d complex array</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># create sample complex data.</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;complex.nc&quot;</span><span class="p">,</span><span class="s">&quot;w&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">size</span> <span class="o">=</span> <span class="mi">3</span> <span class="c"># length of 1-d complex array</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># create sample complex data.</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">datac</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="mi">1j</span><span class="o">*</span><span class="p">(</span><span class="mf">1.</span><span class="o">+</span><span class="n">numpy</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">numpy</span><span class="o">.</span><span class="n">pi</span><span class="p">,</span> <span class="n">size</span><span class="p">)))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># create complex128 compound data type.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">complex128</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">dtype</span><span class="p">([(</span><span class="s2">&quot;real&quot;</span><span class="p">,</span><span class="n">numpy</span><span class="o">.</span><span class="n">float64</span><span class="p">),(</span><span class="s2">&quot;imag&quot;</span><span class="p">,</span><span class="n">numpy</span><span class="o">.</span><span class="n">float64</span><span class="p">)])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">complex128_t</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createCompoundType</span><span class="p">(</span><span class="n">complex128</span><span class="p">,</span><span class="s2">&quot;complex128&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># create a variable with this data type, write some data to it.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;x_dim&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;cmplx_var&quot;</span><span class="p">,</span><span class="n">complex128_t</span><span class="p">,</span><span class="s2">&quot;x_dim&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="n">size</span><span class="p">,</span><span class="n">complex128</span><span class="p">)</span> <span class="c1"># numpy structured array</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;real&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">datac</span><span class="o">.</span><span class="n">real</span><span class="p">;</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;imag&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">datac</span><span class="o">.</span><span class="n">imag</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">data</span> <span class="c1"># write numpy structured array to netcdf compound var</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># close and reopen the file, check the contents.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span><span class="o">.</span><span class="n">close</span><span class="p">();</span> <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;complex.nc&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s2">&quot;cmplx_var&quot;</span><span class="p">]</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">datain</span> <span class="o">=</span> <span class="n">v</span><span class="p">[:]</span> <span class="c1"># read in all the data into a numpy structured array</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># create an empty numpy complex array</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># create complex128 compound data type.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">complex128</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">dtype</span><span class="p">([(</span><span class="s">&quot;real&quot;</span><span class="p">,</span><span class="n">numpy</span><span class="o">.</span><span class="n">float64</span><span class="p">),(</span><span class="s">&quot;imag&quot;</span><span class="p">,</span><span class="n">numpy</span><span class="o">.</span><span class="n">float64</span><span class="p">)])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">complex128_t</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createCompoundType</span><span class="p">(</span><span class="n">complex128</span><span class="p">,</span><span class="s">&quot;complex128&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># create a variable with this data type, write some data to it.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;x_dim&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;cmplx_var&quot;</span><span class="p">,</span><span class="n">complex128_t</span><span class="p">,</span><span class="s">&quot;x_dim&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="n">size</span><span class="p">,</span><span class="n">complex128</span><span class="p">)</span> <span class="c"># numpy structured array</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span><span class="p">[</span><span class="s">&quot;real&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">datac</span><span class="o">.</span><span class="n">real</span><span class="p">;</span> <span class="n">data</span><span class="p">[</span><span class="s">&quot;imag&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">datac</span><span class="o">.</span><span class="n">imag</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">data</span> <span class="c"># write numpy structured array to netcdf compound var</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># close and reopen the file, check the contents.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span><span class="o">.</span><span class="n">close</span><span class="p">();</span> <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;complex.nc&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&quot;cmplx_var&quot;</span><span class="p">]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">datain</span> <span class="o">=</span> <span class="n">v</span><span class="p">[:]</span> <span class="c"># read in all the data into a numpy structured array</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># create an empty numpy complex array</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">datac2</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="n">datain</span><span class="o">.</span><span class="n">shape</span><span class="p">,</span><span class="n">numpy</span><span class="o">.</span><span class="n">complex128</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># .. fill it with contents of structured array.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">datac2</span><span class="o">.</span><span class="n">real</span> <span class="o">=</span> <span class="n">datain</span><span class="p">[</span><span class="s2">&quot;real&quot;</span><span class="p">];</span> <span class="n">datac2</span><span class="o">.</span><span class="n">imag</span> <span class="o">=</span> <span class="n">datain</span><span class="p">[</span><span class="s2">&quot;imag&quot;</span><span class="p">]</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">datac</span><span class="o">.</span><span class="n">dtype</span><span class="p">,</span><span class="n">datac</span> <span class="c1"># original data</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># .. fill it with contents of structured array.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">datac2</span><span class="o">.</span><span class="n">real</span> <span class="o">=</span> <span class="n">datain</span><span class="p">[</span><span class="s">&quot;real&quot;</span><span class="p">];</span> <span class="n">datac2</span><span class="o">.</span><span class="n">imag</span> <span class="o">=</span> <span class="n">datain</span><span class="p">[</span><span class="s">&quot;imag&quot;</span><span class="p">]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">datac</span><span class="o">.</span><span class="n">dtype</span><span class="p">,</span><span class="n">datac</span> <span class="c"># original data</span>
 <span class="n">complex128</span> <span class="p">[</span> <span class="mf">0.54030231</span><span class="o">+</span><span class="mf">0.84147098j</span> <span class="o">-</span><span class="mf">0.84147098</span><span class="o">+</span><span class="mf">0.54030231j</span>  <span class="o">-</span><span class="mf">0.54030231</span><span class="o">-</span><span class="mf">0.84147098j</span><span class="p">]</span>
 <span class="o">&gt;&gt;&gt;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">datac2</span><span class="o">.</span><span class="n">dtype</span><span class="p">,</span><span class="n">datac2</span> <span class="c1"># data from file</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">datac2</span><span class="o">.</span><span class="n">dtype</span><span class="p">,</span><span class="n">datac2</span> <span class="c"># data from file</span>
 <span class="n">complex128</span> <span class="p">[</span> <span class="mf">0.54030231</span><span class="o">+</span><span class="mf">0.84147098j</span> <span class="o">-</span><span class="mf">0.84147098</span><span class="o">+</span><span class="mf">0.54030231j</span>  <span class="o">-</span><span class="mf">0.54030231</span><span class="o">-</span><span class="mf">0.84147098j</span><span class="p">]</span>
 </pre></div>
 
@@ -1942,22 +1942,22 @@ raise if you try to create one that is n
 All of the compound types defined for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> are stored 
 in a Python dictionary, just like variables and dimensions. As always, printing
 objects gives useful summary information in an interactive session:</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
 <span class="n">root</span> <span class="n">group</span> <span class="p">(</span><span class="n">NETCDF4</span> <span class="nb">file</span> <span class="n">format</span><span class="p">):</span>
     <span class="n">dimensions</span><span class="p">:</span> <span class="n">x_dim</span>
     <span class="n">variables</span><span class="p">:</span> <span class="n">cmplx_var</span>
     <span class="n">groups</span><span class="p">:</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s2">&quot;cmplx_var&quot;</span><span class="p">]</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&quot;cmplx_var&quot;</span><span class="p">]</span>
 <span class="n">compound</span> <span class="n">cmplx_var</span><span class="p">(</span><span class="n">x_dim</span><span class="p">)</span>
-<span class="n">compound</span> <span class="n">data</span> <span class="nb">type</span><span class="p">:</span> <span class="p">[(</span><span class="s2">&quot;real&quot;</span><span class="p">,</span> <span class="s2">&quot;&lt;f8&quot;</span><span class="p">),</span> <span class="p">(</span><span class="s2">&quot;imag&quot;</span><span class="p">,</span> <span class="s2">&quot;&lt;f8&quot;</span><span class="p">)]</span>
+<span class="n">compound</span> <span class="n">data</span> <span class="nb">type</span><span class="p">:</span> <span class="p">[(</span><span class="s">&quot;real&quot;</span><span class="p">,</span> <span class="s">&quot;&lt;f8&quot;</span><span class="p">),</span> <span class="p">(</span><span class="s">&quot;imag&quot;</span><span class="p">,</span> <span class="s">&quot;&lt;f8&quot;</span><span class="p">)]</span>
 <span class="n">unlimited</span> <span class="n">dimensions</span><span class="p">:</span> <span class="n">x_dim</span>
 <span class="n">current</span> <span class="n">shape</span> <span class="o">=</span> <span class="p">(</span><span class="mi">3</span><span class="p">,)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">cmptypes</span>
-<span class="n">OrderedDict</span><span class="p">([(</span><span class="s2">&quot;complex128&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">CompoundType</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1029eb7e8</span><span class="o">&gt;</span><span class="p">)])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">cmptypes</span><span class="p">[</span><span class="s2">&quot;complex128&quot;</span><span class="p">]</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.CompoundType&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;complex128&quot;</span><span class="p">,</span> <span class="n">numpy</span> <span class="n">dtype</span> <span class="o">=</span> <span class="p">[(</span><span class="sa">u</span><span class="s2">&quot;real&quot;</span><span class="p">,</span><span class="s2">&quot;&lt;f8&quot;</span><span class="p">),</span> <span class="p">(</span><span class="sa">u</span><span class="s2">&quot;imag&quot;</span><span class="p">,</span> <span class="s2">&quot;&lt;f8&quot;</span><span class="p">)]</span>
+<span class="n">OrderedDict</span><span class="p">([(</span><span class="s">&quot;complex128&quot;</span><span class="p">,</span> <span class="o">&lt;</span><span class="n">netCDF4</span><span class="o">.</span><span class="n">CompoundType</span> <span class="nb">object</span> <span class="n">at</span> <span class="mh">0x1029eb7e8</span><span class="o">&gt;</span><span class="p">)])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">cmptypes</span><span class="p">[</span><span class="s">&quot;complex128&quot;</span><span class="p">]</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.CompoundType&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&quot;complex128&quot;</span><span class="p">,</span> <span class="n">numpy</span> <span class="n">dtype</span> <span class="o">=</span> <span class="p">[(</span><span class="s">u&quot;real&quot;</span><span class="p">,</span><span class="s">&quot;&lt;f8&quot;</span><span class="p">),</span> <span class="p">(</span><span class="s">u&quot;imag&quot;</span><span class="p">,</span> <span class="s">&quot;&lt;f8&quot;</span><span class="p">)]</span>
 </pre></div>
 
 
@@ -1966,8 +1966,8 @@ objects gives useful summary information
 of variable length sequences having the same type. To create a variable-length
 data type, use the <a href="#netCDF4.Dataset.createVLType"><code>createVLType</code></a> method
 method of a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> instance.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;tst_vlen.nc&quot;</span><span class="p">,</span><span class="s2">&quot;w&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vlen_t</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVLType</span><span class="p">(</span><span class="n">numpy</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span> <span class="s2">&quot;phony_vlen&quot;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;tst_vlen.nc&quot;</span><span class="p">,</span><span class="s">&quot;w&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vlen_t</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVLType</span><span class="p">(</span><span class="n">numpy</span><span class="o">.</span><span class="n">int32</span><span class="p">,</span> <span class="s">&quot;phony_vlen&quot;</span><span class="p">)</span>
 </pre></div>
 
 
@@ -1976,9 +1976,9 @@ new datatype must be specified. Any of t
 used (signed and unsigned integers, 32 and 64 bit floats, and characters),
 but compound data types cannot.
 A new variable can then be created using this datatype.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">x</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;x&quot;</span><span class="p">,</span><span class="mi">3</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">y</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;y&quot;</span><span class="p">,</span><span class="mi">4</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vlvar</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;phony_vlen_var&quot;</span><span class="p">,</span> <span class="n">vlen_t</span><span class="p">,</span> <span class="p">(</span><span class="s2">&quot;y&quot;</span><span class="p">,</span><span class="s2">&quot;x&quot;</span><span class="p">))</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">x</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;x&quot;</span><span class="p">,</span><span class="mi">3</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">y</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;y&quot;</span><span class="p">,</span><span class="mi">4</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vlvar</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;phony_vlen_var&quot;</span><span class="p">,</span> <span class="n">vlen_t</span><span class="p">,</span> <span class="p">(</span><span class="s">&quot;y&quot;</span><span class="p">,</span><span class="s">&quot;x&quot;</span><span class="p">))</span>
 </pre></div>
 
 
@@ -1989,13 +1989,13 @@ For this application, they must contain
 but of varying length.
 In this case, they contain 1-D numpy <code>int32</code> arrays of random length between
 1 and 10.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">random</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">random</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">data</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="p">)</span><span class="o">*</span><span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="p">),</span><span class="nb">object</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="p">)</span><span class="o">*</span><span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="p">)):</span>
-<span class="o">&gt;&gt;&gt;</span>    <span class="n">data</span><span class="p">[</span><span class="n">n</span><span class="p">]</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="n">random</span><span class="o">.</span><span class="n">randint</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">10</span><span class="p">),</span><span class="n">dtype</span><span class="o">=</span><span class="s2">&quot;int32&quot;</span><span class="p">)</span><span class="o">+</span><span class="mi">1</span>
+<span class="o">&gt;&gt;&gt;</span>    <span class="n">data</span><span class="p">[</span><span class="n">n</span><span class="p">]</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="n">random</span><span class="o">.</span><span class="n">randint</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">10</span><span class="p">),</span><span class="n">dtype</span><span class="o">=</span><span class="s">&quot;int32&quot;</span><span class="p">)</span><span class="o">+</span><span class="mi">1</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">data</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">data</span><span class="p">,(</span><span class="nb">len</span><span class="p">(</span><span class="n">y</span><span class="p">),</span><span class="nb">len</span><span class="p">(</span><span class="n">x</span><span class="p">)))</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">vlvar</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">data</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;vlen variable =</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span><span class="n">vlvar</span><span class="p">[:]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;vlen variable =</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span><span class="n">vlvar</span><span class="p">[:]</span>
 <span class="n">vlen</span> <span class="n">variable</span> <span class="o">=</span>
 <span class="p">[[[</span> <span class="mi">1</span>  <span class="mi">2</span>  <span class="mi">3</span>  <span class="mi">4</span>  <span class="mi">5</span>  <span class="mi">6</span>  <span class="mi">7</span>  <span class="mi">8</span>  <span class="mi">9</span> <span class="mi">10</span><span class="p">]</span> <span class="p">[</span><span class="mi">1</span> <span class="mi">2</span> <span class="mi">3</span> <span class="mi">4</span> <span class="mi">5</span><span class="p">]</span> <span class="p">[</span><span class="mi">1</span> <span class="mi">2</span> <span class="mi">3</span> <span class="mi">4</span> <span class="mi">5</span> <span class="mi">6</span> <span class="mi">7</span> <span class="mi">8</span><span class="p">]]</span>
  <span class="p">[[</span><span class="mi">1</span> <span class="mi">2</span> <span class="mi">3</span> <span class="mi">4</span> <span class="mi">5</span> <span class="mi">6</span> <span class="mi">7</span><span class="p">]</span> <span class="p">[</span><span class="mi">1</span> <span class="mi">2</span> <span class="mi">3</span> <span class="mi">4</span> <span class="mi">5</span> <span class="mi">6</span><span class="p">]</span> <span class="p">[</span><span class="mi">1</span> <span class="mi">2</span> <span class="mi">3</span> <span class="mi">4</span> <span class="mi">5</span><span class="p">]]</span>
@@ -2003,19 +2003,19 @@ In this case, they contain 1-D numpy <co
  <span class="p">[[</span> <span class="mi">1</span>  <span class="mi">2</span>  <span class="mi">3</span>  <span class="mi">4</span>  <span class="mi">5</span>  <span class="mi">6</span>  <span class="mi">7</span>  <span class="mi">8</span>  <span class="mi">9</span> <span class="mi">10</span><span class="p">]</span> <span class="p">[</span> <span class="mi">1</span>  <span class="mi">2</span>  <span class="mi">3</span>  <span class="mi">4</span>  <span class="mi">5</span>  <span class="mi">6</span>  <span class="mi">7</span>  <span class="mi">8</span>  <span class="mi">9</span> <span class="mi">10</span><span class="p">]</span>
   <span class="p">[</span><span class="mi">1</span> <span class="mi">2</span> <span class="mi">3</span> <span class="mi">4</span> <span class="mi">5</span> <span class="mi">6</span> <span class="mi">7</span> <span class="mi">8</span><span class="p">]]]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
 <span class="n">root</span> <span class="n">group</span> <span class="p">(</span><span class="n">NETCDF4</span> <span class="nb">file</span> <span class="n">format</span><span class="p">):</span>
     <span class="n">dimensions</span><span class="p">:</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span>
     <span class="n">variables</span><span class="p">:</span> <span class="n">phony_vlen_var</span>
     <span class="n">groups</span><span class="p">:</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s2">&quot;phony_vlen_var&quot;</span><span class="p">]</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&quot;phony_vlen_var&quot;</span><span class="p">]</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
 <span class="n">vlen</span> <span class="n">phony_vlen_var</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">x</span><span class="p">)</span>
 <span class="n">vlen</span> <span class="n">data</span> <span class="nb">type</span><span class="p">:</span> <span class="n">int32</span>
 <span class="n">unlimited</span> <span class="n">dimensions</span><span class="p">:</span>
 <span class="n">current</span> <span class="n">shape</span> <span class="o">=</span> <span class="p">(</span><span class="mi">4</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">VLtypes</span><span class="p">[</span><span class="s2">&quot;phony_vlen&quot;</span><span class="p">]</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.VLType&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s2">&quot;phony_vlen&quot;</span><span class="p">,</span> <span class="n">numpy</span> <span class="n">dtype</span> <span class="o">=</span> <span class="n">int32</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">VLtypes</span><span class="p">[</span><span class="s">&quot;phony_vlen&quot;</span><span class="p">]</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.VLType&quot;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&quot;phony_vlen&quot;</span><span class="p">,</span> <span class="n">numpy</span> <span class="n">dtype</span> <span class="o">=</span> <span class="n">int32</span>
 </pre></div>
 
 
@@ -2024,33 +2024,33 @@ variables,  For vlen strings, you don't
 Instead, simply use the python <code>str</code> builtin (or a numpy string datatype
 with fixed length greater than 1) when calling the
 <a href="#netCDF4.Dataset.createVariable"><code>createVariable</code></a> method.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">z</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;z&quot;</span><span class="p">,</span><span class="mi">10</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">strvar</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;strvar&quot;</span><span class="p">,</span> <span class="nb">str</span><span class="p">,</span> <span class="s2">&quot;z&quot;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">z</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;z&quot;</span><span class="p">,</span><span class="mi">10</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">strvar</span> <span class="o">=</span> <span class="n">rootgrp</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;strvar&quot;</span><span class="p">,</span> <span class="nb">str</span><span class="p">,</span> <span class="s">&quot;z&quot;</span><span class="p">)</span>
 </pre></div>
 
 
 <p>In this example, an object array is filled with random python strings with
 random lengths between 2 and 12 characters, and the data in the object
 array is assigned to the vlen string variable.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">chars</span> <span class="o">=</span> <span class="s2">&quot;1234567890aabcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span><span class="s2">&quot;O&quot;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">chars</span> <span class="o">=</span> <span class="s">&quot;1234567890aabcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span><span class="s">&quot;O&quot;</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="n">stringlen</span> <span class="o">=</span> <span class="n">random</span><span class="o">.</span><span class="n">randint</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span><span class="mi">12</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="n">data</span><span class="p">[</span><span class="n">n</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="n">random</span><span class="o">.</span><span class="n">choice</span><span class="p">(</span><span class="n">chars</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">stringlen</span><span class="p">)])</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="n">data</span><span class="p">[</span><span class="n">n</span><span class="p">]</span> <span class="o">=</span> <span class="s">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="n">random</span><span class="o">.</span><span class="n">choice</span><span class="p">(</span><span class="n">chars</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">stringlen</span><span class="p">)])</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">strvar</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">data</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s2">&quot;variable-length string variable:</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">,</span><span class="n">strvar</span><span class="p">[:]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="s">&quot;variable-length string variable:</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span><span class="n">strvar</span><span class="p">[:]</span>
 <span class="n">variable</span><span class="o">-</span><span class="n">length</span> <span class="n">string</span> <span class="n">variable</span><span class="p">:</span>
 <span class="p">[</span><span class="n">aDy29jPt</span> <span class="mi">5</span><span class="n">DS9X8</span> <span class="n">jd7aplD</span> <span class="n">b8t4RM</span> <span class="n">jHh8hq</span> <span class="n">KtaPWF9cQj</span> <span class="n">Q1hHN5WoXSiT</span> <span class="n">MMxsVeq</span> <span class="n">tdLUzvVTzj</span><span class="p">]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Dataset&quot;</span><span class="o">&gt;</span>
 <span class="n">root</span> <span class="n">group</span> <span class="p">(</span><span class="n">NETCDF4</span> <span class="nb">file</span> <span class="n">format</span><span class="p">):</span>
     <span class="n">dimensions</span><span class="p">:</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">z</span>
     <span class="n">variables</span><span class="p">:</span> <span class="n">phony_vlen_var</span><span class="p">,</span> <span class="n">strvar</span>
     <span class="n">groups</span><span class="p">:</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s2">&quot;strvar&quot;</span><span class="p">]</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&quot;strvar&quot;</span><span class="p">]</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;netCDF4._netCDF4.Variable&quot;</span><span class="o">&gt;</span>
 <span class="n">vlen</span> <span class="n">strvar</span><span class="p">(</span><span class="n">z</span><span class="p">)</span>
-<span class="n">vlen</span> <span class="n">data</span> <span class="nb">type</span><span class="p">:</span> <span class="o">&lt;</span><span class="nb">type</span> <span class="s2">&quot;str&quot;</span><span class="o">&gt;</span>
+<span class="n">vlen</span> <span class="n">data</span> <span class="nb">type</span><span class="p">:</span> <span class="o">&lt;</span><span class="nb">type</span> <span class="s">&quot;str&quot;</span><span class="o">&gt;</span>
 <span class="n">unlimited</span> <span class="n">dimensions</span><span class="p">:</span>
 <span class="n">current</span> <span class="n">size</span> <span class="o">=</span> <span class="p">(</span><span class="mi">10</span><span class="p">,)</span>
 </pre></div>
@@ -2067,21 +2067,21 @@ a numpy data type, they are read and wri
 The base integer data type and a python dictionary describing the allowed
 values and their names are used to define an Enum data type using
 <a href="#netCDF4.Dataset.createEnumType"><code>createEnumType</code></a>.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s1">&#39;clouds.nc&#39;</span><span class="p">,</span><span class="s1">&#39;w&#39;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># python dict with allowed values and their names.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">enum_dict</span> <span class="o">=</span> <span class="p">{</span><span class="sa">u</span><span class="s1">&#39;Altocumulus&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Missing&#39;</span><span class="p">:</span> <span class="mi">255</span><span class="p">,</span> 
-<span class="o">&gt;&gt;&gt;</span> <span class="sa">u</span><span class="s1">&#39;Stratus&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Clear&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="sa">u</span><span class="s1">&#39;Nimbostratus&#39;</span><span class="p">:</span> <span class="mi">6</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Cumulus&#39;</span><span class="p">:</span> <span class="mi">4</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Altostratus&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="sa">u</span><span class="s1">&#39;Cumulonimbus&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Stratocumulus&#39;</span><span class="p">:</span> <span class="mi">3</span><span class="p">}</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># create the Enum type called &#39;cloud_t&#39;.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">cloud_type</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createEnumType</span><span class="p">(</span><span class="n">numpy</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span><span class="s1">&#39;cloud_t&#39;</span><span class="p">,</span><span class="n">enum_dict</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&#39;clouds.nc&#39;</span><span class="p">,</span><span class="s">&#39;w&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># python dict with allowed values and their names.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">enum_dict</span> <span class="o">=</span> <span class="p">{</span><span class="s">u&#39;Altocumulus&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span> <span class="s">u&#39;Missing&#39;</span><span class="p">:</span> <span class="mi">255</span><span class="p">,</span> 
+<span class="o">&gt;&gt;&gt;</span> <span class="s">u&#39;Stratus&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span> <span class="s">u&#39;Clear&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="s">u&#39;Nimbostratus&#39;</span><span class="p">:</span> <span class="mi">6</span><span class="p">,</span> <span class="s">u&#39;Cumulus&#39;</span><span class="p">:</span> <span class="mi">4</span><span class="p">,</span> <span class="s">u&#39;Altostratus&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="s">u&#39;Cumulonimbus&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="s">u&#39;Stratocumulus&#39;</span><span class="p">:</span> <span class="mi">3</span><span class="p">}</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># create the Enum type called &#39;cloud_t&#39;.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">cloud_type</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createEnumType</span><span class="p">(</span><span class="n">numpy</span><span class="o">.</span><span class="n">uint8</span><span class="p">,</span><span class="s">&#39;cloud_t&#39;</span><span class="p">,</span><span class="n">enum_dict</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">cloud_type</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s1">&#39;netCDF4._netCDF4.EnumType&#39;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;cloud_t&#39;</span><span class="p">,</span>
-<span class="n">numpy</span> <span class="n">dtype</span> <span class="o">=</span> <span class="n">uint8</span><span class="p">,</span> <span class="n">fields</span><span class="o">/</span><span class="n">values</span> <span class="o">=</span><span class="p">{</span><span class="sa">u</span><span class="s1">&#39;Cumulus&#39;</span><span class="p">:</span> <span class="mi">4</span><span class="p">,</span>
-<span class="sa">u</span><span class="s1">&#39;Altocumulus&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Missing&#39;</span><span class="p">:</span> <span class="mi">255</span><span class="p">,</span>
-<span class="sa">u</span><span class="s1">&#39;Stratus&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Clear&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
-<span class="sa">u</span><span class="s1">&#39;Cumulonimbus&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Stratocumulus&#39;</span><span class="p">:</span> <span class="mi">3</span><span class="p">,</span>
-<span class="sa">u</span><span class="s1">&#39;Nimbostratus&#39;</span><span class="p">:</span> <span class="mi">6</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Altostratus&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">}</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&#39;netCDF4._netCDF4.EnumType&#39;</span><span class="o">&gt;</span><span class="p">:</span> <span class="n">name</span> <span class="o">=</span> <span class="s">&#39;cloud_t&#39;</span><span class="p">,</span>
+<span class="n">numpy</span> <span class="n">dtype</span> <span class="o">=</span> <span class="n">uint8</span><span class="p">,</span> <span class="n">fields</span><span class="o">/</span><span class="n">values</span> <span class="o">=</span><span class="p">{</span><span class="s">u&#39;Cumulus&#39;</span><span class="p">:</span> <span class="mi">4</span><span class="p">,</span>
+<span class="s">u&#39;Altocumulus&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span> <span class="s">u&#39;Missing&#39;</span><span class="p">:</span> <span class="mi">255</span><span class="p">,</span>
+<span class="s">u&#39;Stratus&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span> <span class="s">u&#39;Clear&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span>
+<span class="s">u&#39;Cumulonimbus&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="s">u&#39;Stratocumulus&#39;</span><span class="p">:</span> <span class="mi">3</span><span class="p">,</span>
+<span class="s">u&#39;Nimbostratus&#39;</span><span class="p">:</span> <span class="mi">6</span><span class="p">,</span> <span class="s">u&#39;Altostratus&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">}</span>
 </pre></div>
 
 
@@ -2090,32 +2090,32 @@ Integer data is written to the variable
 cloud types in enum_dict. A <code>ValueError</code> will be raised if an attempt
 is made to write an integer value not associated with one of the
 specified names.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">time</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s1">&#39;time&#39;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># create a 1d variable of type &#39;cloud_type&#39;.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># The fill_value is set to the &#39;Missing&#39; named value.</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">time</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&#39;time&#39;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># create a 1d variable of type &#39;cloud_type&#39;.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># The fill_value is set to the &#39;Missing&#39; named value.</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">cloud_var</span> <span class="o">=</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s1">&#39;primary_cloud&#39;</span><span class="p">,</span><span class="n">cloud_type</span><span class="p">,</span><span class="s1">&#39;time&#39;</span><span class="p">,</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">enum_dict</span><span class="p">[</span><span class="s1">&#39;Missing&#39;</span><span class="p">])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># write some data to the variable.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">cloud_var</span><span class="p">[:]</span> <span class="o">=</span> <span class="p">[</span><span class="n">enum_dict</span><span class="p">[</span><span class="s1">&#39;Clear&#39;</span><span class="p">],</span><span class="n">enum_dict</span><span class="p">[</span><span class="s1">&#39;Stratus&#39;</span><span class="p">],</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">enum_dict</span><span class="p">[</span><span class="s1">&#39;Cumulus&#39;</span><span class="p">],</span><span class="n">enum_dict</span><span class="p">[</span><span class="s1">&#39;Missing&#39;</span><span class="p">],</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">enum_dict</span><span class="p">[</span><span class="s1">&#39;Cumulonimbus&#39;</span><span class="p">]]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&#39;primary_cloud&#39;</span><span class="p">,</span><span class="n">cloud_type</span><span class="p">,</span><span class="s">&#39;time&#39;</span><span class="p">,</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">enum_dict</span><span class="p">[</span><span class="s">&#39;Missing&#39;</span><span class="p">])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># write some data to the variable.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">cloud_var</span><span class="p">[:]</span> <span class="o">=</span> <span class="p">[</span><span class="n">enum_dict</span><span class="p">[</span><span class="s">&#39;Clear&#39;</span><span class="p">],</span><span class="n">enum_dict</span><span class="p">[</span><span class="s">&#39;Stratus&#39;</span><span class="p">],</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">enum_dict</span><span class="p">[</span><span class="s">&#39;Cumulus&#39;</span><span class="p">],</span><span class="n">enum_dict</span><span class="p">[</span><span class="s">&#39;Missing&#39;</span><span class="p">],</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">enum_dict</span><span class="p">[</span><span class="s">&#39;Cumulonimbus&#39;</span><span class="p">]]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># reopen the file, read the data.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s1">&#39;clouds.nc&#39;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">cloud_var</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;primary_cloud&#39;</span><span class="p">]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># reopen the file, read the data.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&#39;clouds.nc&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">cloud_var</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&#39;primary_cloud&#39;</span><span class="p">]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">cloud_var</span>
-<span class="o">&lt;</span><span class="nb">type</span> <span class="s1">&#39;netCDF4._netCDF4.Variable&#39;</span><span class="o">&gt;</span>
+<span class="o">&lt;</span><span class="nb">type</span> <span class="s">&#39;netCDF4._netCDF4.Variable&#39;</span><span class="o">&gt;</span>
 <span class="n">enum</span> <span class="n">primary_cloud</span><span class="p">(</span><span class="n">time</span><span class="p">)</span>
     <span class="n">_FillValue</span><span class="p">:</span> <span class="mi">255</span>
 <span class="n">enum</span> <span class="n">data</span> <span class="nb">type</span><span class="p">:</span> <span class="n">uint8</span>
 <span class="n">unlimited</span> <span class="n">dimensions</span><span class="p">:</span> <span class="n">time</span>
 <span class="n">current</span> <span class="n">shape</span> <span class="o">=</span> <span class="p">(</span><span class="mi">5</span><span class="p">,)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">cloud_var</span><span class="o">.</span><span class="n">datatype</span><span class="o">.</span><span class="n">enum_dict</span>
-<span class="p">{</span><span class="sa">u</span><span class="s1">&#39;Altocumulus&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Missing&#39;</span><span class="p">:</span> <span class="mi">255</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Stratus&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span>
-<span class="sa">u</span><span class="s1">&#39;Clear&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Nimbostratus&#39;</span><span class="p">:</span> <span class="mi">6</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Cumulus&#39;</span><span class="p">:</span> <span class="mi">4</span><span class="p">,</span>
-<span class="sa">u</span><span class="s1">&#39;Altostratus&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;Cumulonimbus&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span>
-<span class="sa">u</span><span class="s1">&#39;Stratocumulus&#39;</span><span class="p">:</span> <span class="mi">3</span><span class="p">}</span>
+<span class="p">{</span><span class="s">u&#39;Altocumulus&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">,</span> <span class="s">u&#39;Missing&#39;</span><span class="p">:</span> <span class="mi">255</span><span class="p">,</span> <span class="s">u&#39;Stratus&#39;</span><span class="p">:</span> <span class="mi">2</span><span class="p">,</span>
+<span class="s">u&#39;Clear&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="s">u&#39;Nimbostratus&#39;</span><span class="p">:</span> <span class="mi">6</span><span class="p">,</span> <span class="s">u&#39;Cumulus&#39;</span><span class="p">:</span> <span class="mi">4</span><span class="p">,</span>
+<span class="s">u&#39;Altostratus&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span> <span class="s">u&#39;Cumulonimbus&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span>
+<span class="s">u&#39;Stratocumulus&#39;</span><span class="p">:</span> <span class="mi">3</span><span class="p">}</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">cloud_var</span><span class="p">[:]</span>
 <span class="p">[</span><span class="mi">0</span> <span class="mi">2</span> <span class="mi">4</span> <span class="o">--</span> <span class="mi">1</span><span class="p">]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
@@ -2128,10 +2128,10 @@ specified names.</p>
 be built with parallel IO capabilities enabled.  To use parallel IO,
 your program must be running in an MPI environment using 
 <a href="https://mpi4py.scipy.org">mpi4py</a>.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">mpi4py</span> <span class="kn">import</span> <span class="n">MPI</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">mpi4py</span> <span class="kn">import</span> <span class="n">MPI</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="kn">from</span> <span class="nn">netCDF4</span> <span class="kn">import</span> <span class="n">Dataset</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">rank</span> <span class="o">=</span> <span class="n">MPI</span><span class="o">.</span><span class="n">COMM_WORLD</span><span class="o">.</span><span class="n">rank</span>  <span class="c1"># The process ID (integer 0-3 for 4-process run)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">rank</span> <span class="o">=</span> <span class="n">MPI</span><span class="o">.</span><span class="n">COMM_WORLD</span><span class="o">.</span><span class="n">rank</span>  <span class="c"># The process ID (integer 0-3 for 4-process run)</span>
 </pre></div>
 
 
@@ -2140,7 +2140,7 @@ parallel instances of Python (for exampl
 The parallel features of netcdf4-python are mostly transparent -
 when a new dataset is created or an existing dataset is opened,
 use the <code>parallel</code> keyword to enable parallel access.</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s1">&#39;parallel_tst.nc&#39;</span><span class="p">,</span><span class="s1">&#39;w&#39;</span><span class="p">,</span><span class="n">parallel</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&#39;parallel_tst.nc&#39;</span><span class="p">,</span><span class="s">&#39;w&#39;</span><span class="p">,</span><span class="n">parallel</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
 </pre></div>
 
 
@@ -2148,8 +2148,8 @@ use the <code>parallel</code> keyword to
 MPI communicator (<code>MPI_COMM_WORLD</code> is used by default).  Each process (or rank)
 can now write to the file indepedently.  In this example the process rank is
 written to a different variable index on each task</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="n">d</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s1">&#39;dim&#39;</span><span class="p">,</span><span class="mi">4</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s1">&#39;var&#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">int</span><span class="p">,</span> <span class="s1">&#39;dim&#39;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">d</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&#39;dim&#39;</span><span class="p">,</span><span class="mi">4</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&#39;var&#39;</span><span class="p">,</span> <span class="n">numpy</span><span class="o">.</span><span class="n">int</span><span class="p">,</span> <span class="s">&#39;dim&#39;</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="p">[</span><span class="n">rank</span><span class="p">]</span> <span class="o">=</span> <span class="n">rank</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
 
@@ -2183,6 +2183,86 @@ are collective.  There are a couple of i
    you can read it).</li>
 <li>You cannot use variable-length (VLEN) data types. </li>
 </ul>
+<h2><div id='section14'>14) Dealing with strings.</h2>
+<p>The most flexible way to store arrays of strings is with the 
+<a href="#section11">Variable-length (vlen) string data type</a>. However, this requires
+the use of the NETCDF4 data model, and the vlen type does not map very well
+numpy arrays (you have to use numpy arrays of dtype=<code>object</code>, which are arrays of
+arbitrary python objects). numpy does have a fixed-width string array
+data type, but unfortunately the netCDF data model does not.
+Instead fixed-width byte strings are typically stored as <a href="https://www.unidata.ucar.edu/software/netcdf/docs/BestPractices.html#bp_Strings-and-Variables-of-type-char">arrays of 8-bit
+characters</a>.
+To perform the conversion to and from character arrays to fixed-width numpy string arrays, the
+following convention is followed by the python interface.
+If the <code>_Encoding</code> special attribute is set for a character array
+(dtype <code>S1</code>) variable, the <a href="#netCDF4.chartostring"><code>chartostring</code></a> utility function is used to convert the array of
+characters to an array of strings with one less dimension (the last dimension is
+interpreted as the length of each string) when reading the data. The character
+set (usually ascii) is specified by the <code>_Encoding</code> attribute. If <code>_Encoding</code>
+is 'none' or 'bytes', then the character array is converted to a numpy
+fixed-width byte string array (dtype <code>S#</code>), otherwise a numpy unicode (dtype
+<code>U#</code>) array is created.  When writing the data,
+<a href="#netCDF4.stringtochar"><code>stringtochar</code></a> is used to convert the numpy string array to an array of
+characters with one more dimension. For example,</p>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&#39;stringtest.nc&#39;</span><span class="p">,</span><span class="s">&#39;w&#39;</span><span class="p">,</span><span class="n">format</span><span class="o">=</span><span class="s">&#39;NETCDF4_CLASSIC&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&#39;nchars&#39;</span><span class="p">,</span><span class="mi">3</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&#39;nstrings&#39;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&#39;strings&#39;</span><span class="p">,</span><span class="s">&#39;S1&#39;</span><span class="p">,(</span><span class="s">&#39;nstrings&#39;</span><span class="p">,</span><span class="s">&#39;nchars&#39;</span><span class="p">))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">datain</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="s">&#39;foo&#39;</span><span class="p">,</span><span class="s">&#39;bar&#39;</span><span class="p">],</span><span class="n">dtype</span><span class="o">=</span><span class="s">&#39;S3&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">stringtochar</span><span class="p">(</span><span class="n">datain</span><span class="p">)</span> <span class="c"># manual conversion to char array</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="p">[:]</span> <span class="c"># data returned as char array</span>
+<span class="p">[[</span><span class="n">b</span><span class="s">&#39;f&#39;</span> <span class="n">b</span><span class="s">&#39;o&#39;</span> <span class="n">b</span><span class="s">&#39;o&#39;</span><span class="p">]</span>
+<span class="p">[</span><span class="n">b</span><span class="s">&#39;b&#39;</span> <span class="n">b</span><span class="s">&#39;a&#39;</span> <span class="n">b</span><span class="s">&#39;r&#39;</span><span class="p">]]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="o">.</span><span class="n">_Encoding</span> <span class="o">=</span> <span class="s">&#39;ascii&#39;</span> <span class="c"># this enables automatic conversion</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">datain</span> <span class="c"># conversion to char array done internally</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">v</span><span class="p">[:]</span> <span class="c"># data returned in numpy string array</span>
+<span class="p">[</span><span class="s">&#39;foo&#39;</span> <span class="s">&#39;bar&#39;</span><span class="p">]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
+</pre></div>
+
+
+<p>Even if the <code>_Encoding</code> attribute is set, the automatic conversion of char
+arrays to/from string arrays can be disabled with
+<a href="#netCDF4.Variable.set_auto_chartostring"><code>set_auto_chartostring</code></a>. </p>
+<p>A similar situation is often encountered with numpy structured arrays with subdtypes
+containing fixed-wdith byte strings (dtype=<code>S#</code>). Since there is no native fixed-length string
+netCDF datatype, these numpy structure arrays are mapped onto netCDF compound
+types with character array elements.  In this case the string &lt;-&gt; char array
+conversion is handled automatically (without the need to set the <code>_Encoding</code>
+attribute) using <a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.ndarray.view.html">numpy
+views</a>.
+The structured array dtype (including the string elements) can even be used to
+define the compound data type - the string dtype will be converted to
+character array dtype under the hood when creating the netcdf compound type.
+Here's an example:</p>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&#39;compoundstring_example.nc&#39;</span><span class="p">,</span><span class="s">&#39;w&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">dtype</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">dtype</span><span class="p">([(</span><span class="s">&#39;observation&#39;</span><span class="p">,</span> <span class="s">&#39;f4&#39;</span><span class="p">),</span>
+                  <span class="p">(</span><span class="s">&#39;station_name&#39;</span><span class="p">,</span><span class="s">&#39;S80&#39;</span><span class="p">)])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">station_data_t</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createCompoundType</span><span class="p">(</span><span class="n">dtype</span><span class="p">,</span><span class="s">&#39;station_data&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&#39;station&#39;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&#39;station_obs&#39;</span><span class="p">,</span> <span class="n">station_data_t</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;station&#39;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">empty</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span><span class="n">dtype</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;observation&#39;</span><span class="p">][:]</span> <span class="o">=</span> <span class="p">(</span><span class="mf">123.</span><span class="p">,</span><span class="mf">3.14</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;station_name&#39;</span><span class="p">][:]</span> <span class="o">=</span> <span class="p">(</span><span class="s">&#39;Boulder&#39;</span><span class="p">,</span><span class="s">&#39;New York&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span><span class="o">.</span><span class="n">dtype</span> <span class="c"># strings actually stored as character arrays</span>
+<span class="p">{</span><span class="s">&#39;names&#39;</span><span class="p">:[</span><span class="s">&#39;observation&#39;</span><span class="p">,</span><span class="s">&#39;station_name&#39;</span><span class="p">],</span> <span class="s">&#39;formats&#39;</span><span class="p">:[</span><span class="s">&#39;&lt;f4&#39;</span><span class="p">,(</span><span class="s">&#39;S1&#39;</span><span class="p">,</span> <span class="p">(</span><span class="mi">80</span><span class="p">,))],</span> <span class="s">&#39;offsets&#39;</span><span class="p">:[</span><span class="mi">0</span><span class="p">,</span><span class="mi">4</span><span class="p">],</span> <span class="s">&#39;itemsize&#39;</span><span class="p">:</span><span class="mi">84</span><span class="p">,</span> <span class="s">&#39;aligned&#39;</span><span class="p">:</span><span class="bp">True</span><span class="p">}</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">data</span> <span class="c"># strings converted to character arrays internally</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span><span class="p">[:]</span> <span class="c"># character arrays converted back to strings</span>
+<span class="p">[(</span><span class="mf">123.</span>  <span class="p">,</span> <span class="s">&#39;Boulder&#39;</span><span class="p">)</span> <span class="p">(</span>  <span class="mf">3.14</span><span class="p">,</span> <span class="s">&#39;New York&#39;</span><span class="p">)]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span><span class="p">[:]</span><span class="o">.</span><span class="n">dtype</span>
+<span class="p">{</span><span class="s">&#39;names&#39;</span><span class="p">:[</span><span class="s">&#39;observation&#39;</span><span class="p">,</span><span class="s">&#39;station_name&#39;</span><span class="p">],</span> <span class="s">&#39;formats&#39;</span><span class="p">:[</span><span class="s">&#39;&lt;f4&#39;</span><span class="p">,</span><span class="s">&#39;S80&#39;</span><span class="p">],</span> <span class="s">&#39;offsets&#39;</span><span class="p">:[</span><span class="mi">0</span><span class="p">,</span><span class="mi">4</span><span class="p">],</span> <span class="s">&#39;itemsize&#39;</span><span class="p">:</span><span class="mi">84</span><span class="p">,</span> <span class="s">&#39;aligned&#39;</span><span class="p">:</span><span class="bp">True</span><span class="p">}</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span><span class="o">.</span><span class="n">set_auto_chartostring</span><span class="p">(</span><span class="bp">False</span><span class="p">)</span> <span class="c"># turn off auto-conversion</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="n">dtype</span><span class="o">=</span><span class="p">[(</span><span class="s">&#39;observation&#39;</span><span class="p">,</span> <span class="s">&#39;f4&#39;</span><span class="p">),(</span><span class="s">&#39;station_name&#39;</span><span class="p">,</span><span class="s">&#39;S1&#39;</span><span class="p">,</span><span class="mi">10</span><span class="p">)])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">statdat</span><span class="p">[:]</span> <span class="c"># now structured array with char array subtype is returned</span>
+<span class="p">[(</span><span class="mf">123.</span>  <span class="p">,</span> <span class="p">[</span><span class="s">&#39;B&#39;</span><span class="p">,</span> <span class="s">&#39;o&#39;</span><span class="p">,</span> <span class="s">&#39;u&#39;</span><span class="p">,</span> <span class="s">&#39;l&#39;</span><span class="p">,</span> <span class="s">&#39;d&#39;</span><span class="p">,</span> <span class="s">&#39;e&#39;</span><span class="p">,</span> <span class="s">&#39;r&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">])</span>
+<span class="p">(</span>  <span class="mf">3.14</span><span class="p">,</span> <span class="p">[</span><span class="s">&#39;N&#39;</span><span class="p">,</span> <span class="s">&#39;e&#39;</span><span class="p">,</span> <span class="s">&#39;w&#39;</span><span class="p">,</span> <span class="s">&#39; &#39;</span><span class="p">,</span> <span class="s">&#39;Y&#39;</span><span class="p">,</span> <span class="s">&#39;o&#39;</span><span class="p">,</span> <span class="s">&#39;r&#39;</span><span class="p">,</span> <span class="s">&#39;k&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">,</span> <span class="s">&#39;&#39;</span><span class="p">])]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">nc</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
+</pre></div>
+
+
+<p>Note that there is currently no support for mapping numpy structured arrays with
+unicode elements (dtype <code>U#</code>) onto netCDF compound types, nor is there support 
+for netCDF compound types with vlen string components.</p>
 <p>All of the code in this tutorial is available in <code>examples/tutorial.py</code>, except
 the parallel IO example, which is in <code>examples/mpi_example.py</code>.
 Unit tests are in the <code>test</code> directory.</p>
@@ -2222,8 +2302,9 @@ PERFORMANCE OF THIS SOFTWARE.</p>
 Will be converted to a array of strings, where each string has a fixed
 length of <code>b.shape[-1]</code> characters.</p>
 <p>optional kwarg <code>encoding</code> can be used to specify character encoding (default
-<code>utf-8</code>).</p>
-<p>returns a numpy string array with datatype <code>'UN'</code> and shape
+<code>utf-8</code>). If <code>encoding</code> is 'none' or 'bytes', a <code>numpy.string_</code> btye array is
+returned.</p>
+<p>returns a numpy string array with datatype <code>'UN'</code> (or <code>'SN'</code>) and shape
 <code>b.shape[:-1]</code> where where <code>N=b.shape[-1]</code>.</p></div>
   <div class="source_cont">
 </div>
@@ -2233,19 +2314,20 @@ length of <code>b.shape[-1]</code> chara
       
   <div class="item">
     <div class="name def" id="netCDF4.date2index">
-    <p>def <span class="ident">date2index</span>(</p><p>dates, nctime, calendar=None, select=&#39;exact&#39;)</p>
+    <p>def <span class="ident">date2index</span>(</p><p>...)</p>
     </div>
     
 
     
   
-    <div class="desc"><p>Return indices of a netCDF time variable corresponding to the given dates.</p>
+    <div class="desc"><p>date2index(dates, nctime, calendar=None, select='exact')</p>
+<p>Return indices of a netCDF time variable corresponding to the given dates.</p>
 <p><strong><code>dates</code></strong>: A datetime object or a sequence of datetime objects.
 The datetime objects should not include a time-zone offset.</p>
 <p><strong><code>nctime</code></strong>: A netCDF time variable object. The nctime object must have a
 <code>units</code> attribute.</p>
 <p><strong><code>calendar</code></strong>: describes the calendar used in the time calculations.
-All the values currently defined in the 
+All the values currently defined in the
 <a href="http://cfconventions.org">CF metadata convention</a>
 Valid calendars <code>'standard', 'gregorian', 'proleptic_gregorian'
 'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'</code>.
@@ -2268,15 +2350,16 @@ to the given datetime object(s).</p></di
       
   <div class="item">
     <div class="name def" id="netCDF4.date2num">
-    <p>def <span class="ident">date2num</span>(</p><p>dates,units,calendar=&#39;standard&#39;)</p>
+    <p>def <span class="ident">date2num</span>(</p><p>...)</p>
     </div>
     
 
     
   
-    <div class="desc"><p>Return numeric time values given datetime objects. The units
-of the numeric time values are described by the <code>netCDF4.units</code> argument
-and the <code>netCDF4.calendar</code> keyword. The datetime objects must
+    <div class="desc"><p>date2num(dates,units,calendar='standard')</p>
+<p>Return numeric time values given datetime objects. The units
+of the numeric time values are described by the <code>units</code> argument
+and the <code>calendar</code> keyword. The datetime objects must
 be in UTC with no time-zone offset.  If there is a
 time-zone offset in <code>units</code>, it will be applied to the
 returned numeric values.</p>
@@ -2285,14 +2368,14 @@ The datetime objects should not include
 <p><strong><code>units</code></strong>: a string of the form <code>&lt;time units&gt; since &lt;reference time&gt;</code>
 describing the time units. <code>&lt;time units&gt;</code> can be days, hours, minutes,
 seconds, milliseconds or microseconds. <code>&lt;reference time&gt;</code> is the time
-origin.  </p>
+origin.</p>
 <p><strong><code>calendar</code></strong>: describes the calendar used in the time calculations.
-All the values currently defined in the 
+All the values currently defined in the
 <a href="http://cfconventions.org">CF metadata convention</a>
 Valid calendars <code>'standard', 'gregorian', 'proleptic_gregorian'
 'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'</code>.
 Default is <code>'standard'</code>, which is a mixed Julian/Gregorian calendar.</p>
-<p>returns a numeric time value, or an array of numeric time values 
+<p>returns a numeric time value, or an array of numeric time values
 with approximately millisecond accuracy.</p></div>
   <div class="source_cont">
 </div>
@@ -2318,13 +2401,14 @@ used to build the module, and when it wa
       
   <div class="item">
     <div class="name def" id="netCDF4.num2date">
-    <p>def <span class="ident">num2date</span>(</p><p>times,units,calendar=&#39;standard&#39;)</p>
+    <p>def <span class="ident">num2date</span>(</p><p>...)</p>
     </div>
     
 
     
   
-    <div class="desc"><p>Return datetime objects given numeric time values. The units
+    <div class="desc"><p>num2date(times,units,calendar='standard')</p>
+<p>Return datetime objects given numeric time values. The units
 of the numeric time values are described by the <code>units</code> argument
 and the <code>calendar</code> keyword. The returned datetime objects represent
 UTC with no time-zone offset, even if the specified
@@ -2335,11 +2419,14 @@ describing the time units. <code>&lt;tim
 seconds, milliseconds or microseconds. <code>&lt;reference time&gt;</code> is the time
 origin.</p>
 <p><strong><code>calendar</code></strong>: describes the calendar used in the time calculations.
-All the values currently defined in the 
+All the values currently defined in the
 <a href="http://cfconventions.org">CF metadata convention</a>
 Valid calendars <code>'standard', 'gregorian', 'proleptic_gregorian'
 'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'</code>.
 Default is <code>'standard'</code>, which is a mixed Julian/Gregorian calendar.</p>
+<p><strong><code>only_use_cftime_datetimes</code></strong>: if False (default), datetime.datetime
+objects are returned from num2date where possible; if True dates which
+subclass cftime.datetime are returned for all calendars.</p>
 <p>returns a datetime instance, or an array of datetime instances with
 approximately millisecond accuracy.</p>
 <p><strong><em>Note</em></strong>: The datetime instances returned are 'real' python datetime
@@ -2393,7 +2480,8 @@ unicode array (dtype = <code>'U1'</code>
 is the number of characters in each string.  Will be converted to
 an array of characters (datatype <code>'S1'</code> or <code>'U1'</code>) of shape <code>a.shape + (N,)</code>.</p>
 <p>optional kwarg <code>encoding</code> can be used to specify character encoding (default
-<code>utf-8</code>).</p>
+<code>utf-8</code>). If <code>encoding</code> is 'none' or 'bytes', a <code>numpy.string_</code> the input array
+is treated a raw byte strings (<code>numpy.string_</code>).</p>
 <p>returns a numpy character array with datatype <code>'S1'</code> or <code>'U1'</code>
 and shape <code>a.shape + (N,)</code>, where N is the length of each string in a.</p></div>
   <div class="source_cont">
@@ -2423,7 +2511,7 @@ the user.</p></div>
           <h3>Ancestors (in MRO)</h3>
           <ul class="class_list">
           <li><a href="#netCDF4.CompoundType">CompoundType</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
@@ -2438,6 +2526,16 @@ the user.</p></div>
 
             </div>
             <div class="item">
+            <p id="netCDF4.CompoundType.dtype_view" class="name">var <span class="ident">dtype_view</span></p>
+            
+
+            
+  
+  <div class="source_cont">
+</div>
+
+            </div>
+            <div class="item">
             <p id="netCDF4.CompoundType.name" class="name">var <span class="ident">name</span></p>
             
 
@@ -2542,7 +2640,7 @@ references to the parent Dataset or Grou
           <h3>Ancestors (in MRO)</h3>
           <ul class="class_list">
           <li><a href="#netCDF4.Dataset">Dataset</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
@@ -3059,10 +3157,10 @@ changed using the <code>encoding</code>
     <div class="desc"><p>Returns a list of variables that match specific conditions.</p>
 <p>Can pass in key=value parameters and variables are returned that
 contain all of the matches. For example, </p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables with x-axis attribute.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="s1">&#39;X&#39;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables with matching &quot;standard_name&quot; attribute</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">standard_name</span><span class="o">=</span><span class="s1">&#39;northward_sea_water_velocity&#39;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables with x-axis attribute.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="s">&#39;X&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables with matching &quot;standard_name&quot; attribute</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">standard_name</span><span class="o">=</span><span class="s">&#39;northward_sea_water_velocity&#39;</span><span class="p">)</span>
 </pre></div>
 
 
@@ -3070,11 +3168,11 @@ contain all of the matches. For example,
 callable returns True.  The callable should accept a single parameter,
 the attribute value.  None is given as the attribute value when the
 attribute does not exist on the variable. For example,</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get Axis variables</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;X&#39;</span><span class="p">,</span> <span class="s1">&#39;Y&#39;</span><span class="p">,</span> <span class="s1">&#39;Z&#39;</span><span class="p">,</span> <span class="s1">&#39;T&#39;</span><span class="p">])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables that don&#39;t have an &quot;axis&quot; attribute</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># Get Axis variables</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">in</span> <span class="p">[</span><span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;Y&#39;</span><span class="p">,</span> <span class="s">&#39;Z&#39;</span><span class="p">,</span> <span class="s">&#39;T&#39;</span><span class="p">])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables that don&#39;t have an &quot;axis&quot; attribute</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables that have a &quot;grid_mapping&quot; attribute</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables that have a &quot;grid_mapping&quot; attribute</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">grid_mapping</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">is</span> <span class="ow">not</span> <span class="bp">None</span><span class="p">)</span>
 </pre></div></div>
   <div class="source_cont">
@@ -3341,8 +3439,7 @@ with the same name as one of the reserve
   
     <div class="desc"><p>set a netCDF dataset or group string attribute using name,value pair.
 Use if you need to ensure that a netCDF attribute is created with type
-<code>NC_STRING</code> if the file format is <code>NETCDF4</code>.
-Use if you need to set an attribute to an array of variable-length strings.</p></div>
+<code>NC_STRING</code> if the file format is <code>NETCDF4</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3407,7 +3504,7 @@ determine if the dimension is unlimited.
           <h3>Ancestors (in MRO)</h3>
           <ul class="class_list">
           <li><a href="#netCDF4.Dimension">Dimension</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
@@ -3505,7 +3602,7 @@ the user.</p></div>
           <h3>Ancestors (in MRO)</h3>
           <ul class="class_list">
           <li><a href="#netCDF4.EnumType">EnumType</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
@@ -3593,22 +3690,15 @@ to a <a href="#netCDF4.Group"><code>Grou
           <ul class="class_list">
           <li><a href="#netCDF4.Group">Group</a></li>
           <li><a href="#netCDF4.Dataset">Dataset</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
             <p id="netCDF4.Group.cmptypes" class="name">var <span class="ident">cmptypes</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.cmptypes">cmptypes</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>cmptypes</code> dictionary maps the names of
-compound types defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.CompoundType"><code>CompoundType</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3616,16 +3706,9 @@ compound types defined for the <a href="
             <div class="item">
             <p id="netCDF4.Group.data_model" class="name">var <span class="ident">data_model</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.data_model">data_model</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>data_model</code> describes the netCDF
-data model version, one of <code>NETCDF3_CLASSIC</code>, <code>NETCDF4</code>,
-<code>NETCDF4_CLASSIC</code>, <code>NETCDF3_64BIT_OFFSET</code> or <code>NETCDF3_64BIT_DATA</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3633,16 +3716,9 @@ data model version, one of <code>NETCDF3
             <div class="item">
             <p id="netCDF4.Group.dimensions" class="name">var <span class="ident">dimensions</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.dimensions">dimensions</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>dimensions</code> dictionary maps the names of
-dimensions defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.Dimension"><code>Dimension</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3650,18 +3726,9 @@ dimensions defined for the <a href="#net
             <div class="item">
             <p id="netCDF4.Group.disk_format" class="name">var <span class="ident">disk_format</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.disk_format">disk_format</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>disk_format</code> describes the underlying
-file format, one of <code>NETCDF3</code>, <code>HDF5</code>, <code>HDF4</code>,
-<code>PNETCDF</code>, <code>DAP2</code>, <code>DAP4</code> or <code>UNDEFINED</code>. Only available if using
-netcdf C library version &gt;= 4.3.1, otherwise will always return
-<code>UNDEFINED</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3669,16 +3736,9 @@ netcdf C library version &gt;= 4.3.1, ot
             <div class="item">
             <p id="netCDF4.Group.enumtypes" class="name">var <span class="ident">enumtypes</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.enumtypes">enumtypes</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>enumtypes</code> dictionary maps the names of
-Enum types defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.EnumType"><code>EnumType</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3686,14 +3746,9 @@ Enum types defined for the <a href="#net
             <div class="item">
             <p id="netCDF4.Group.file_format" class="name">var <span class="ident">file_format</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.file_format">file_format</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>same as <code>data_model</code>, retained for backwards compatibility.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3701,17 +3756,9 @@ Enum types defined for the <a href="#net
             <div class="item">
             <p id="netCDF4.Group.groups" class="name">var <span class="ident">groups</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.groups">groups</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The groups dictionary maps the names of groups created for
-this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> to instances of the <a href="#netCDF4.Group"><code>Group</code></a> class (the
-<a href="#netCDF4.Dataset"><code>Dataset</code></a> class is simply a special case of the <a href="#netCDF4.Group"><code>Group</code></a> class which
-describes the root group in the netCDF4 file).</p></div>
   <div class="source_cont">
 </div>
 
@@ -3719,15 +3766,9 @@ describes the root group in the netCDF4
             <div class="item">
             <p id="netCDF4.Group.keepweakref" class="name">var <span class="ident">keepweakref</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.keepweakref">keepweakref</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>If <code>True</code>, child Dimension and Variables objects only keep weak references to
-the parent Dataset or Group.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3746,15 +3787,9 @@ the parent Dataset or Group.</p></div>
             <div class="item">
             <p id="netCDF4.Group.parent" class="name">var <span class="ident">parent</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.parent">parent</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>parent</code> is a reference to the parent
-<a href="#netCDF4.Group"><code>Group</code></a> instance. <code>None</code> for the root group or <a href="#netCDF4.Dataset"><code>Dataset</code></a> instance</p></div>
   <div class="source_cont">
 </div>
 
@@ -3762,17 +3797,9 @@ the parent Dataset or Group.</p></div>
             <div class="item">
             <p id="netCDF4.Group.path" class="name">var <span class="ident">path</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.path">path</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>path</code> shows the location of the <a href="#netCDF4.Group"><code>Group</code></a> in
-the <a href="#netCDF4.Dataset"><code>Dataset</code></a> in a unix directory format (the names of groups in the
-hierarchy separated by backslashes). A <a href="#netCDF4.Dataset"><code>Dataset</code></a> instance is the root
-group, so the path is simply <code>'/'</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3780,16 +3807,9 @@ group, so the path is simply <code>'/'</
             <div class="item">
             <p id="netCDF4.Group.variables" class="name">var <span class="ident">variables</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.variables">variables</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>variables</code> dictionary maps the names of variables
-defined for this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> to instances of the <a href="#netCDF4.Variable"><code>Variable</code></a>
-class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3797,16 +3817,9 @@ class.</p></div>
             <div class="item">
             <p id="netCDF4.Group.vltypes" class="name">var <span class="ident">vltypes</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.vltypes">vltypes</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>vltypes</code> dictionary maps the names of
-variable-length types defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.VLType"><code>VLType</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -3843,10 +3856,6 @@ another <a href="#netCDF4.Group"><code>G
     <p>def <span class="ident">close</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.close">close</a></code>
-    </p>
 
     
   
@@ -3863,14 +3872,10 @@ instances, raises IOError.</p></div>
     <p>def <span class="ident">createCompoundType</span>(</p><p>self, datatype, datatype_name)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createCompoundType">createCompoundType</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new compound data type named <code>datatype_name</code> from the numpy
+    <div class="desc"><p>Creates a new compound data type named <code>datatype_name</code> from the numpy
 dtype object <code>datatype</code>.</p>
 <p><strong><em>Note</em></strong>: If the new compound data type contains other compound data types
 (i.e. it is a 'nested' compound type, where not all of the elements
@@ -3889,14 +3894,10 @@ datatype.</p></div>
     <p>def <span class="ident">createDimension</span>(</p><p>self, dimname, size=None)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createDimension">createDimension</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new dimension with the given <code>dimname</code> and <code>size</code>.</p>
+    <div class="desc"><p>Creates a new dimension with the given <code>dimname</code> and <code>size</code>.</p>
 <p><code>size</code> must be a positive integer or <code>None</code>, which stands for
 "unlimited" (default is <code>None</code>). Specifying a size of 0 also
 results in an unlimited dimension. The return value is the <a href="#netCDF4.Dimension"><code>Dimension</code></a>
@@ -3915,14 +3916,10 @@ instance. To determine if a dimension is
     <p>def <span class="ident">createEnumType</span>(</p><p>self, datatype, datatype_name, enum_dict)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createEnumType">createEnumType</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new Enum data type named <code>datatype_name</code> from a numpy
+    <div class="desc"><p>Creates a new Enum data type named <code>datatype_name</code> from a numpy
 integer dtype object <code>datatype</code>, and a python dictionary
 defining the enum fields and values.</p>
 <p>The return value is the <a href="#netCDF4.EnumType"><code>EnumType</code></a> class instance describing the new
@@ -3938,14 +3935,10 @@ datatype.</p></div>
     <p>def <span class="ident">createGroup</span>(</p><p>self, groupname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createGroup">createGroup</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new <a href="#netCDF4.Group"><code>Group</code></a> with the given <code>groupname</code>.</p>
+    <div class="desc"><p>Creates a new <a href="#netCDF4.Group"><code>Group</code></a> with the given <code>groupname</code>.</p>
 <p>If <code>groupname</code> is specified as a path, using forward slashes as in unix to
 separate components, then intermediate groups will be created as necessary 
 (analogous to <code>mkdir -p</code> in unix).  For example,
@@ -3965,14 +3958,10 @@ raised.</p>
     <p>def <span class="ident">createVLType</span>(</p><p>self, datatype, datatype_name)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createVLType">createVLType</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new VLEN data type named <code>datatype_name</code> from a numpy
+    <div class="desc"><p>Creates a new VLEN data type named <code>datatype_name</code> from a numpy
 dtype object <code>datatype</code>.</p>
 <p>The return value is the <a href="#netCDF4.VLType"><code>VLType</code></a> class instance describing the new
 datatype.</p></div>
@@ -3987,14 +3976,10 @@ datatype.</p></div>
     <p>def <span class="ident">createVariable</span>(</p><p>self, varname, datatype, dimensions=(), zlib=False, complevel=4, shuffle=True, fletcher32=False, contiguous=False, chunksizes=None, endian=&#39;native&#39;, least_significant_digit=None, fill_value=None)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createVariable">createVariable</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new variable with the given <code>varname</code>, <code>datatype</code>, and
+    <div class="desc"><p>Creates a new variable with the given <code>varname</code>, <code>datatype</code>, and
 <code>dimensions</code>. If dimensions are not given, the variable is assumed to be
 a scalar.</p>
 <p>If <code>varname</code> is specified as a path, using forward slashes as in unix to
@@ -4104,14 +4089,10 @@ is the number of variable dimensions.</p
     <p>def <span class="ident">delncattr</span>(</p><p>self,name,value)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.delncattr">delncattr</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>delete a netCDF dataset or group attribute.  Use if you need to delete a
+    <div class="desc"><p>delete a netCDF dataset or group attribute.  Use if you need to delete a
 netCDF attribute with the same name as one of the reserved python
 attributes.</p></div>
   <div class="source_cont">
@@ -4125,14 +4106,10 @@ attributes.</p></div>
     <p>def <span class="ident">filepath</span>(</p><p>self,encoding=None)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.filepath">filepath</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Get the file system path (or the opendap URL) which was used to
+    <div class="desc"><p>Get the file system path (or the opendap URL) which was used to
 open/create the Dataset. Requires netcdf &gt;= 4.1.2.  The path
 is decoded into a string using <code>sys.getfilesystemencoding()</code> by default, this can be
 changed using the <code>encoding</code> kwarg.</p></div>
@@ -4147,20 +4124,16 @@ changed using the <code>encoding</code>
     <p>def <span class="ident">get_variables_by_attributes</span>(</p><p>...)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.get_variables_by_attributes">get_variables_by_attributes</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Returns a list of variables that match specific conditions.</p>
+    <div class="desc"><p>Returns a list of variables that match specific conditions.</p>
 <p>Can pass in key=value parameters and variables are returned that
 contain all of the matches. For example, </p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables with x-axis attribute.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="s1">&#39;X&#39;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables with matching &quot;standard_name&quot; attribute</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">standard_name</span><span class="o">=</span><span class="s1">&#39;northward_sea_water_velocity&#39;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables with x-axis attribute.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="s">&#39;X&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables with matching &quot;standard_name&quot; attribute</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">standard_name</span><span class="o">=</span><span class="s">&#39;northward_sea_water_velocity&#39;</span><span class="p">)</span>
 </pre></div>
 
 
@@ -4168,11 +4141,11 @@ contain all of the matches. For example,
 callable returns True.  The callable should accept a single parameter,
 the attribute value.  None is given as the attribute value when the
 attribute does not exist on the variable. For example,</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get Axis variables</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;X&#39;</span><span class="p">,</span> <span class="s1">&#39;Y&#39;</span><span class="p">,</span> <span class="s1">&#39;Z&#39;</span><span class="p">,</span> <span class="s1">&#39;T&#39;</span><span class="p">])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables that don&#39;t have an &quot;axis&quot; attribute</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># Get Axis variables</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">in</span> <span class="p">[</span><span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;Y&#39;</span><span class="p">,</span> <span class="s">&#39;Z&#39;</span><span class="p">,</span> <span class="s">&#39;T&#39;</span><span class="p">])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables that don&#39;t have an &quot;axis&quot; attribute</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables that have a &quot;grid_mapping&quot; attribute</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables that have a &quot;grid_mapping&quot; attribute</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">grid_mapping</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">is</span> <span class="ow">not</span> <span class="bp">None</span><span class="p">)</span>
 </pre></div></div>
   <div class="source_cont">
@@ -4186,14 +4159,10 @@ attribute does not exist on the variable
     <p>def <span class="ident">getncattr</span>(</p><p>self,name)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.getncattr">getncattr</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>retrieve a netCDF dataset or group attribute.
+    <div class="desc"><p>retrieve a netCDF dataset or group attribute.
 Use if you need to get a netCDF attribute with the same
 name as one of the reserved python attributes.</p>
 <p>option kwarg <code>encoding</code> can be used to specify the
@@ -4209,14 +4178,10 @@ character encoding of a string attribute
     <p>def <span class="ident">isopen</span>(</p><p>...)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.isopen">isopen</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>is the Dataset open or closed?</p></div>
+    <div class="desc"><p>is the Dataset open or closed?</p></div>
   <div class="source_cont">
 </div>
 
@@ -4228,14 +4193,10 @@ character encoding of a string attribute
     <p>def <span class="ident">ncattrs</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.ncattrs">ncattrs</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>return netCDF global attribute names for this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> in a list.</p></div>
+    <div class="desc"><p>return netCDF global attribute names for this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> in a list.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4247,14 +4208,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameAttribute</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameAttribute">renameAttribute</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> attribute named <code>oldname</code> to <code>newname</code>.</p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> attribute named <code>oldname</code> to <code>newname</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4266,14 +4223,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameDimension</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameDimension">renameDimension</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Dimension"><code>Dimension</code></a> named <code>oldname</code> to <code>newname</code>.</p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Dimension"><code>Dimension</code></a> named <code>oldname</code> to <code>newname</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4285,14 +4238,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameGroup</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameGroup">renameGroup</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Group"><code>Group</code></a> named <code>oldname</code> to <code>newname</code> (requires netcdf &gt;= 4.3.1).</p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Group"><code>Group</code></a> named <code>oldname</code> to <code>newname</code> (requires netcdf &gt;= 4.3.1).</p></div>
   <div class="source_cont">
 </div>
 
@@ -4304,14 +4253,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameVariable</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameVariable">renameVariable</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Variable"><code>Variable</code></a> named <code>oldname</code> to <code>newname</code></p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Variable"><code>Variable</code></a> named <code>oldname</code> to <code>newname</code></p></div>
   <div class="source_cont">
 </div>
 
@@ -4323,14 +4268,10 @@ character encoding of a string attribute
     <p>def <span class="ident">set_auto_chartostring</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_chartostring">set_auto_chartostring</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_chartostring"><code>set_auto_chartostring</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_chartostring"><code>set_auto_chartostring</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic conversion of
 all character arrays &lt;--&gt; string arrays should be performed for 
@@ -4349,14 +4290,10 @@ after calling this function will follow
     <p>def <span class="ident">set_auto_mask</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_mask">set_auto_mask</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_mask"><code>set_auto_mask</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_mask"><code>set_auto_mask</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic conversion to masked arrays
 shall be applied for all variables.</p>
@@ -4373,14 +4310,10 @@ after calling this function will follow
     <p>def <span class="ident">set_auto_maskandscale</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_maskandscale">set_auto_maskandscale</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_maskandscale"><code>set_auto_maskandscale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_maskandscale"><code>set_auto_maskandscale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic conversion to masked arrays
 and variable scaling shall be applied for all variables.</p>
@@ -4397,14 +4330,10 @@ after calling this function will follow
     <p>def <span class="ident">set_auto_scale</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_scale">set_auto_scale</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_scale"><code>set_auto_scale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_scale"><code>set_auto_scale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic variable scaling
 shall be applied for all variables.</p>
@@ -4421,14 +4350,10 @@ after calling this function will follow
     <p>def <span class="ident">set_fill_off</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_fill_off">set_fill_off</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>off</code>.</p>
+    <div class="desc"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>off</code>.</p>
 <p>This will prevent the data from being pre-filled with fill values, which
 may result in some performance improvements. However, you must then make
 sure the data is actually written before being read.</p></div>
@@ -4443,14 +4368,10 @@ sure the data is actually written before
     <p>def <span class="ident">set_fill_on</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_fill_on">set_fill_on</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>on</code>.</p>
+    <div class="desc"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>on</code>.</p>
 <p>This causes data to be pre-filled with fill values. The fill values can be
 controlled by the variable's <code>_Fill_Value</code> attribute, but is usually
 sufficient to the use the netCDF default <code>_Fill_Value</code> (defined
@@ -4469,14 +4390,10 @@ to.</p></div>
     <p>def <span class="ident">setncattr</span>(</p><p>self,name,value)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.setncattr">setncattr</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>set a netCDF dataset or group attribute using name,value pair.
+    <div class="desc"><p>set a netCDF dataset or group attribute using name,value pair.
 Use if you need to set a netCDF attribute with the
 with the same name as one of the reserved python attributes.</p></div>
   <div class="source_cont">
@@ -4490,17 +4407,12 @@ with the same name as one of the reserve
     <p>def <span class="ident">setncattr_string</span>(</p><p>self,name,value)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.setncattr_string">setncattr_string</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>set a netCDF dataset or group string attribute using name,value pair.
+    <div class="desc"><p>set a netCDF dataset or group string attribute using name,value pair.
 Use if you need to ensure that a netCDF attribute is created with type
-<code>NC_STRING</code> if the file format is <code>NETCDF4</code>.
-Use if you need to set an attribute to an array of variable-length strings.</p></div>
+<code>NC_STRING</code> if the file format is <code>NETCDF4</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4512,14 +4424,10 @@ Use if you need to set an attribute to a
     <p>def <span class="ident">setncatts</span>(</p><p>self,attdict)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.setncatts">setncatts</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>set a bunch of netCDF dataset or group attributes at once using a python dictionary.
+    <div class="desc"><p>set a bunch of netCDF dataset or group attributes at once using a python dictionary.
 This may be faster when setting a lot of attributes for a <code>NETCDF3</code>
 formatted file, since nc_redef/nc_enddef is not called in between setting
 each attribute</p></div>
@@ -4534,14 +4442,10 @@ each attribute</p></div>
     <p>def <span class="ident">sync</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.sync">sync</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Writes all buffered data in the <a href="#netCDF4.Dataset"><code>Dataset</code></a> to the disk file.</p></div>
+    <div class="desc"><p>Writes all buffered data in the <a href="#netCDF4.Dataset"><code>Dataset</code></a> to the disk file.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4560,18 +4464,18 @@ Datasets must be in <code>NETCDF4_CLASSI
 or NETCDF3_64BIT_DATA</code> format (<code>NETCDF4</code> Datasets won't work).</p>
 <p>Adapted from <a href="http://pysclint.sourceforge.net/pycdf">pycdf</a> by Andre Gosselin.</p>
 <p>Example usage (See <a href="#netCDF4.MFDataset.__init__"><code>__init__</code></a> for more details):</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">numpy</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># create a series of netCDF files with a variable sharing</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># the same unlimited dimension.</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">numpy</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># create a series of netCDF files with a variable sharing</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># the same unlimited dimension.</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">for</span> <span class="n">nf</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;mftest</span><span class="si">%s</span><span class="s2">.nc&quot;</span> <span class="o">%</span> <span class="n">nf</span><span class="p">,</span><span class="s2">&quot;w&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;x&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span>     <span class="n">x</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;x&quot;</span><span class="p">,</span><span class="s2">&quot;i&quot;</span><span class="p">,(</span><span class="s2">&quot;x&quot;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;mftest</span><span class="si">%s</span><span class="s">.nc&quot;</span> <span class="o">%</span> <span class="n">nf</span><span class="p">,</span><span class="s">&quot;w&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;x&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span>     <span class="n">x</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;x&quot;</span><span class="p">,</span><span class="s">&quot;i&quot;</span><span class="p">,(</span><span class="s">&quot;x&quot;</span><span class="p">,))</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">10</span><span class="p">]</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="n">nf</span><span class="o">*</span><span class="mi">10</span><span class="p">,</span><span class="mi">10</span><span class="o">*</span><span class="p">(</span><span class="n">nf</span><span class="o">+</span><span class="mi">1</span><span class="p">))</span>
 <span class="o">&gt;&gt;&gt;</span>     <span class="n">f</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># now read all those files in at once, in one Dataset.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">MFDataset</span><span class="p">(</span><span class="s2">&quot;mftest*nc&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s2">&quot;x&quot;</span><span class="p">][:]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># now read all those files in at once, in one Dataset.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">MFDataset</span><span class="p">(</span><span class="s">&quot;mftest*nc&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&quot;x&quot;</span><span class="p">][:]</span>
 <span class="p">[</span> <span class="mi">0</span>  <span class="mi">1</span>  <span class="mi">2</span>  <span class="mi">3</span>  <span class="mi">4</span>  <span class="mi">5</span>  <span class="mi">6</span>  <span class="mi">7</span>  <span class="mi">8</span>  <span class="mi">9</span> <span class="mi">10</span> <span class="mi">11</span> <span class="mi">12</span> <span class="mi">13</span> <span class="mi">14</span> <span class="mi">15</span> <span class="mi">16</span> <span class="mi">17</span> <span class="mi">18</span> <span class="mi">19</span> <span class="mi">20</span> <span class="mi">21</span> <span class="mi">22</span> <span class="mi">23</span> <span class="mi">24</span>
  <span class="mi">25</span> <span class="mi">26</span> <span class="mi">27</span> <span class="mi">28</span> <span class="mi">29</span> <span class="mi">30</span> <span class="mi">31</span> <span class="mi">32</span> <span class="mi">33</span> <span class="mi">34</span> <span class="mi">35</span> <span class="mi">36</span> <span class="mi">37</span> <span class="mi">38</span> <span class="mi">39</span> <span class="mi">40</span> <span class="mi">41</span> <span class="mi">42</span> <span class="mi">43</span> <span class="mi">44</span> <span class="mi">45</span> <span class="mi">46</span> <span class="mi">47</span> <span class="mi">48</span> <span class="mi">49</span>
  <span class="mi">50</span> <span class="mi">51</span> <span class="mi">52</span> <span class="mi">53</span> <span class="mi">54</span> <span class="mi">55</span> <span class="mi">56</span> <span class="mi">57</span> <span class="mi">58</span> <span class="mi">59</span> <span class="mi">60</span> <span class="mi">61</span> <span class="mi">62</span> <span class="mi">63</span> <span class="mi">64</span> <span class="mi">65</span> <span class="mi">66</span> <span class="mi">67</span> <span class="mi">68</span> <span class="mi">69</span> <span class="mi">70</span> <span class="mi">71</span> <span class="mi">72</span> <span class="mi">73</span> <span class="mi">74</span>
@@ -4586,22 +4490,15 @@ or NETCDF3_64BIT_DATA</code> format (<co
           <ul class="class_list">
           <li><a href="#netCDF4.MFDataset">MFDataset</a></li>
           <li><a href="#netCDF4.Dataset">Dataset</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
             <p id="netCDF4.MFDataset.cmptypes" class="name">var <span class="ident">cmptypes</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.cmptypes">cmptypes</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>cmptypes</code> dictionary maps the names of
-compound types defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.CompoundType"><code>CompoundType</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4609,16 +4506,9 @@ compound types defined for the <a href="
             <div class="item">
             <p id="netCDF4.MFDataset.data_model" class="name">var <span class="ident">data_model</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.data_model">data_model</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>data_model</code> describes the netCDF
-data model version, one of <code>NETCDF3_CLASSIC</code>, <code>NETCDF4</code>,
-<code>NETCDF4_CLASSIC</code>, <code>NETCDF3_64BIT_OFFSET</code> or <code>NETCDF3_64BIT_DATA</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4626,16 +4516,9 @@ data model version, one of <code>NETCDF3
             <div class="item">
             <p id="netCDF4.MFDataset.dimensions" class="name">var <span class="ident">dimensions</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.dimensions">dimensions</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>dimensions</code> dictionary maps the names of
-dimensions defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.Dimension"><code>Dimension</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4643,18 +4526,9 @@ dimensions defined for the <a href="#net
             <div class="item">
             <p id="netCDF4.MFDataset.disk_format" class="name">var <span class="ident">disk_format</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.disk_format">disk_format</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>disk_format</code> describes the underlying
-file format, one of <code>NETCDF3</code>, <code>HDF5</code>, <code>HDF4</code>,
-<code>PNETCDF</code>, <code>DAP2</code>, <code>DAP4</code> or <code>UNDEFINED</code>. Only available if using
-netcdf C library version &gt;= 4.3.1, otherwise will always return
-<code>UNDEFINED</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4662,16 +4536,9 @@ netcdf C library version &gt;= 4.3.1, ot
             <div class="item">
             <p id="netCDF4.MFDataset.enumtypes" class="name">var <span class="ident">enumtypes</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.enumtypes">enumtypes</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>enumtypes</code> dictionary maps the names of
-Enum types defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.EnumType"><code>EnumType</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4679,14 +4546,9 @@ Enum types defined for the <a href="#net
             <div class="item">
             <p id="netCDF4.MFDataset.file_format" class="name">var <span class="ident">file_format</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.file_format">file_format</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>same as <code>data_model</code>, retained for backwards compatibility.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4694,17 +4556,9 @@ Enum types defined for the <a href="#net
             <div class="item">
             <p id="netCDF4.MFDataset.groups" class="name">var <span class="ident">groups</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.groups">groups</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The groups dictionary maps the names of groups created for
-this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> to instances of the <a href="#netCDF4.Group"><code>Group</code></a> class (the
-<a href="#netCDF4.Dataset"><code>Dataset</code></a> class is simply a special case of the <a href="#netCDF4.Group"><code>Group</code></a> class which
-describes the root group in the netCDF4 file).</p></div>
   <div class="source_cont">
 </div>
 
@@ -4712,15 +4566,9 @@ describes the root group in the netCDF4
             <div class="item">
             <p id="netCDF4.MFDataset.keepweakref" class="name">var <span class="ident">keepweakref</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.keepweakref">keepweakref</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>If <code>True</code>, child Dimension and Variables objects only keep weak references to
-the parent Dataset or Group.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4728,15 +4576,9 @@ the parent Dataset or Group.</p></div>
             <div class="item">
             <p id="netCDF4.MFDataset.parent" class="name">var <span class="ident">parent</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.parent">parent</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>parent</code> is a reference to the parent
-<a href="#netCDF4.Group"><code>Group</code></a> instance. <code>None</code> for the root group or <a href="#netCDF4.Dataset"><code>Dataset</code></a> instance</p></div>
   <div class="source_cont">
 </div>
 
@@ -4744,17 +4586,9 @@ the parent Dataset or Group.</p></div>
             <div class="item">
             <p id="netCDF4.MFDataset.path" class="name">var <span class="ident">path</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.path">path</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p><code>path</code> shows the location of the <a href="#netCDF4.Group"><code>Group</code></a> in
-the <a href="#netCDF4.Dataset"><code>Dataset</code></a> in a unix directory format (the names of groups in the
-hierarchy separated by backslashes). A <a href="#netCDF4.Dataset"><code>Dataset</code></a> instance is the root
-group, so the path is simply <code>'/'</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4762,16 +4596,9 @@ group, so the path is simply <code>'/'</
             <div class="item">
             <p id="netCDF4.MFDataset.variables" class="name">var <span class="ident">variables</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.variables">variables</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>variables</code> dictionary maps the names of variables
-defined for this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> to instances of the <a href="#netCDF4.Variable"><code>Variable</code></a>
-class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4779,16 +4606,9 @@ class.</p></div>
             <div class="item">
             <p id="netCDF4.MFDataset.vltypes" class="name">var <span class="ident">vltypes</span></p>
             
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.vltypes">vltypes</a></code>
-    </p>
 
             
   
-    <div class="desc inherited"><p>The <code>vltypes</code> dictionary maps the names of
-variable-length types defined for the <a href="#netCDF4.Group"><code>Group</code></a> or <a href="#netCDF4.Dataset"><code>Dataset</code></a> to instances of the
-<a href="#netCDF4.VLType"><code>VLType</code></a> class.</p></div>
   <div class="source_cont">
 </div>
 
@@ -4796,18 +4616,70 @@ variable-length types defined for the <a
           <h3>Static methods</h3>
             
   <div class="item">
-    <div class="name def" id="netCDF4.MFDataset.createCompoundType">
-    <p>def <span class="ident">createCompoundType</span>(</p><p>self, datatype, datatype_name)</p>
+    <div class="name def" id="netCDF4.MFDataset.__init__">
+    <p>def <span class="ident">__init__</span>(</p><p>self, files, check=False, aggdim=None, exclude=[])</p>
     </div>
     
     <p class="inheritance">
      <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createCompoundType">createCompoundType</a></code>
+       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.__init__">__init__</a></code>
     </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new compound data type named <code>datatype_name</code> from the numpy
+    <div class="desc"><p><strong><code>__init__(self, files, check=False, aggdim=None, exclude=[])</code></strong></p>
+<p>Open a Dataset spanning multiple files, making it look as if it was a
+single file. Variables in the list of files that share the same
+dimension (specified with the keyword <code>aggdim</code>) are aggregated. If
+<code>aggdim</code> is not specified, the unlimited is aggregated.  Currently,
+<code>aggdim</code> must be the leftmost (slowest varying) dimension of each
+of the variables to be aggregated.</p>
+<p><strong><code>files</code></strong>: either a sequence of netCDF files or a string with a
+wildcard (converted to a sorted list of files using glob)  The first file
+in the list will become the "master" file, defining all the
+variables with an aggregation dimension which may span
+subsequent files. Attribute access returns attributes only from "master"
+file. The files are always opened in read-only mode.</p>
+<p><strong><code>check</code></strong>: True if you want to do consistency checking to ensure the
+correct variables structure for all of the netcdf files.  Checking makes
+the initialization of the MFDataset instance much slower. Default is
+False.</p>
+<p><strong><code>aggdim</code></strong>: The name of the dimension to aggregate over (must
+be the leftmost dimension of each of the variables to be aggregated).
+If None (default), aggregate over the unlimited dimension.</p>
+<p><strong><code>exclude</code></strong>: A list of variable names to exclude from aggregation.
+Default is an empty list.</p></div>
+  <div class="source_cont">
+</div>
+
+  </div>
+  
+            
+  <div class="item">
+    <div class="name def" id="netCDF4.MFDataset.close">
+    <p>def <span class="ident">close</span>(</p><p>self)</p>
+    </div>
+    
+
+    
+  
+    <div class="desc"><p><strong><code>close(self)</code></strong></p>
+<p>close all the open files.</p></div>
+  <div class="source_cont">
+</div>
+
+  </div>
+  
+            
+  <div class="item">
+    <div class="name def" id="netCDF4.MFDataset.createCompoundType">
+    <p>def <span class="ident">createCompoundType</span>(</p><p>self, datatype, datatype_name)</p>
+    </div>
+    
+
+    
+  
+    <div class="desc"><p>Creates a new compound data type named <code>datatype_name</code> from the numpy
 dtype object <code>datatype</code>.</p>
 <p><strong><em>Note</em></strong>: If the new compound data type contains other compound data types
 (i.e. it is a 'nested' compound type, where not all of the elements
@@ -4826,14 +4698,10 @@ datatype.</p></div>
     <p>def <span class="ident">createDimension</span>(</p><p>self, dimname, size=None)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createDimension">createDimension</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new dimension with the given <code>dimname</code> and <code>size</code>.</p>
+    <div class="desc"><p>Creates a new dimension with the given <code>dimname</code> and <code>size</code>.</p>
 <p><code>size</code> must be a positive integer or <code>None</code>, which stands for
 "unlimited" (default is <code>None</code>). Specifying a size of 0 also
 results in an unlimited dimension. The return value is the <a href="#netCDF4.Dimension"><code>Dimension</code></a>
@@ -4852,14 +4720,10 @@ instance. To determine if a dimension is
     <p>def <span class="ident">createEnumType</span>(</p><p>self, datatype, datatype_name, enum_dict)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createEnumType">createEnumType</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new Enum data type named <code>datatype_name</code> from a numpy
+    <div class="desc"><p>Creates a new Enum data type named <code>datatype_name</code> from a numpy
 integer dtype object <code>datatype</code>, and a python dictionary
 defining the enum fields and values.</p>
 <p>The return value is the <a href="#netCDF4.EnumType"><code>EnumType</code></a> class instance describing the new
@@ -4875,14 +4739,10 @@ datatype.</p></div>
     <p>def <span class="ident">createGroup</span>(</p><p>self, groupname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createGroup">createGroup</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new <a href="#netCDF4.Group"><code>Group</code></a> with the given <code>groupname</code>.</p>
+    <div class="desc"><p>Creates a new <a href="#netCDF4.Group"><code>Group</code></a> with the given <code>groupname</code>.</p>
 <p>If <code>groupname</code> is specified as a path, using forward slashes as in unix to
 separate components, then intermediate groups will be created as necessary 
 (analogous to <code>mkdir -p</code> in unix).  For example,
@@ -4902,14 +4762,10 @@ raised.</p>
     <p>def <span class="ident">createVLType</span>(</p><p>self, datatype, datatype_name)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createVLType">createVLType</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new VLEN data type named <code>datatype_name</code> from a numpy
+    <div class="desc"><p>Creates a new VLEN data type named <code>datatype_name</code> from a numpy
 dtype object <code>datatype</code>.</p>
 <p>The return value is the <a href="#netCDF4.VLType"><code>VLType</code></a> class instance describing the new
 datatype.</p></div>
@@ -4924,14 +4780,10 @@ datatype.</p></div>
     <p>def <span class="ident">createVariable</span>(</p><p>self, varname, datatype, dimensions=(), zlib=False, complevel=4, shuffle=True, fletcher32=False, contiguous=False, chunksizes=None, endian=&#39;native&#39;, least_significant_digit=None, fill_value=None)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.createVariable">createVariable</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Creates a new variable with the given <code>varname</code>, <code>datatype</code>, and
+    <div class="desc"><p>Creates a new variable with the given <code>varname</code>, <code>datatype</code>, and
 <code>dimensions</code>. If dimensions are not given, the variable is assumed to be
 a scalar.</p>
 <p>If <code>varname</code> is specified as a path, using forward slashes as in unix to
@@ -5041,14 +4893,10 @@ is the number of variable dimensions.</p
     <p>def <span class="ident">delncattr</span>(</p><p>self,name,value)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.delncattr">delncattr</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>delete a netCDF dataset or group attribute.  Use if you need to delete a
+    <div class="desc"><p>delete a netCDF dataset or group attribute.  Use if you need to delete a
 netCDF attribute with the same name as one of the reserved python
 attributes.</p></div>
   <div class="source_cont">
@@ -5062,14 +4910,10 @@ attributes.</p></div>
     <p>def <span class="ident">filepath</span>(</p><p>self,encoding=None)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.filepath">filepath</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Get the file system path (or the opendap URL) which was used to
+    <div class="desc"><p>Get the file system path (or the opendap URL) which was used to
 open/create the Dataset. Requires netcdf &gt;= 4.1.2.  The path
 is decoded into a string using <code>sys.getfilesystemencoding()</code> by default, this can be
 changed using the <code>encoding</code> kwarg.</p></div>
@@ -5084,20 +4928,16 @@ changed using the <code>encoding</code>
     <p>def <span class="ident">get_variables_by_attributes</span>(</p><p>...)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.get_variables_by_attributes">get_variables_by_attributes</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Returns a list of variables that match specific conditions.</p>
+    <div class="desc"><p>Returns a list of variables that match specific conditions.</p>
 <p>Can pass in key=value parameters and variables are returned that
 contain all of the matches. For example, </p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables with x-axis attribute.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="s1">&#39;X&#39;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables with matching &quot;standard_name&quot; attribute</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">standard_name</span><span class="o">=</span><span class="s1">&#39;northward_sea_water_velocity&#39;</span><span class="p">)</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables with x-axis attribute.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="s">&#39;X&#39;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables with matching &quot;standard_name&quot; attribute</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">standard_name</span><span class="o">=</span><span class="s">&#39;northward_sea_water_velocity&#39;</span><span class="p">)</span>
 </pre></div>
 
 
@@ -5105,11 +4945,11 @@ contain all of the matches. For example,
 callable returns True.  The callable should accept a single parameter,
 the attribute value.  None is given as the attribute value when the
 attribute does not exist on the variable. For example,</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get Axis variables</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;X&#39;</span><span class="p">,</span> <span class="s1">&#39;Y&#39;</span><span class="p">,</span> <span class="s1">&#39;Z&#39;</span><span class="p">,</span> <span class="s1">&#39;T&#39;</span><span class="p">])</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables that don&#39;t have an &quot;axis&quot; attribute</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="c"># Get Axis variables</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">in</span> <span class="p">[</span><span class="s">&#39;X&#39;</span><span class="p">,</span> <span class="s">&#39;Y&#39;</span><span class="p">,</span> <span class="s">&#39;Z&#39;</span><span class="p">,</span> <span class="s">&#39;T&#39;</span><span class="p">])</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables that don&#39;t have an &quot;axis&quot; attribute</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Get variables that have a &quot;grid_mapping&quot; attribute</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Get variables that have a &quot;grid_mapping&quot; attribute</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">vs</span> <span class="o">=</span> <span class="n">nc</span><span class="o">.</span><span class="n">get_variables_by_attributes</span><span class="p">(</span><span class="n">grid_mapping</span><span class="o">=</span><span class="k">lambda</span> <span class="n">v</span><span class="p">:</span> <span class="n">v</span> <span class="ow">is</span> <span class="ow">not</span> <span class="bp">None</span><span class="p">)</span>
 </pre></div></div>
   <div class="source_cont">
@@ -5123,14 +4963,10 @@ attribute does not exist on the variable
     <p>def <span class="ident">getncattr</span>(</p><p>self,name)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.getncattr">getncattr</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>retrieve a netCDF dataset or group attribute.
+    <div class="desc"><p>retrieve a netCDF dataset or group attribute.
 Use if you need to get a netCDF attribute with the same
 name as one of the reserved python attributes.</p>
 <p>option kwarg <code>encoding</code> can be used to specify the
@@ -5146,14 +4982,26 @@ character encoding of a string attribute
     <p>def <span class="ident">isopen</span>(</p><p>...)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.isopen">isopen</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>is the Dataset open or closed?</p></div>
+    <div class="desc"><p>is the Dataset open or closed?</p></div>
+  <div class="source_cont">
+</div>
+
+  </div>
+  
+            
+  <div class="item">
+    <div class="name def" id="netCDF4.MFDataset.ncattrs">
+    <p>def <span class="ident">ncattrs</span>(</p><p>self)</p>
+    </div>
+    
+
+    
+  
+    <div class="desc"><p><strong><code>ncattrs(self)</code></strong></p>
+<p>return the netcdf attribute names from the master file.</p></div>
   <div class="source_cont">
 </div>
 
@@ -5165,14 +5013,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameAttribute</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameAttribute">renameAttribute</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> attribute named <code>oldname</code> to <code>newname</code>.</p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Dataset"><code>Dataset</code></a> or <a href="#netCDF4.Group"><code>Group</code></a> attribute named <code>oldname</code> to <code>newname</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -5184,14 +5028,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameDimension</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameDimension">renameDimension</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Dimension"><code>Dimension</code></a> named <code>oldname</code> to <code>newname</code>.</p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Dimension"><code>Dimension</code></a> named <code>oldname</code> to <code>newname</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -5203,14 +5043,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameGroup</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameGroup">renameGroup</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Group"><code>Group</code></a> named <code>oldname</code> to <code>newname</code> (requires netcdf &gt;= 4.3.1).</p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Group"><code>Group</code></a> named <code>oldname</code> to <code>newname</code> (requires netcdf &gt;= 4.3.1).</p></div>
   <div class="source_cont">
 </div>
 
@@ -5222,14 +5058,10 @@ character encoding of a string attribute
     <p>def <span class="ident">renameVariable</span>(</p><p>self, oldname, newname)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.renameVariable">renameVariable</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>rename a <a href="#netCDF4.Variable"><code>Variable</code></a> named <code>oldname</code> to <code>newname</code></p></div>
+    <div class="desc"><p>rename a <a href="#netCDF4.Variable"><code>Variable</code></a> named <code>oldname</code> to <code>newname</code></p></div>
   <div class="source_cont">
 </div>
 
@@ -5241,14 +5073,10 @@ character encoding of a string attribute
     <p>def <span class="ident">set_auto_chartostring</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_chartostring">set_auto_chartostring</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_chartostring"><code>set_auto_chartostring</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_chartostring"><code>set_auto_chartostring</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic conversion of
 all character arrays &lt;--&gt; string arrays should be performed for 
@@ -5267,14 +5095,10 @@ after calling this function will follow
     <p>def <span class="ident">set_auto_mask</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_mask">set_auto_mask</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_mask"><code>set_auto_mask</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_mask"><code>set_auto_mask</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic conversion to masked arrays
 shall be applied for all variables.</p>
@@ -5291,14 +5115,10 @@ after calling this function will follow
     <p>def <span class="ident">set_auto_maskandscale</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_maskandscale">set_auto_maskandscale</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_maskandscale"><code>set_auto_maskandscale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_maskandscale"><code>set_auto_maskandscale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic conversion to masked arrays
 and variable scaling shall be applied for all variables.</p>
@@ -5315,14 +5135,10 @@ after calling this function will follow
     <p>def <span class="ident">set_auto_scale</span>(</p><p>self, True_or_False)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_auto_scale">set_auto_scale</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Call <a href="#netCDF4.Variable.set_auto_scale"><code>set_auto_scale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
+    <div class="desc"><p>Call <a href="#netCDF4.Variable.set_auto_scale"><code>set_auto_scale</code></a> for all variables contained in this <a href="#netCDF4.Dataset"><code>Dataset</code></a> or
 <a href="#netCDF4.Group"><code>Group</code></a>, as well as for all variables in all its subgroups.</p>
 <p><strong><code>True_or_False</code></strong>: Boolean determining if automatic variable scaling
 shall be applied for all variables.</p>
@@ -5339,14 +5155,10 @@ after calling this function will follow
     <p>def <span class="ident">set_fill_off</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_fill_off">set_fill_off</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>off</code>.</p>
+    <div class="desc"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>off</code>.</p>
 <p>This will prevent the data from being pre-filled with fill values, which
 may result in some performance improvements. However, you must then make
 sure the data is actually written before being read.</p></div>
@@ -5361,14 +5173,10 @@ sure the data is actually written before
     <p>def <span class="ident">set_fill_on</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.set_fill_on">set_fill_on</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>on</code>.</p>
+    <div class="desc"><p>Sets the fill mode for a <a href="#netCDF4.Dataset"><code>Dataset</code></a> open for writing to <code>on</code>.</p>
 <p>This causes data to be pre-filled with fill values. The fill values can be
 controlled by the variable's <code>_Fill_Value</code> attribute, but is usually
 sufficient to the use the netCDF default <code>_Fill_Value</code> (defined
@@ -5387,14 +5195,10 @@ to.</p></div>
     <p>def <span class="ident">setncattr</span>(</p><p>self,name,value)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.setncattr">setncattr</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>set a netCDF dataset or group attribute using name,value pair.
+    <div class="desc"><p>set a netCDF dataset or group attribute using name,value pair.
 Use if you need to set a netCDF attribute with the
 with the same name as one of the reserved python attributes.</p></div>
   <div class="source_cont">
@@ -5408,17 +5212,12 @@ with the same name as one of the reserve
     <p>def <span class="ident">setncattr_string</span>(</p><p>self,name,value)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.setncattr_string">setncattr_string</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>set a netCDF dataset or group string attribute using name,value pair.
+    <div class="desc"><p>set a netCDF dataset or group string attribute using name,value pair.
 Use if you need to ensure that a netCDF attribute is created with type
-<code>NC_STRING</code> if the file format is <code>NETCDF4</code>.
-Use if you need to set an attribute to an array of variable-length strings.</p></div>
+<code>NC_STRING</code> if the file format is <code>NETCDF4</code>.</p></div>
   <div class="source_cont">
 </div>
 
@@ -5430,14 +5229,10 @@ Use if you need to set an attribute to a
     <p>def <span class="ident">setncatts</span>(</p><p>self,attdict)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.setncatts">setncatts</a></code>
-    </p>
 
     
   
-    <div class="desc inherited"><p>set a bunch of netCDF dataset or group attributes at once using a python dictionary.
+    <div class="desc"><p>set a bunch of netCDF dataset or group attributes at once using a python dictionary.
 This may be faster when setting a lot of attributes for a <code>NETCDF3</code>
 formatted file, since nc_redef/nc_enddef is not called in between setting
 each attribute</p></div>
@@ -5452,92 +5247,10 @@ each attribute</p></div>
     <p>def <span class="ident">sync</span>(</p><p>self)</p>
     </div>
     
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.sync">sync</a></code>
-    </p>
-
-    
-  
-    <div class="desc inherited"><p>Writes all buffered data in the <a href="#netCDF4.Dataset"><code>Dataset</code></a> to the disk file.</p></div>
-  <div class="source_cont">
-</div>
-
-  </div>
-  
-          <h3>Methods</h3>
-            
-  <div class="item">
-    <div class="name def" id="netCDF4.MFDataset.__init__">
-    <p>def <span class="ident">__init__</span>(</p><p>self, files, check=False, aggdim=None, exclude=[])</p>
-    </div>
-    
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.__init__">__init__</a></code>
-    </p>
-
-    
-  
-    <div class="desc"><p>Open a Dataset spanning multiple files, making it look as if it was a
-single file. Variables in the list of files that share the same
-dimension (specified with the keyword <code>aggdim</code>) are aggregated. If
-<code>aggdim</code> is not specified, the unlimited is aggregated.  Currently,
-<code>aggdim</code> must be the leftmost (slowest varying) dimension of each
-of the variables to be aggregated.</p>
-<p><strong><code>files</code></strong>: either a sequence of netCDF files or a string with a
-wildcard (converted to a sorted list of files using glob)  The first file
-in the list will become the "master" file, defining all the
-variables with an aggregation dimension which may span
-subsequent files. Attribute access returns attributes only from "master"
-file. The files are always opened in read-only mode.</p>
-<p><strong><code>check</code></strong>: True if you want to do consistency checking to ensure the
-correct variables structure for all of the netcdf files.  Checking makes
-the initialization of the MFDataset instance much slower. Default is
-False.</p>
-<p><strong><code>aggdim</code></strong>: The name of the dimension to aggregate over (must
-be the leftmost dimension of each of the variables to be aggregated).
-If None (default), aggregate over the unlimited dimension.</p>
-<p><strong><code>exclude</code></strong>: A list of variable names to exclude from aggregation.
-Default is an empty list.</p></div>
-  <div class="source_cont">
-</div>
-
-  </div>
-  
-            
-  <div class="item">
-    <div class="name def" id="netCDF4.MFDataset.close">
-    <p>def <span class="ident">close</span>(</p><p>self)</p>
-    </div>
-    
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.close">close</a></code>
-    </p>
 
     
   
-    <div class="desc"><p>close all the open files.</p></div>
-  <div class="source_cont">
-</div>
-
-  </div>
-  
-            
-  <div class="item">
-    <div class="name def" id="netCDF4.MFDataset.ncattrs">
-    <p>def <span class="ident">ncattrs</span>(</p><p>self)</p>
-    </div>
-    
-    <p class="inheritance">
-     <strong>Inheritance:</strong>
-       <code><a href="#netCDF4.Dataset">Dataset</a></code>.<code><a href="#netCDF4.Dataset.ncattrs">ncattrs</a></code>
-    </p>
-
-    
-  
-    <div class="desc"><p>return the netcdf attribute names from the master file.</p></div>
+    <div class="desc"><p>Writes all buffered data in the <a href="#netCDF4.Dataset"><code>Dataset</code></a> to the disk file.</p></div>
   <div class="source_cont">
 </div>
 
@@ -5551,29 +5264,29 @@ Default is an empty list.</p></div>
       
   
     <div class="desc"><p>Class providing an interface to a MFDataset time Variable by imposing a unique common
-time unit to all files. </p>
+time unit and/or calendar to all files.</p>
 <p>Example usage (See <a href="#netCDF4.MFTime.__init__"><code>__init__</code></a> for more details):</p>
-<div class="codehilite"><pre><span></span><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">numpy</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f1</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;mftest_1.nc&quot;</span><span class="p">,</span><span class="s2">&quot;w&quot;</span><span class="p">,</span> <span class="n">format</span><span class="o">=</span><span class="s2">&quot;NETCDF4_CLASSIC&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f2</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s2">&quot;mftest_2.nc&quot;</span><span class="p">,</span><span class="s2">&quot;w&quot;</span><span class="p">,</span> <span class="n">format</span><span class="o">=</span><span class="s2">&quot;NETCDF4_CLASSIC&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f1</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f2</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">t1</span> <span class="o">=</span> <span class="n">f1</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;i&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">t2</span> <span class="o">=</span> <span class="n">f2</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">,</span><span class="s2">&quot;i&quot;</span><span class="p">,(</span><span class="s2">&quot;time&quot;</span><span class="p">,))</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">t1</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s2">&quot;days since 2000-01-01&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">t2</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s2">&quot;days since 2000-02-01&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">t1</span><span class="o">.</span><span class="n">calendar</span> <span class="o">=</span> <span class="s2">&quot;standard&quot;</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">t2</span><span class="o">.</span><span class="n">calendar</span> <span class="o">=</span> <span class="s2">&quot;standard&quot;</span>
+<div class="codehilite"><pre><span class="o">&gt;&gt;&gt;</span> <span class="kn">import</span> <span class="nn">numpy</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f1</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;mftest_1.nc&quot;</span><span class="p">,</span><span class="s">&quot;w&quot;</span><span class="p">,</span> <span class="n">format</span><span class="o">=</span><span class="s">&quot;NETCDF4_CLASSIC&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f2</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="s">&quot;mftest_2.nc&quot;</span><span class="p">,</span><span class="s">&quot;w&quot;</span><span class="p">,</span> <span class="n">format</span><span class="o">=</span><span class="s">&quot;NETCDF4_CLASSIC&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f1</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f2</span><span class="o">.</span><span class="n">createDimension</span><span class="p">(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="bp">None</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">t1</span> <span class="o">=</span> <span class="n">f1</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;i&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">t2</span> <span class="o">=</span> <span class="n">f2</span><span class="o">.</span><span class="n">createVariable</span><span class="p">(</span><span class="s">&quot;time&quot;</span><span class="p">,</span><span class="s">&quot;i&quot;</span><span class="p">,(</span><span class="s">&quot;time&quot;</span><span class="p">,))</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">t1</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s">&quot;days since 2000-01-01&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">t2</span><span class="o">.</span><span class="n">units</span> <span class="o">=</span> <span class="s">&quot;days since 2000-02-01&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">t1</span><span class="o">.</span><span class="n">calendar</span> <span class="o">=</span> <span class="s">&quot;standard&quot;</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">t2</span><span class="o">.</span><span class="n">calendar</span> <span class="o">=</span> <span class="s">&quot;standard&quot;</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">t1</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="mi">31</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">t2</span><span class="p">[:]</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="mi">30</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">f1</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">f2</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="c1"># Read the two files in at once, in one Dataset.</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">MFDataset</span><span class="p">(</span><span class="s2">&quot;mftest*nc&quot;</span><span class="p">)</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="n">t</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s2">&quot;time&quot;</span><span class="p">]</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="c"># Read the two files in at once, in one Dataset.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">f</span> <span class="o">=</span> <span class="n">MFDataset</span><span class="p">(</span><span class="s">&quot;mftest*nc&quot;</span><span class="p">)</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="n">t</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s">&quot;time&quot;</span><span class="p">]</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">t</span><span class="o">.</span><span class="n">units</span>
 <span class="n">days</span> <span class="n">since</span> <span class="mi">2000</span><span class="o">-</span><span class="mo">01</span><span class="o">-</span><span class="mo">01</span>
-<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">t</span><span class="p">[</span><span class="mi">32</span><span class="p">]</span> <span class="c1"># The value written in the file, inconsistent with the MF time units.</span>
+<span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">t</span><span class="p">[</span><span class="mi">32</span><span class="p">]</span> <span class="c"># The value written in the file, inconsistent with the MF time units.</span>
 <span class="mi">1</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="n">T</span> <span class="o">=</span> <span class="n">MFTime</span><span class="p">(</span><span class="n">t</span><span class="p">)</span>
 <span class="o">&gt;&gt;&gt;</span> <span class="k">print</span> <span class="n">T</span><span class="p">[</span><span class="mi">32</span><span class="p">]</span>
@@ -5588,23 +5301,28 @@ time unit to all files. </p>
           <ul class="class_list">
           <li><a href="#netCDF4.MFTime">MFTime</a></li>
           <li>netCDF4._netCDF4._Variable</li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
-          <h3>Methods</h3>
+          <h3>Static methods</h3>
             
   <div class="item">
     <div class="name def" id="netCDF4.MFTime.__init__">
-    <p>def <span class="ident">__init__</span>(</p><p>self, time, units=None)</p>
+    <p>def <span class="ident">__init__</span>(</p><p>self, time, units=None, calendar=None)</p>
     </div>
     
 
     
   
-    <div class="desc"><p>Create a time Variable with units consistent across a multifile
+    <div class="desc"><p><strong><code>__init__(self, time, units=None, calendar=None)</code></strong></p>
+<p>Create a time Variable with units consistent across a multifile
 dataset.</p>
 <p><strong><code>time</code></strong>: Time variable from a <a href="#netCDF4.MFDataset"><code>MFDataset</code></a>.</p>
-<p><strong><code>units</code></strong>: Time units, for example, <code>days since 1979-01-01</code>. If None, use
-the units from the master variable.</p></div>
+<p><strong><code>units</code></strong>: Time units, for example, <code>'days since 1979-01-01'</code>. If <code>None</code>,
+use the units from the master variable.</p>
+<p><strong><code>calendar</code></strong>: Calendar overload to use across all files, for example,
+<code>'standard'</code> or <code>'gregorian'</code>. If <code>None</code>, check that the calendar attribute
+is present on each variable and values are unique across files raising a
+<code>ValueError</code> otherwise.</p></div>
   <div class="source_cont">
 </div>
 
@@ -5613,7 +5331,7 @@ the units from the master variable.</p><
             
   <div class="item">
     <div class="name def" id="netCDF4.MFTime.ncattrs">
-    <p>def <span class="ident">ncattrs</span>(</p><p>...)</p>
+    <p>def <span class="ident">ncattrs</span>(</p><p>self)</p>
     </div>
     
 
@@ -5627,7 +5345,7 @@ the units from the master variable.</p><
             
   <div class="item">
     <div class="name def" id="netCDF4.MFTime.set_auto_chartostring">
-    <p>def <span class="ident">set_auto_chartostring</span>(</p><p>...)</p>
+    <p>def <span class="ident">set_auto_chartostring</span>(</p><p>self, val)</p>
     </div>
     
 
@@ -5641,7 +5359,7 @@ the units from the master variable.</p><
             
   <div class="item">
     <div class="name def" id="netCDF4.MFTime.set_auto_mask">
-    <p>def <span class="ident">set_auto_mask</span>(</p><p>...)</p>
+    <p>def <span class="ident">set_auto_mask</span>(</p><p>self, val)</p>
     </div>
     
 
@@ -5655,7 +5373,7 @@ the units from the master variable.</p><
             
   <div class="item">
     <div class="name def" id="netCDF4.MFTime.set_auto_maskandscale">
-    <p>def <span class="ident">set_auto_maskandscale</span>(</p><p>...)</p>
+    <p>def <span class="ident">set_auto_maskandscale</span>(</p><p>self, val)</p>
     </div>
     
 
@@ -5669,7 +5387,7 @@ the units from the master variable.</p><
             
   <div class="item">
     <div class="name def" id="netCDF4.MFTime.set_auto_scale">
-    <p>def <span class="ident">set_auto_scale</span>(</p><p>...)</p>
+    <p>def <span class="ident">set_auto_scale</span>(</p><p>self, val)</p>
     </div>
     
 
@@ -5683,7 +5401,7 @@ the units from the master variable.</p><
             
   <div class="item">
     <div class="name def" id="netCDF4.MFTime.typecode">
-    <p>def <span class="ident">typecode</span>(</p><p>...)</p>
+    <p>def <span class="ident">typecode</span>(</p><p>self)</p>
     </div>
     
 
@@ -5715,7 +5433,7 @@ the user.</p></div>
           <h3>Ancestors (in MRO)</h3>
           <ul class="class_list">
           <li><a href="#netCDF4.VLType">VLType</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
@@ -5820,7 +5538,7 @@ behavior is similar to Fortran or Matlab
           <h3>Ancestors (in MRO)</h3>
           <ul class="class_list">
           <li><a href="#netCDF4.Variable">Variable</a></li>
-          <li>__builtin__.object</li>
+          <li>builtins.object</li>
           </ul>
           <h3>Class variables</h3>
             <div class="item">
@@ -6296,12 +6014,12 @@ set to missing_value.</p>
 <p>If <code>maskandscale</code> is set to <code>True</code>, and the variable has a
 <code>scale_factor</code> or an <code>add_offset</code> attribute, then data read
 from that variable is unpacked using::</p>
-<div class="codehilite"><pre><span></span>data = self.scale_factor*data + self.add_offset
+<div class="codehilite"><pre>data = self.scale_factor*data + self.add_offset
 </pre></div>
 
 
 <p>When data is written to a variable it is packed using::</p>
-<div class="codehilite"><pre><span></span>data = (data - self.add_offset)/self.scale_factor
+<div class="codehilite"><pre>data = (data - self.add_offset)/self.scale_factor
 </pre></div>
 
 
@@ -6341,12 +6059,12 @@ attribute.</p>
 <p>If <code>scale</code> is set to <code>True</code>, and the variable has a
 <code>scale_factor</code> or an <code>add_offset</code> attribute, then data read
 from that variable is unpacked using::</p>
-<div class="codehilite"><pre><span></span>data = self.scale_factor*data + self.add_offset
+<div class="codehilite"><pre>data = self.scale_factor*data + self.add_offset
 </pre></div>
 
 
 <p>When data is written to a variable it is packed using::</p>
-<div class="codehilite"><pre><span></span>data = (data - self.add_offset)/self.scale_factor
+<div class="codehilite"><pre>data = (data - self.add_offset)/self.scale_factor
 </pre></div>
 
 
@@ -6483,7 +6201,7 @@ to the unstrided read routine <code>nc_g
   <footer id="footer">
     <p>
       Documentation generated by
-      <a href="https://github.com/BurntSushi/pdoc">pdoc 0.3.2.dev16</a>
+      <a href="https://github.com/BurntSushi/pdoc">pdoc 0.3.2.dev29</a>
     </p>
 
     <p>pdoc is in the public domain with the
diff -pruN 1.3.1-1/examples/tutorial.py 1.4.0-1/examples/tutorial.py
--- 1.3.1-1/examples/tutorial.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/examples/tutorial.py	2018-05-01 17:12:07.000000000 +0000
@@ -162,18 +162,17 @@ datac2.real = datain['real']
 datac2.imag = datain['imag']
 print(datac.dtype,datac)
 print(datac2.dtype,datac2)
+
 # more complex compound type example.
-from netCDF4 import chartostring, stringtoarr
 f = Dataset('compound_example.nc','w') # create a new dataset.
 # create an unlimited  dimension call 'station'
 f.createDimension('station',None)
 # define a compound data type (can contain arrays, or nested compound types).
-NUMCHARS = 80 # number of characters to use in fixed-length strings.
 winddtype = numpy.dtype([('speed','f4'),('direction','i4')])
 statdtype = numpy.dtype([('latitude', 'f4'), ('longitude', 'f4'),
                          ('surface_wind',winddtype),
                          ('temp_sounding','f4',10),('press_sounding','i4',10),
-                         ('location_name','S1',NUMCHARS)])
+                         ('location_name','S12')])
 # use this data type definitions to create a compound data types
 # called using the createCompoundType Dataset method.
 # create a compound type for vector wind which will be nested inside
@@ -182,12 +181,12 @@ wind_data_t = f.createCompoundType(windd
 # now that wind_data_t is defined, create the station data type.
 station_data_t = f.createCompoundType(statdtype,'station_data')
 # create nested compound data types to hold the units variable attribute.
-winddtype_units = numpy.dtype([('speed','S1',NUMCHARS),('direction','S1',NUMCHARS)])
-statdtype_units = numpy.dtype([('latitude', 'S1',NUMCHARS), ('longitude', 'S1',NUMCHARS),
+winddtype_units = numpy.dtype([('speed','S12'),('direction','S12')])
+statdtype_units = numpy.dtype([('latitude', 'S12'), ('longitude', 'S12'),
                                ('surface_wind',winddtype_units),
-                               ('temp_sounding','S1',NUMCHARS),
-                               ('location_name','S1',NUMCHARS),
-                               ('press_sounding','S1',NUMCHARS)])
+                               ('temp_sounding','S12'),
+                               ('location_name','S12'),
+                               ('press_sounding','S12')])
 # create the wind_data_units type first, since it will nested inside
 # the station_data_units data type.
 wind_data_units_t = f.createCompoundType(winddtype_units,'wind_data_units')
@@ -196,35 +195,33 @@ f.createCompoundType(statdtype_units,'st
 # create a variable of of type 'station_data_t'
 statdat = f.createVariable('station_obs', station_data_t, ('station',))
 # create a numpy structured array, assign data to it.
-data = numpy.empty(1,station_data_t)
+data = numpy.empty(1,statdtype)
 data['latitude'] = 40.
 data['longitude'] = -105.
 data['surface_wind']['speed'] = 12.5
 data['surface_wind']['direction'] = 270
 data['temp_sounding'] = (280.3,272.,270.,269.,266.,258.,254.1,250.,245.5,240.)
 data['press_sounding'] = range(800,300,-50)
-# variable-length string datatypes are not supported inside compound types, so
-# to store strings in a compound data type, each string must be
-# stored as fixed-size (in this case 80) array of characters.
-data['location_name'] = stringtoarr('Boulder, Colorado, USA',NUMCHARS)
+data['location_name'] = 'Boulder, CO'
 # assign structured array to variable slice.
 statdat[0] = data
 # or just assign a tuple of values to variable slice
 # (will automatically be converted to a structured array).
-statdat[1] = (40.78,-73.99,(-12.5,90),
+statdat[1] = numpy.array((40.78,-73.99,(-12.5,90),
              (290.2,282.5,279.,277.9,276.,266.,264.1,260.,255.5,243.),
-             range(900,400,-50),stringtoarr('New York, New York, USA',NUMCHARS))
+             range(900,400,-50),'New York, NY'),data.dtype)
 print(f.cmptypes)
 windunits = numpy.empty(1,winddtype_units)
 stationobs_units = numpy.empty(1,statdtype_units)
-windunits['speed'] = stringtoarr('m/s',NUMCHARS)
-windunits['direction'] = stringtoarr('degrees',NUMCHARS)
-stationobs_units['latitude'] = stringtoarr('degrees north',NUMCHARS)
-stationobs_units['longitude'] = stringtoarr('degrees west',NUMCHARS)
+windunits['speed'] = 'm/s'
+windunits['direction'] = 'degrees'
+stationobs_units['latitude'] = 'degrees N'
+stationobs_units['longitude'] = 'degrees W'
 stationobs_units['surface_wind'] = windunits
-stationobs_units['location_name'] = stringtoarr('None', NUMCHARS)
-stationobs_units['temp_sounding'] = stringtoarr('Kelvin',NUMCHARS)
-stationobs_units['press_sounding'] = stringtoarr('hPa',NUMCHARS)
+stationobs_units['location_name'] = 'None'
+stationobs_units['temp_sounding'] = 'Kelvin'
+stationobs_units['press_sounding'] = 'hPa'
+print(stationobs_units.dtype)
 statdat.units = stationobs_units
 # close and reopen the file.
 f.close()
@@ -234,22 +231,7 @@ statdat = f.variables['station_obs']
 print(statdat)
 # print out data in variable.
 print('data in a variable of compound type:')
-print('----')
-for data in statdat[:]:
-    for name in statdat.dtype.names:
-        if data[name].dtype.kind == 'S': # a string
-            # convert array of characters back to a string for display.
-            units = chartostring(statdat.units[name])
-            print(name,': value =',chartostring(data[name]),\
-                    ': units=',units)
-        elif data[name].dtype.kind == 'V': # a nested compound type
-            units_list = [chartostring(s) for s in tuple(statdat.units[name])]
-            print(name,data[name].dtype.names,': value=',data[name],': units=',\
-            units_list)
-        else: # a numeric type.
-            units = chartostring(statdat.units[name])
-            print(name,': value=',data[name],': units=',units)
-    print('----')
+print(statdat[:])
 f.close()
 
 f = Dataset('tst_vlen.nc','w')
@@ -306,3 +288,35 @@ print(cloud_var)
 print(cloud_var.datatype.enum_dict)
 print(cloud_var[:])
 f.close()
+
+# dealing with strings
+from netCDF4 import stringtochar
+nc = Dataset('stringtest.nc','w',format='NETCDF4_CLASSIC')
+nc.createDimension('nchars',3)
+nc.createDimension('nstrings',None)
+v = nc.createVariable('strings','S1',('nstrings','nchars'))
+datain = numpy.array(['foo','bar'],dtype='S3')
+v[:] = stringtochar(datain) # manual conversion to char array
+print(v[:]) # data returned as char array
+v._Encoding = 'ascii' # this enables automatic conversion
+v[:] = datain # conversion to char array done internally
+print(v[:]) # data returned in numpy string array
+nc.close()
+# strings in compound types
+nc = Dataset('compoundstring_example.nc','w')
+dtype = numpy.dtype([('observation', 'f4'),
+                     ('station_name','S12')])
+station_data_t = nc.createCompoundType(dtype,'station_data')
+nc.createDimension('station',None)
+statdat = nc.createVariable('station_obs', station_data_t, ('station',))
+data = numpy.empty(2,station_data_t.dtype_view)
+data['observation'][:] = (123.,3.14)
+data['station_name'][:] = ('Boulder','New York')
+print(statdat.dtype) # strings actually stored as character arrays
+statdat[:] = data # strings converted to character arrays internally
+print(statdat[:]) # character arrays converted back to strings
+print(statdat[:].dtype)
+statdat.set_auto_chartostring(False) # turn off auto-conversion
+statdat[:] = data.view(station_data_t.dtype)
+print(statdat[:]) # now structured array with char array subtype is returned
+nc.close()
diff -pruN 1.3.1-1/MANIFEST.in 1.4.0-1/MANIFEST.in
--- 1.3.1-1/MANIFEST.in	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/MANIFEST.in	2018-05-01 17:12:07.000000000 +0000
@@ -13,9 +13,8 @@ include examples/*ipynb
 include examples/README.md
 include test/*py
 include test/*nc
-include netcdftime/__init__.py
-include netcdftime/_netcdftime.pyx
 include netCDF4/__init__.py
 include netCDF4/_netCDF4.pyx
 include netCDF4/utils.py
 include include/netCDF4.pxi
+include include/mpi-compat.h
diff -pruN 1.3.1-1/netCDF4/_netCDF4.pyx 1.4.0-1/netCDF4/_netCDF4.pyx
--- 1.3.1-1/netCDF4/_netCDF4.pyx	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/netCDF4/_netCDF4.pyx	2018-05-01 17:12:07.000000000 +0000
@@ -1,5 +1,5 @@
 """
-Version 1.3.1
+Version 1.4.0
 -------------
 - - - 
 
@@ -41,6 +41,9 @@ Requires
  - [Cython](http://cython.org), version 0.21 or later.
  - [setuptools](https://pypi.python.org/pypi/setuptools), version 18.0 or
    later.
+ - [cftime](https://github.com/Unidata/cftime) for 
+ the time and date handling utility functions (`netCDF4.num2date`,
+ `netCDF4.date2num` and `netCDF4.date2index`).
  - The HDF5 C library version 1.8.4-patch1 or higher (1.8.x recommended)
  from [](ftp://ftp.hdfgroup.org/HDF5/current/src).
  ***netCDF version 4.4.1 or higher is recommended if using HDF5 1.10.x -
@@ -109,6 +112,7 @@ Tutorial
 11. [Variable-length (vlen) data types.](#section11)
 12. [Enum data type.](#section12)
 13. [Parallel IO.](#section13)
+14. [Dealing with strings](#section14)
 
 
 ## <div id='section1'>1) Creating/Opening/Closing a netCDF file.
@@ -532,7 +536,7 @@ Hemisphere longitudes, resulting in a nu
     shape of fancy temp slice =  (3, 3, 36, 71)
 
 ***Special note for scalar variables***: To extract data from a scalar variable
-`v` with no associated dimensions, use `np.asarray(v)` or `v[...]`. The result
+`v` with no associated dimensions, use `numpy.asarray(v)` or `v[...]`. The result
 will be a numpy scalar array.
 
 ## <div id='section7'>7) Dealing with time coordinates.
@@ -543,7 +547,9 @@ measure relative to a fixed date using a
 specified like `hours since YY-MM-DD hh:mm:ss`.  These units can be
 awkward to deal with, without a utility to convert the values to and
 from calendar dates.  The function called `netCDF4.num2date` and `netCDF4.date2num` are
-provided with this package to do just that.  Here's an example of how they
+provided with this package to do just that (starting with version 1.4.0, the 
+[cftime](https://unidata.github.io/cftime) package must be installed
+separately).  Here's an example of how they
 can be used:
 
     :::python
@@ -927,7 +933,7 @@ written to a different variable index on
 
     :::python
     >>> d = nc.createDimension('dim',4)
-    >>> v = nc.createVariable('var', np.int, 'dim')
+    >>> v = nc.createVariable('var', numpy.int, 'dim')
     >>> v[rank] = rank
     >>> nc.close()
 
@@ -959,6 +965,89 @@ are collective.  There are a couple of i
    you can read it).
  - You cannot use variable-length (VLEN) data types. 
 
+## <div id='section14'>14) Dealing with strings.
+
+The most flexible way to store arrays of strings is with the 
+[Variable-length (vlen) string data type](#section11). However, this requires
+the use of the NETCDF4 data model, and the vlen type does not map very well
+numpy arrays (you have to use numpy arrays of dtype=`object`, which are arrays of
+arbitrary python objects). numpy does have a fixed-width string array
+data type, but unfortunately the netCDF data model does not.
+Instead fixed-width byte strings are typically stored as [arrays of 8-bit
+characters](https://www.unidata.ucar.edu/software/netcdf/docs/BestPractices.html#bp_Strings-and-Variables-of-type-char).
+To perform the conversion to and from character arrays to fixed-width numpy string arrays, the
+following convention is followed by the python interface.
+If the `_Encoding` special attribute is set for a character array
+(dtype `S1`) variable, the `netCDF4.chartostring` utility function is used to convert the array of
+characters to an array of strings with one less dimension (the last dimension is
+interpreted as the length of each string) when reading the data. The character
+set (usually ascii) is specified by the `_Encoding` attribute. If `_Encoding`
+is 'none' or 'bytes', then the character array is converted to a numpy
+fixed-width byte string array (dtype `S#`), otherwise a numpy unicode (dtype
+`U#`) array is created.  When writing the data,
+`netCDF4.stringtochar` is used to convert the numpy string array to an array of
+characters with one more dimension. For example,
+
+    :::python
+    >>> nc = Dataset('stringtest.nc','w',format='NETCDF4_CLASSIC')
+    >>> nc.createDimension('nchars',3)
+    >>> nc.createDimension('nstrings',None)
+    >>> v = nc.createVariable('strings','S1',('nstrings','nchars'))
+    >>> datain = numpy.array(['foo','bar'],dtype='S3')
+    >>> v[:] = stringtochar(datain) # manual conversion to char array
+    >>> v[:] # data returned as char array
+    [[b'f' b'o' b'o']
+    [b'b' b'a' b'r']]
+    >>> v._Encoding = 'ascii' # this enables automatic conversion
+    >>> v[:] = datain # conversion to char array done internally
+    >>> v[:] # data returned in numpy string array
+    ['foo' 'bar']
+    >>> nc.close()
+
+Even if the `_Encoding` attribute is set, the automatic conversion of char
+arrays to/from string arrays can be disabled with
+`netCDF4.Variable.set_auto_chartostring`. 
+
+A similar situation is often encountered with numpy structured arrays with subdtypes
+containing fixed-wdith byte strings (dtype=`S#`). Since there is no native fixed-length string
+netCDF datatype, these numpy structure arrays are mapped onto netCDF compound
+types with character array elements.  In this case the string <-> char array
+conversion is handled automatically (without the need to set the `_Encoding`
+attribute) using [numpy
+views](https://docs.scipy.org/doc/numpy/reference/generated/numpy.ndarray.view.html).
+The structured array dtype (including the string elements) can even be used to
+define the compound data type - the string dtype will be converted to
+character array dtype under the hood when creating the netcdf compound type.
+Here's an example:
+
+    :::python
+    >>> nc = Dataset('compoundstring_example.nc','w')
+    >>> dtype = numpy.dtype([('observation', 'f4'),
+                      ('station_name','S80')])
+    >>> station_data_t = nc.createCompoundType(dtype,'station_data')
+    >>> nc.createDimension('station',None)
+    >>> statdat = nc.createVariable('station_obs', station_data_t, ('station',))
+    >>> data = numpy.empty(2,dtype)
+    >>> data['observation'][:] = (123.,3.14)
+    >>> data['station_name'][:] = ('Boulder','New York')
+    >>> statdat.dtype # strings actually stored as character arrays
+    {'names':['observation','station_name'], 'formats':['<f4',('S1', (80,))], 'offsets':[0,4], 'itemsize':84, 'aligned':True}
+    >>> statdat[:] = data # strings converted to character arrays internally
+    >>> statdat[:] # character arrays converted back to strings
+    [(123.  , 'Boulder') (  3.14, 'New York')]
+    >>> statdat[:].dtype
+    {'names':['observation','station_name'], 'formats':['<f4','S80'], 'offsets':[0,4], 'itemsize':84, 'aligned':True}
+    >>> statdat.set_auto_chartostring(False) # turn off auto-conversion
+    >>> statdat[:] = data.view(dtype=[('observation', 'f4'),('station_name','S1',10)])
+    >>> statdat[:] # now structured array with char array subtype is returned
+    [(123.  , ['B', 'o', 'u', 'l', 'd', 'e', 'r', '', '', ''])
+    (  3.14, ['N', 'e', 'w', ' ', 'Y', 'o', 'r', 'k', '', ''])]
+    >>> nc.close()
+
+Note that there is currently no support for mapping numpy structured arrays with
+unicode elements (dtype `U#`) onto netCDF compound types, nor is there support 
+for netCDF compound types with vlen string components.
+
 All of the code in this tutorial is available in `examples/tutorial.py`, except
 the parallel IO example, which is in `examples/mpi_example.py`.
 Unit tests are in the `test` directory.
@@ -988,7 +1077,7 @@ from cpython.buffer cimport PyObject_Get
 
 # pure python utilities
 from .utils import (_StartCountStride, _quantize, _find_dim, _walk_grps,
-                    _out_array_shape, _sortbylist, _tostr, _safecast)
+                    _out_array_shape, _sortbylist, _tostr, _safecast, _is_int)
 # try to use built-in ordered dict in python >= 2.7
 try:
     from collections import OrderedDict
@@ -1003,11 +1092,11 @@ except ImportError:
     # python3: zip is already python2's itertools.izip
     pass
 
-__version__ = "1.3.1"
+__version__ = "1.4.0"
 
 # Initialize numpy
 import posixpath
-import netcdftime
+from cftime import num2date, date2num, date2index
 import numpy
 import weakref
 import sys
@@ -1231,7 +1320,7 @@ cdef _get_att(grp, int varid, name, enco
             # check if it's a compound
             try:
                 type_att = _read_compound(grp, att_type)
-                value_arr = numpy.empty(att_len,type_att)
+                value_arr = numpy.empty(att_len,type_att.dtype_view)
             except:
                 # check if it's an enum
                 try:
@@ -1331,8 +1420,10 @@ cdef _set_att(grp, int varid, name, valu
     # if array contains unicode strings, and data model is NETCDF4, 
     # write as a string.
     if value_arr.dtype.char in ['S','U']:
-        if not is_netcdf3 and force_ncstring and value_arr.size > 1:
-            N = value_arr.size
+        # force array of strings if array has multiple elements (issue #770)
+        N = value_arr.size
+        if N > 1: force_ncstring=True
+        if not is_netcdf3 and force_ncstring and N > 1:
             string_ptrs = <char**>PyMem_Malloc(N * sizeof(char*))
             if not string_ptrs:
                 raise MemoryError()
@@ -1347,6 +1438,10 @@ cdef _set_att(grp, int varid, name, valu
             finally:
                 PyMem_Free(string_ptrs)
         else:
+            # don't allow string array attributes in NETCDF3 files.
+            if is_netcdf3 and N > 1:
+                msg='array string attributes can only be written with NETCDF4'
+                raise IOError(msg)
             if not value_arr.shape:
                 dats = _strencode(value_arr.item())
             else:
@@ -1884,17 +1979,18 @@ references to the parent Dataset or Grou
             IF HAS_NC_PAR != 1:
                 msg='parallel mode requires MPI enabled netcdf-c'
                 raise ValueError(msg)
-            if format != 'NETCDF4':
-                msg='parallel mode only works with format=NETCDF4'
-                raise ValueError(msg)
-            if comm is not None:
-                mpicomm = comm.ob_mpi
-            else:
-                mpicomm = MPI_COMM_WORLD
-            if info is not None:
-                mpiinfo = info.ob_mpi
-            else:
-                mpiinfo = MPI_INFO_NULL
+            ELSE:
+                if format != 'NETCDF4':
+                    msg='parallel mode only works with format=NETCDF4'
+                    raise ValueError(msg)
+                if comm is not None:
+                    mpicomm = comm.ob_mpi
+                else:
+                    mpicomm = MPI_COMM_WORLD
+                if info is not None:
+                    mpiinfo = info.ob_mpi
+                else:
+                    mpiinfo = MPI_INFO_NULL
 
         if mode == 'w':
             _set_default_format(format=format)
@@ -2517,8 +2613,7 @@ with the same name as one of the reserve
 
 set a netCDF dataset or group string attribute using name,value pair.
 Use if you need to ensure that a netCDF attribute is created with type
-`NC_STRING` if the file format is `NETCDF4`.
-Use if you need to set an attribute to an array of variable-length strings."""
+`NC_STRING` if the file format is `NETCDF4`."""
         cdef nc_type xtype
         xtype=-99
         if self.data_model != 'NETCDF4':
@@ -3252,6 +3347,7 @@ behavior is similar to Fortran or Matlab
         `netCDF4.Group` instance, not using this class directly.
         """
         cdef int ierr, ndims, icontiguous, ideflate_level, numdims, _grpid
+        cdef char namstring[NC_MAX_NAME+1]
         cdef char *varname
         cdef nc_type xtype
         cdef int *dimids
@@ -3329,6 +3425,9 @@ behavior is similar to Fortran or Matlab
                 datatype = VLType(self._grp, str, None)
                 self._vltype = datatype
             xtype = datatype._nc_type
+            # make sure this a valid user defined datatype defined in this Group
+            ierr = nc_inq_type(self._grpid, xtype, namstring, NULL)
+            _ensure_nc_success(ierr)
             # dtype variable attribute is a numpy datatype object.
             self.dtype = datatype.dtype
         elif datatype.str[1:] in _supportedtypes:
@@ -3997,13 +4096,13 @@ rename a `netCDF4.Variable` attribute na
 
         if self.mask and (self._isprimitive or self._isenum):
             data = self._toma(data)
-
-        # if attribute _Unsigned is True, and variable has signed integer
-        # dtype, return view with corresponding unsigned dtype (issue #656)
-        if self.scale:  # only do this if autoscale option is on.
-            is_unsigned = getattr(self, '_Unsigned', False)
-            if is_unsigned and data.dtype.kind == 'i':
-                data = data.view('u%s' % data.dtype.itemsize)
+        else:
+            # if attribute _Unsigned is True, and variable has signed integer
+            # dtype, return view with corresponding unsigned dtype (issue #656)
+            if self.scale:  # only do this if autoscale option is on.
+                is_unsigned = getattr(self, '_Unsigned', False)
+                if is_unsigned and data.dtype.kind == 'i':
+                    data = data.view('u%s' % data.dtype.itemsize)
 
         if self.scale and self._isprimitive and valid_scaleoffset:
             # if variable has scale_factor and add_offset attributes, rescale.
@@ -4037,10 +4136,25 @@ rename a `netCDF4.Variable` attribute na
                     if matchdim:
                         data = chartostring(data, encoding=encoding)
 
+        # if structure array contains char arrays, return view as strings
+        # if _Encoding att set (issue #773)
+        if self._iscompound and \
+           self._cmptype.dtype != self._cmptype.dtype_view and \
+           self.chartostring:
+#          self.chartostring and getattr(self,'_Encoding',None) is not None:
+                data = data.view(self._cmptype.dtype_view)
         return data
 
     def _toma(self,data):
         cdef int ierr, no_fill
+        # if attribute _Unsigned is True, and variable has signed integer
+        # dtype, return view with corresponding unsigned dtype (issues #656,
+        # #794)
+        is_unsigned = getattr(self, '_Unsigned', False)
+        is_unsigned_int = is_unsigned and data.dtype.kind == 'i'
+        if self.scale and is_unsigned_int:  # only do this if autoscale option is on.
+            dtype_unsigned_int = 'u%s' % data.dtype.itemsize
+            data = data.view(dtype_unsigned_int)
         # private function for creating a masked array, masking missing_values
         # and/or _FillValues.
         totalmask = numpy.zeros(data.shape, numpy.bool)
@@ -4048,6 +4162,8 @@ rename a `netCDF4.Variable` attribute na
         safe_missval = self._check_safecast('missing_value')
         if safe_missval:
             mval = numpy.array(self.missing_value, self.dtype)
+            if self.scale and is_unsigned_int:
+                mval = mval.view(dtype_unsigned_int)
             # create mask from missing values. 
             mvalmask = numpy.zeros(data.shape, numpy.bool)
             if mval.shape == (): # mval a scalar.
@@ -4072,6 +4188,8 @@ rename a `netCDF4.Variable` attribute na
         safe_fillval = self._check_safecast('_FillValue')
         if safe_fillval:
             fval = numpy.array(self._FillValue, self.dtype)
+            if self.scale and is_unsigned_int:
+                fval = fval.view(dtype_unsigned_int)
             # is _FillValue a NaN?
             try:
                 fvalisnan = numpy.isnan(fval)
@@ -4134,6 +4252,10 @@ rename a `netCDF4.Variable` attribute na
                 validmin = numpy.array(self.valid_min, self.dtype)
             if safe_validmax:
                 validmax = numpy.array(self.valid_max, self.dtype)
+        if validmin is not None and self.scale and is_unsigned_int:
+            validmin = validmin.view(dtype_unsigned_int)
+        if validmax is not None and self.scale and is_unsigned_int:
+            validmax = validmax.view(dtype_unsigned_int)
         # http://www.unidata.ucar.edu/software/netcdf/docs/attribute_conventions.html).
         # "If the data type is byte and _FillValue 
         # is not explicitly defined,
@@ -4149,26 +4271,38 @@ rename a `netCDF4.Variable` attribute na
             fval = numpy.array(default_fillvals[self.dtype.str[1:]],self.dtype)
             if byte_type: fval = None
         if self.dtype.kind != 'S': # don't set mask for character data
-            if validmin is None and (fval is not None and fval <= 0):
-                validmin = fval
-            if validmax is None and (fval is not None and fval > 0):
-                validmax = fval
+            # issues #761 and #748:  setting valid_min/valid_max to the
+            # _FillVaue is too surprising for many users (despite the
+            # netcdf docs attribute best practices suggesting clients
+            # should do this).
+            #if validmin is None and (fval is not None and fval <= 0):
+            #    validmin = fval
+            #if validmax is None and (fval is not None and fval > 0):
+            #    validmax = fval
             if validmin is not None:
                 totalmask += data < validmin
             if validmax is not None:
                 totalmask += data > validmax
         if fill_value is None and fval is not None:
             fill_value = fval
+        # if all else fails, use default _FillValue as fill_value
+        # for masked array.
+        if fill_value is None:
+            fill_value = default_fillvals[self.dtype.str[1:]]
         # create masked array with computed mask
-        if totalmask.any() and fill_value is not None:
+        if totalmask.any():
             data = ma.masked_array(data,mask=totalmask,fill_value=fill_value)
-            # issue 515 scalar array with mask=True should be converted
-            # to numpy.ma.MaskedConstant to be consistent with slicing
-            # behavior of masked arrays.
-            if data.shape == () and data.mask.all():
-                # return a scalar numpy masked constant not a 0-d masked array,
-                # so that data == numpy.ma.masked.
-                data = data[()] # changed from [...] (issue #662)
+        else:
+            # issue #785: always return masked array, if no values masked
+            # set mask=False.
+            data = ma.masked_array(data,mask=False,fill_value=fill_value)
+        # issue 515 scalar array with mask=True should be converted
+        # to numpy.ma.MaskedConstant to be consistent with slicing
+        # behavior of masked arrays.
+        if data.shape == () and data.mask.all():
+            # return a scalar numpy masked constant not a 0-d masked array,
+            # so that data == numpy.ma.masked.
+            data = data[()] # changed from [...] (issue #662)
         return data
 
     def _assign_vlen(self, elem, data):
@@ -4185,7 +4319,7 @@ rename a `netCDF4.Variable` attribute na
         msg="data can only be assigned to VLEN variables using integer indices"
         # check to see that elem is a tuple of integers.
         # handle negative integers.
-        if isinstance(elem, int):
+        if _is_int(elem):
             if ndims > 1:
                 raise IndexError(msg)
             if elem < 0:
@@ -4198,7 +4332,7 @@ rename a `netCDF4.Variable` attribute na
                 raise IndexError("Illegal index")
             elemnew = []
             for n,e in enumerate(elem):
-                if not isinstance(e, int):
+                if not _is_int(e):
                     raise IndexError(msg)
                 elif e < 0:
                     enew = self.shape[n]+e
@@ -4287,6 +4421,16 @@ cannot be safely cast to variable data t
                     # of characters with one more dimension.
                     data = stringtochar(data, encoding=encoding)
 
+        # if structured data has strings (and _Encoding att set), create view as char arrays
+        # (issue #773)
+        if self._iscompound and \
+           self._cmptype.dtype != self._cmptype.dtype_view and \
+           _set_viewdtype(data.dtype) == self._cmptype.dtype_view and \
+           self.chartostring:
+#          self.chartostring and getattr(self,'_Encoding',None) is not None:
+                # may need to cast input data to aligned type
+                data = data.astype(self._cmptype.dtype_view).view(self._cmptype.dtype)
+
         if self._isvlen: # if vlen, should be object array (don't try casting)
             if self.dtype == str:
                 # for string vars, if data is not an array
@@ -4375,12 +4519,16 @@ cannot be safely cast to variable data t
         # automatic conversion to masked array using
         # valid_min,validmax,missing_value,_Fill_Value.
         # ignore if not a primitive or enum data type (not compound or vlen).
-        if self.mask and (self._isprimitive or self._isenum):
-            # use missing_value as fill value.
-            # if no missing value set, use _FillValue.
-            if hasattr(self, 'scale_factor') or hasattr(self, 'add_offset'):
-                # if not masked, create a masked array.
-                if not ma.isMA(data): data = self._toma(data)
+
+        # remove this since it causes suprising behaviour (issue #777)
+        # (missing_value should apply to scaled data, not unscaled data)
+        #if self.mask and (self._isprimitive or self._isenum):
+        #    # use missing_value as fill value.
+        #    # if no missing value set, use _FillValue.
+        #    if hasattr(self, 'scale_factor') or hasattr(self, 'add_offset'):
+        #        # if not masked, create a masked array.
+        #        if not ma.isMA(data): data = self._toma(data)
+
         if self.scale and self._isprimitive:
             # pack non-masked values using scale_factor and add_offset
             if hasattr(self, 'scale_factor') and hasattr(self, 'add_offset'):
@@ -4784,16 +4932,20 @@ The default value of `mask` is `True`
         if self._isprimitive or self._iscompound or self._isenum:
             data = numpy.empty(shapeout, self.dtype)
             # strides all 1 or scalar variable, use get_vara (faster)
-            if sum(stride) == ndims or ndims == 0:
-                with nogil:
-                    ierr = nc_get_vara(self._grpid, self._varid,
-                                       startp, countp, data.data)
+            # if count contains a zero element, no data is being read
+            if 0 not in count:
+                if sum(stride) == ndims or ndims == 0:
+                    with nogil:
+                        ierr = nc_get_vara(self._grpid, self._varid,
+                                           startp, countp, data.data)
+                else:
+                    with nogil:
+                        ierr = nc_get_vars(self._grpid, self._varid,
+                                           startp, countp, stridep, data.data)
             else:
-                with nogil:
-                    ierr = nc_get_vars(self._grpid, self._varid,
-                                       startp, countp, stridep, data.data)
+                ierr = 0
             if ierr == NC_EINVALCOORDS:
-                raise IndexError
+                raise IndexError('index exceeds dimension bounds')
             elif ierr != NC_NOERR:
                 _ensure_nc_success(ierr)
         elif self._isvlen:
@@ -4924,7 +5076,7 @@ The instance variables `dtype` and `name
 the user.
     """
     cdef public nc_type _nc_type
-    cdef public dtype, name
+    cdef public dtype, dtype_view, name
     __pdoc__['CompoundType.name'] = \
     """String name."""
     __pdoc__['CompoundType.dtype'] = \
@@ -4964,13 +5116,21 @@ the user.
         # (this may or may not be still true, but empirical
         # evidence suggests that segfaults occur if this
         # alignment step is skipped - see issue #705).
+        # numpy string subdtypes (i.e. 'S80') are 
+        # automatically converted to character array
+        # subtypes (i.e. ('S1',80)).  If '_Encoding'
+        # variable attribute is set, data will be converted
+        # to and from the string array representation with views.
         dt = _set_alignment(numpy.dtype(dt))
+        # create a view datatype for converting char arrays to/from strings
+        dtview = _set_viewdtype(numpy.dtype(dt))
         if 'typeid' in kwargs:
             xtype = kwargs['typeid']
         else:
             xtype = _def_compound(grp, dt, dtype_name)
         self._nc_type = xtype
         self.dtype = dt
+        self.dtype_view = dtview
         self.name = dtype_name
 
     def __repr__(self):
@@ -5001,10 +5161,37 @@ def _set_alignment(dt):
                 else:
                     dtx = dt.fields[name][0]
         else:
+            # convert character string elements to char arrays
+            if fmt.kind == 'S' and fmt.itemsize != 1:
+                dtx = numpy.dtype('(%s,)S1' % fmt.itemsize)
+            else:
+                # primitive data type
+                dtx = dt.fields[name][0]
+        formats.append(dtx)
+    # leave out offsets, they will be re-computed to preserve alignment.
+    dtype_dict = {'names':names,'formats':formats}
+    return numpy.dtype(dtype_dict, align=True)
+
+def _set_viewdtype(dt):
+    # recursively change character array dtypes to string dtypes
+    names = dt.names; formats = []
+    for name in names:
+        fmt = dt.fields[name][0]
+        if fmt.kind == 'V':
+            if fmt.shape == ():
+                dtx = _set_viewdtype(dt.fields[name][0])
+            else:
+                if fmt.subdtype[0].kind == 'V': # structured dtype
+                    raise TypeError('nested structured dtype arrays not supported')
+                elif fmt.subdtype[0].kind == 'S' and len(dt.fields[name][0].shape) == 1:
+                    lenchar = dt.fields[name][0].shape[0]
+                    dtx = numpy.dtype('S%s' % lenchar)
+                else:
+                    dtx = dt.fields[name][0]
+        else:
             # primitive data type
             dtx = dt.fields[name][0]
         formats.append(dtx)
-    # leave out offsets, they will be re-computed to preserve alignment.
     dtype_dict = {'names':names,'formats':formats}
     return numpy.dtype(dtype_dict, align=True)
 
@@ -5091,9 +5278,10 @@ cdef _find_cmptype(grp, dtype):
         names2 = cmpdt.dtype.fields.keys()
         formats1 = [v[0] for v in dtype.fields.values()]
         formats2 = [v[0] for v in cmpdt.dtype.fields.values()]
+        formats2v = [v[0] for v in cmpdt.dtype_view.fields.values()]
         # match names, formats, but not offsets (they may be changed
         # by netcdf lib).
-        if names1==names2 and formats1==formats2:
+        if names1==names2 and formats1==formats2 or (formats1 == formats2v):
             match = True
             break
     if not match:
@@ -5385,7 +5573,7 @@ cdef _def_enum(grp, object dt, object dt
         ierr = nc_def_enum(grp._grpid, xtype_tmp, namstring, &xtype);
         _ensure_nc_success(ierr)
     else:
-        msg="unsupported datatype specified for Enum (must be integer)"
+        msg="unsupported datatype specified for ENUM (must be integer)"
         raise KeyError(msg)
     # insert named members into enum type.
     for field in enum_dict:
@@ -5412,13 +5600,13 @@ cdef _read_enum(group, nc_type xtype, en
         ierr = nc_inq_enum(_grpid, xtype, enum_namstring, &base_xtype, NULL,\
                 &nmembers)
     _ensure_nc_success(ierr)
-    name = enum_namstring.decode('utf-8')
+    enum_name = enum_namstring.decode('utf-8')
     try:
         datatype = _nctonptype[base_xtype]
         if endian is not None: datatype = endian + datatype
         dt = numpy.dtype(datatype) # see if it is a primitive type
     except KeyError:
-        raise KeyError("unsupported component type for VLEN")
+        raise KeyError("unsupported component type for ENUM")
     # loop over members, build dict.
     enum_dict = {}
     for nmem from 0 <= nmem < nmembers:
@@ -5428,7 +5616,7 @@ cdef _read_enum(group, nc_type xtype, en
         _ensure_nc_success(ierr)
         name = enum_namstring.decode('utf-8')
         enum_dict[name] = int(enum_val)
-    return EnumType(group, dt, name, enum_dict, typeid=xtype)
+    return EnumType(group, dt, enum_name, enum_dict, typeid=xtype)
 
 cdef _strencode(pystr,encoding=None):
     # encode a string into bytes.  If already bytes, do nothing.
@@ -5447,41 +5635,6 @@ def _to_ascii(bytestr):
     else:
         return bytestr.encode('ascii')
 
-#----------------------------------------
-# extra utilities (formerly in utils.pyx)
-#----------------------------------------
-from datetime import timedelta, datetime, MINYEAR
-from netcdftime import _parse_date, microsec_units, millisec_units,\
-                       sec_units, min_units, hr_units, day_units
-
-# start of the gregorian calendar
-gregorian = datetime(1582,10,15)
-
-def _dateparse(timestr):
-    """parse a string of the form time-units since yyyy-mm-dd hh:mm:ss,
-    return a datetime instance"""
-    # same as version in netcdftime, but returns a timezone naive
-    # python datetime instance with the utc_offset included.
-    timestr_split = timestr.split()
-    units = timestr_split[0].lower()
-    if timestr_split[1].lower() != 'since':
-        raise ValueError("no 'since' in unit_string")
-    # parse the date string.
-    n = timestr.find('since')+6
-    isostring = timestr[n:]
-    year, month, day, hour, minute, second, utc_offset =\
-        _parse_date( isostring.strip() )
-    if year >= MINYEAR:
-        basedate = datetime(year, month, day, hour, minute, second)
-        # subtract utc_offset from basedate time instance (which is timezone naive)
-        basedate -= timedelta(days=utc_offset/1440.)
-    else:
-        if not utc_offset:
-            basedate = netcdftime.datetime(year, month, day, hour, minute, second)
-        else:
-            raise ValueError('cannot use utc_offset for reference years <= 0')
-    return basedate
-
 def stringtoarr(string,NUMCHARS,dtype='S'):
     """
 **`stringtoarr(a, NUMCHARS,dtype='S')`**
@@ -5516,14 +5669,18 @@ is the number of characters in each stri
 an array of characters (datatype `'S1'` or `'U1'`) of shape `a.shape + (N,)`.
 
 optional kwarg `encoding` can be used to specify character encoding (default
-`utf-8`).
+`utf-8`). If `encoding` is 'none' or 'bytes', a `numpy.string_` the input array
+is treated a raw byte strings (`numpy.string_`).
 
 returns a numpy character array with datatype `'S1'` or `'U1'`
 and shape `a.shape + (N,)`, where N is the length of each string in a."""
     dtype = a.dtype.kind
     if dtype not in ["S","U"]:
         raise ValueError("type must string or unicode ('S' or 'U')")
-    b = numpy.array(tuple(a.tostring().decode(encoding)),dtype+'1')
+    if encoding in ['none','None','bytes']:
+        b = numpy.array(tuple(a.tostring()),'S1')
+    else:
+        b = numpy.array(tuple(a.tostring().decode(encoding)),dtype+'1')
     b.shape = a.shape + (a.itemsize,)
     return b
 
@@ -5538,267 +5695,26 @@ Will be converted to a array of strings,
 length of `b.shape[-1]` characters.
 
 optional kwarg `encoding` can be used to specify character encoding (default
-`utf-8`).
+`utf-8`). If `encoding` is 'none' or 'bytes', a `numpy.string_` btye array is
+returned.
 
-returns a numpy string array with datatype `'UN'` and shape
+returns a numpy string array with datatype `'UN'` (or `'SN'`) and shape
 `b.shape[:-1]` where where `N=b.shape[-1]`."""
     dtype = b.dtype.kind
     if dtype not in ["S","U"]:
         raise ValueError("type must be string or unicode ('S' or 'U')")
-    bs = b.tostring().decode(encoding)
+    if encoding in ['none','None','bytes']:
+        bs = b.tostring()
+    else:
+        bs = b.tostring().decode(encoding)
     slen = int(b.shape[-1])
-    a = numpy.array([bs[n1:n1+slen] for n1 in range(0,len(bs),slen)],'U'+repr(slen))
+    if encoding in ['none','None','bytes']:
+        a = numpy.array([bs[n1:n1+slen] for n1 in range(0,len(bs),slen)],'S'+repr(slen))
+    else:
+        a = numpy.array([bs[n1:n1+slen] for n1 in range(0,len(bs),slen)],'U'+repr(slen))
     a.shape = b.shape[:-1]
     return a
 
-def date2num(dates,units,calendar='standard'):
-    """
-**`date2num(dates,units,calendar='standard')`**
-
-Return numeric time values given datetime objects. The units
-of the numeric time values are described by the `netCDF4.units` argument
-and the `netCDF4.calendar` keyword. The datetime objects must
-be in UTC with no time-zone offset.  If there is a
-time-zone offset in `units`, it will be applied to the
-returned numeric values.
-
-**`dates`**: A datetime object or a sequence of datetime objects.
-The datetime objects should not include a time-zone offset.
-
-**`units`**: a string of the form `<time units> since <reference time>`
-describing the time units. `<time units>` can be days, hours, minutes,
-seconds, milliseconds or microseconds. `<reference time>` is the time
-origin.  
-
-**`calendar`**: describes the calendar used in the time calculations.
-All the values currently defined in the 
-[CF metadata convention](http://cfconventions.org)
-Valid calendars `'standard', 'gregorian', 'proleptic_gregorian'
-'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'`.
-Default is `'standard'`, which is a mixed Julian/Gregorian calendar.
-
-returns a numeric time value, or an array of numeric time values 
-with approximately millisecond accuracy.
-    """
-    calendar = calendar.lower()
-    basedate = _dateparse(units)
-    unit = units.split()[0].lower()
-    # real-world calendars limited to positive reference years.
-    if calendar in ['julian', 'standard', 'gregorian', 'proleptic_gregorian']:
-        if basedate.year == 0:
-            msg='zero not allowed as a reference year, does not exist in Julian or Gregorian calendars'
-            raise ValueError(msg)
-        elif basedate.year < 0:
-            msg='negative reference year in time units, must be >= 1'
-            raise ValueError(msg)
-
-    if (calendar == 'proleptic_gregorian' and basedate.year >= MINYEAR) or \
-       (calendar in ['gregorian','standard'] and basedate > gregorian):
-        # use python datetime module,
-        isscalar = False
-        try:
-            dates[0]
-        except:
-            isscalar = True
-        if isscalar:
-            dates = numpy.array([dates])
-        else:
-            dates = numpy.array(dates)
-            shape = dates.shape
-        ismasked = False
-        if hasattr(dates,'mask'):
-            mask = dates.mask
-            ismasked = True
-        times = []
-        for date in dates.flat:
-            if ismasked and not date:
-                times.append(None)
-            else:
-                td = date - basedate
-                # total time in microseconds.
-                totaltime = td.microseconds + (td.seconds + td.days * 24 * 3600) * 1.e6
-                if unit in microsec_units:
-                    times.append(totaltime)
-                elif unit in millisec_units:
-                    times.append(totaltime/1.e3)
-                elif unit in sec_units:
-                    times.append(totaltime/1.e6)
-                elif unit in min_units:
-                    times.append(totaltime/1.e6/60)
-                elif unit in hr_units:
-                    times.append(totaltime/1.e6/3600)
-                elif unit in day_units:
-                    times.append(totaltime/1.e6/3600./24.)
-                else:
-                    raise ValueError('unsupported time units')
-        if isscalar:
-            return times[0]
-        else:
-            return numpy.reshape(numpy.array(times), shape)
-    else: # use netcdftime module for other calendars
-        cdftime = netcdftime.utime(units,calendar=calendar)
-        return cdftime.date2num(dates)
-
-def num2date(times,units,calendar='standard'):
-    """
-**`num2date(times,units,calendar='standard')`**
-
-Return datetime objects given numeric time values. The units
-of the numeric time values are described by the `units` argument
-and the `calendar` keyword. The returned datetime objects represent
-UTC with no time-zone offset, even if the specified
-`units` contain a time-zone offset.
-
-**`times`**: numeric time values.
-
-**`units`**: a string of the form `<time units> since <reference time>`
-describing the time units. `<time units>` can be days, hours, minutes,
-seconds, milliseconds or microseconds. `<reference time>` is the time
-origin.
-
-**`calendar`**: describes the calendar used in the time calculations.
-All the values currently defined in the 
-[CF metadata convention](http://cfconventions.org)
-Valid calendars `'standard', 'gregorian', 'proleptic_gregorian'
-'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'`.
-Default is `'standard'`, which is a mixed Julian/Gregorian calendar.
-
-returns a datetime instance, or an array of datetime instances with
-approximately millisecond accuracy.
-
-***Note***: The datetime instances returned are 'real' python datetime
-objects if `calendar='proleptic_gregorian'`, or
-`calendar='standard'` or `'gregorian'`
-and the date is after the breakpoint between the Julian and
-Gregorian calendars (1582-10-15). Otherwise, they are 'phony' datetime
-objects which support some but not all the methods of 'real' python
-datetime objects. The datetime instances
-do not contain a time-zone offset, even if the specified `units`
-contains one.
-    """
-    calendar = calendar.lower()
-    basedate = _dateparse(units)
-    unit = units.split()[0].lower()
-    # real-world calendars limited to positive reference years.
-    if calendar in ['julian', 'standard', 'gregorian', 'proleptic_gregorian']:
-        if basedate.year == 0:
-            msg='zero not allowed as a reference year, does not exist in Julian or Gregorian calendars'
-            raise ValueError(msg)
-        elif basedate.year < 0:
-            msg='negative reference year in time units, must be >= 1'
-            raise ValueError(msg)
-
-    postimes =  (numpy.asarray(times) > 0).all()
-    if postimes and ((calendar == 'proleptic_gregorian' and basedate.year >= MINYEAR) or \
-       (calendar in ['gregorian','standard'] and basedate > gregorian)):
-        # use python datetime module,
-        isscalar = False
-        try:
-            times[0]
-        except:
-            isscalar = True
-        if isscalar:
-            times = numpy.array([times],dtype='d')
-        else:
-            times = numpy.array(times, dtype='d')
-            shape = times.shape
-        ismasked = False
-        if hasattr(times,'mask'):
-            mask = times.mask
-            ismasked = True
-        dates = []
-        for time in times.flat:
-            if ismasked and not time:
-                dates.append(None)
-            else:
-                # convert to total seconds
-                if unit in microsec_units:
-                    tsecs = time/1.e6
-                elif unit in millisec_units:
-                    tsecs = time/1.e3
-                elif unit in sec_units:
-                    tsecs = time
-                elif unit in min_units:
-                    tsecs = time*60.
-                elif unit in hr_units:
-                    tsecs = time*3600.
-                elif unit in day_units:
-                    tsecs = time*86400.
-                else:
-                    raise ValueError('unsupported time units')
-                # compute time delta.
-                days = tsecs // 86400.
-                msecsd = tsecs*1.e6 - days*86400.*1.e6
-                secs = msecsd // 1.e6
-                msecs = numpy.round(msecsd - secs*1.e6)
-                td = timedelta(days=days,seconds=secs,microseconds=msecs)
-                # add time delta to base date.
-                date = basedate + td
-                dates.append(date)
-        if isscalar:
-            return dates[0]
-        else:
-            return numpy.reshape(numpy.array(dates), shape)
-    else: # use netcdftime for other calendars
-        cdftime = netcdftime.utime(units,calendar=calendar)
-        return cdftime.num2date(times)
-
-def date2index(dates, nctime, calendar=None, select='exact'):
-    """
-**`date2index(dates, nctime, calendar=None, select='exact')`**
-
-Return indices of a netCDF time variable corresponding to the given dates.
-
-**`dates`**: A datetime object or a sequence of datetime objects.
-The datetime objects should not include a time-zone offset.
-
-**`nctime`**: A netCDF time variable object. The nctime object must have a
-`units` attribute.
-
-**`calendar`**: describes the calendar used in the time calculations.
-All the values currently defined in the 
-[CF metadata convention](http://cfconventions.org)
-Valid calendars `'standard', 'gregorian', 'proleptic_gregorian'
-'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'`.
-Default is `'standard'`, which is a mixed Julian/Gregorian calendar.
-If `calendar` is None, its value is given by `nctime.calendar` or
-`standard` if no such attribute exists.
-
-**`select`**: `'exact', 'before', 'after', 'nearest'`
-The index selection method. `exact` will return the indices perfectly
-matching the dates given. `before` and `after` will return the indices
-corresponding to the dates just before or just after the given dates if
-an exact match cannot be found. `nearest` will return the indices that
-correspond to the closest dates.
-
-returns an index (indices) of the netCDF time variable corresponding
-to the given datetime object(s).
-    """
-    try: 
-        nctime.units
-    except AttributeError:
-        raise AttributeError("netcdf time variable is missing a 'units' attribute")
-    if calendar == None:
-        calendar = getattr(nctime, 'calendar', 'standard')
-    calendar = calendar.lower()
-    basedate = _dateparse(nctime.units)
-    # real-world calendars limited to positive reference years.
-    if calendar in ['julian', 'standard', 'gregorian', 'proleptic_gregorian']:
-        if basedate.year == 0:
-            msg='zero not allowed as a reference year, does not exist in Julian or Gregorian calendars'
-            raise ValueError(msg)
-        elif basedate.year < 0:
-            msg='negative reference year in time units, must be >= 1'
-            raise ValueError(msg)
-
-    if (calendar == 'proleptic_gregorian' and basedate.year >= MINYEAR) or \
-       (calendar in ['gregorian','standard'] and basedate > gregorian):
-        # use python datetime
-        times = date2num(dates,nctime.units,calendar=calendar)
-        return netcdftime.time2index(times, nctime, calendar, select)
-    else: # use netcdftime module for other cases
-        return netcdftime.date2index(dates, nctime, calendar, select)
-
 class MFDataset(Dataset):
     """
 Class for reading multi-file netCDF Datasets, making variables
diff -pruN 1.3.1-1/netCDF4/utils.py 1.4.0-1/netCDF4/utils.py
--- 1.3.1-1/netCDF4/utils.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/netCDF4/utils.py	2018-05-01 17:12:07.000000000 +0000
@@ -190,12 +190,13 @@ def _StartCountStride(elem, shape, dimen
     else:   # Convert single index to sequence
         elem = [elem]
     
-    hasEllipsis=False
-    for e in elem:
-        if type(e)==type(Ellipsis):
-            if hasEllipsis:
-                raise IndexError("At most one ellipsis allowed in a slicing expression")
-            hasEllipsis=True
+    # ensure there is at most 1 ellipse
+    #  we cannot use elem.count(Ellipsis), as with fancy indexing would occur
+    #  np.array() == Ellipsis which gives ValueError: The truth value of an 
+    #  array with more than one element is ambiguous. Use a.any() or a.all()
+    if sum(1 for e in elem if e is Ellipsis) > 1:
+        raise IndexError("At most one ellipsis allowed in a slicing expression")
+    
     # replace boolean arrays with sequences of integers.
     newElem = []
     IndexErrorMsg=\
@@ -526,9 +527,9 @@ def ncinfo():
                 print(f.dimensions[dim])
     else:
         if var is None and dim is None:
-            print(getgrp(f,group))
+            print(_getgrp(f,group))
         else:
-            g = getgrp(f,group)
+            g = _getgrp(f,group)
             if var is not None:
                 print(g.variables[var])
             if dim is not None:
@@ -743,11 +744,18 @@ def _nc3tonc4(filename3,filename4,unpack
         if dounpackshort:
             if not quiet: sys.stdout.write('unpacking short integers to floats ...\n')
             sys.stdout.write('')
+        # is there missing value?
         if hasattr(ncvar, '_FillValue'):
-            FillValue = ncvar._FillValue
+            fillvalue3 = ncvar._FillValue
+        elif hasattr(ncvar, 'missing_value'):
+            fillvalue3 = ncvar.missing_value
+        else:
+            fillvalue3 = None
+        if fillvalue3 is not None:
+            fillvalue4 = fillvalue3 if not dounpackshort else mval
         else:
-            FillValue = None
-        var = ncfile4.createVariable(varname,datatype,ncvar.dimensions, fill_value=FillValue, least_significant_digit=lsd,zlib=zlib,complevel=complevel,shuffle=shuffle,fletcher32=fletcher32)
+            fillvalue4 = None
+        var = ncfile4.createVariable(varname,datatype,ncvar.dimensions, fill_value=fillvalue4, least_significant_digit=lsd,zlib=zlib,complevel=complevel,shuffle=shuffle,fletcher32=fletcher32)
         # fill variable attributes.
         attdict = ncvar.__dict__
         if '_FillValue' in attdict: del attdict['_FillValue']
@@ -756,15 +764,8 @@ def _nc3tonc4(filename3,filename4,unpack
         if dounpackshort and 'scale_factor' in attdict:
             del attdict['scale_factor']
         if dounpackshort and 'missing_value' in attdict:
-            attdict['missing_value']=mval
+            attdict['missing_value'] = fillvalue4
         var.setncatts(attdict)
-        #for attname in ncvar.ncattrs():
-        #    if attname == '_FillValue': continue
-        #    if dounpackshort and attname in ['add_offset','scale_factor']: continue
-        #    if dounpackshort and attname == 'missing_value':
-        #        setattr(var,attname,mval)
-        #    else:
-        #        setattr(var,attname,getattr(ncvar,attname))
         # fill variables with data.
         if hasunlimdim: # has an unlim dim, loop over unlim dim index.
             # range to copy
@@ -774,32 +775,11 @@ def _nc3tonc4(filename3,filename4,unpack
                 for n in range(start, stop, step):
                     nmax = n+nchunk
                     if nmax > istop: nmax=istop
-                    idata = ncvar[n:nmax]
-                    if dounpackshort:
-                        tmpdata = (ncvar.scale_factor*idata.astype('f')+ncvar.add_offset).astype('f')
-                        if hasattr(ncvar,'missing_value'):
-                            tmpdata = np.where(idata == ncvar.missing_value, mval, tmpdata)
-                    else:
-                        tmpdata = idata
-                    var[n-istart:nmax-istart] = tmpdata
+                    var[n-istart:nmax-istart] = ncvar[n:nmax]
             else:
-                idata = ncvar[:]
-                if dounpackshort:
-                    tmpdata = (ncvar.scale_factor*idata.astype('f')+ncvar.add_offset).astype('f')
-                    if hasattr(ncvar,'missing_value'):
-                        tmpdata = np.where(idata == ncvar.missing_value, mval, tmpdata)
-                else:
-                    tmpdata = idata
-                var[0:len(unlimdim)] = tmpdata
+                var[0:len(unlimdim)] = ncvar[:]
         else: # no unlim dim or 1-d variable, just copy all data at once.
-            idata = ncvar[:]
-            if dounpackshort:
-                tmpdata = (ncvar.scale_factor*idata.astype('f')+ncvar.add_offset).astype('f')
-                if hasattr(ncvar,'missing_value'):
-                    tmpdata = np.where(idata == ncvar.missing_value, mval, tmpdata)
-            else:
-                tmpdata = idata
-            var[:] = tmpdata
+            var[:] = ncvar[:]
         ncfile4.sync() # flush data to disk
     # close files.
     ncfile3.close()
diff -pruN 1.3.1-1/netcdftime/__init__.py 1.4.0-1/netcdftime/__init__.py
--- 1.3.1-1/netcdftime/__init__.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/netcdftime/__init__.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,8 +0,0 @@
-from ._netcdftime import utime, JulianDayFromDate, DateFromJulianDay
-from ._netcdftime import _parse_date, date2index, time2index
-from ._netcdftime import DatetimeProlepticGregorian as datetime
-from ._netcdftime import DatetimeNoLeap, DatetimeAllLeap, Datetime360Day, DatetimeJulian, \
-                         DatetimeGregorian, DatetimeProlepticGregorian
-from ._netcdftime import microsec_units, millisec_units, \
-                         sec_units, hr_units, day_units, min_units
-from ._netcdftime import __version__
diff -pruN 1.3.1-1/netcdftime/_netcdftime.pyx 1.4.0-1/netcdftime/_netcdftime.pyx
--- 1.3.1-1/netcdftime/_netcdftime.pyx	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/netcdftime/_netcdftime.pyx	1970-01-01 00:00:00.000000000 +0000
@@ -1,1705 +0,0 @@
-"""
-Performs conversions of netCDF time coordinate data to/from datetime objects.
-"""
-
-from cpython.object cimport PyObject_RichCompare
-
-import numpy as np
-import math
-import numpy
-import re
-
-from datetime import datetime as real_datetime
-from datetime import timedelta
-import time                     # strftime
-
-try:
-    from itertools import izip as zip
-except ImportError:  # python 3.x
-    pass
-
-microsec_units = ['microseconds','microsecond', 'microsec', 'microsecs']
-millisec_units = ['milliseconds', 'millisecond', 'millisec', 'millisecs']
-sec_units =      ['second', 'seconds', 'sec', 'secs', 's']
-min_units =      ['minute', 'minutes', 'min', 'mins']
-hr_units =       ['hour', 'hours', 'hr', 'hrs', 'h']
-day_units =      ['day', 'days', 'd']
-_units = microsec_units+millisec_units+sec_units+min_units+hr_units+day_units
-_calendars = ['standard', 'gregorian', 'proleptic_gregorian',
-              'noleap', 'julian', 'all_leap', '365_day', '366_day', '360_day']
-
-__version__ = '1.4.1'
-
-# Adapted from http://delete.me.uk/2005/03/iso8601.html
-# Note: This regex ensures that all ISO8601 timezone formats are accepted -
-# but, due to legacy support for other timestrings, not all incorrect formats can be rejected.
-# For example, the TZ spec "+01:0" will still work even though the minutes value is only one character long.
-ISO8601_REGEX = re.compile(r"(?P<year>[+-]?[0-9]{1,4})(-(?P<month>[0-9]{1,2})(-(?P<day>[0-9]{1,2})"
-                           r"(((?P<separator1>.)(?P<hour>[0-9]{1,2}):(?P<minute>[0-9]{1,2})(:(?P<second>[0-9]{1,2})(\.(?P<fraction>[0-9]+))?)?)?"
-                           r"((?P<separator2>.?)(?P<timezone>Z|(([-+])([0-9]{2})((:([0-9]{2}))|([0-9]{2}))?)))?)?)?)?"
-                           )
-# Note: The re module apparently does not support branch reset groups that allow
-# redifinition of the same group name in alternative branches as PCRE does.
-# Using two different group names is also somewhat ugly, but other solutions might
-# hugely inflate the expression. feel free to contribute a better solution.
-TIMEZONE_REGEX = re.compile(
-       "(?P<prefix>[+-])(?P<hours>[0-9]{2})(?:(?::(?P<minutes1>[0-9]{2}))|(?P<minutes2>[0-9]{2}))?")
-
-def JulianDayFromDate(date, calendar='standard'):
-    """
-
-    creates a Julian Day from a 'datetime-like' object.  Returns the fractional
-    Julian Day (approximately millisecond accuracy).
-
-    if calendar='standard' or 'gregorian' (default), Julian day follows Julian
-    Calendar on and before 1582-10-5, Gregorian calendar after 1582-10-15.
-
-    if calendar='proleptic_gregorian', Julian Day follows gregorian calendar.
-
-    if calendar='julian', Julian Day follows julian calendar.
-
-    Algorithm:
-
-    Meeus, Jean (1998) Astronomical Algorithms (2nd Edition). Willmann-Bell,
-    Virginia. p. 63
-
-    """
-
-    # based on redate.py by David Finlayson.
-
-    # check if input was scalar and change return accordingly
-    isscalar = False
-    try:
-        date[0]
-    except:
-        isscalar = True
-
-    date = np.atleast_1d(np.array(date))
-    year = np.empty(len(date), dtype=np.int32)
-    month = year.copy()
-    day = year.copy()
-    hour = year.copy()
-    minute = year.copy()
-    second = year.copy()
-    microsecond = year.copy()
-    for i, d in enumerate(date):
-        year[i] = d.year
-        month[i] = d.month
-        day[i] = d.day
-        hour[i] = d.hour
-        minute[i] = d.minute
-        second[i] = d.second
-        microsecond[i] = d.microsecond
-    # convert years in BC era to astronomical years (so that 1 BC is year zero)
-    # (fixes issue #596)
-    year[year < 0] = year[year < 0] + 1
-    # Convert time to fractions of a day
-    day = day + hour / 24.0 + minute / 1440.0 + (second + microsecond/1.e6) / 86400.0
-
-    # Start Meeus algorithm (variables are in his notation)
-    month_lt_3 = month < 3
-    month[month_lt_3] = month[month_lt_3] + 12
-    year[month_lt_3] = year[month_lt_3] - 1
-
-    # MC - assure array
-    # A = np.int64(year / 100)
-    A = (year / 100).astype(np.int64)
-
-    # MC
-    # jd = int(365.25 * (year + 4716)) + int(30.6001 * (month + 1)) + \
-    #      day - 1524.5
-    jd = 365. * year + np.int32(0.25 * year + 2000.) + np.int32(30.6001 * (month + 1)) + \
-        day + 1718994.5
-
-    # optionally adjust the jd for the switch from
-    # the Julian to Gregorian Calendar
-    # here assumed to have occurred the day after 1582 October 4
-    if calendar in ['standard', 'gregorian']:
-        # MC - do not have to be contiguous dates
-        # if np.min(jd) >= 2299170.5:
-        #     # 1582 October 15 (Gregorian Calendar)
-        #     B = 2 - A + np.int32(A / 4)
-        # elif np.max(jd) < 2299160.5:
-        #     # 1582 October 5 (Julian Calendar)
-        #     B = np.zeros(len(jd))
-        # else:
-        #     print(date, calendar, jd)
-        #     raise ValueError(
-        #         'impossible date (falls in gap between end of Julian calendar and beginning of Gregorian calendar')
-        if np.any((jd >= 2299160.5) & (jd < 2299170.5)): # missing days in Gregorian calendar
-            raise ValueError(
-                'impossible date (falls in gap between end of Julian calendar and beginning of Gregorian calendar')
-        B = np.zeros(len(jd))             # 1582 October 5 (Julian Calendar)
-        ii = np.where(jd >= 2299170.5)[0] # 1582 October 15 (Gregorian Calendar)
-        if ii.size>0:
-            B[ii] = 2 - A[ii] + np.int32(A[ii] / 4)
-    elif calendar == 'proleptic_gregorian':
-        B = 2 - A + np.int32(A / 4)
-    elif calendar == 'julian':
-        B = np.zeros(len(jd))
-    else:
-        raise ValueError(
-            'unknown calendar, must be one of julian,standard,gregorian,proleptic_gregorian, got %s' % calendar)
-
-    # adjust for Julian calendar if necessary
-    jd = jd + B
-
-    # Add a small offset (proportional to Julian date) for correct re-conversion.
-    # This is about 45 microseconds in 2000 for Julian date starting -4712.
-    # (pull request #433).
-    eps = np.finfo(float).eps
-    eps = np.maximum(eps*jd, eps)
-    jd += eps
-
-    if isscalar:
-        return jd[0]
-    else:
-        return jd
-
-
-cdef _NoLeapDayFromDate(date):
-    """
-
-creates a Julian Day for a calendar with no leap years from a datetime
-instance.  Returns the fractional Julian Day (approximately millisecond accuracy).
-
-    """
-
-    year = date.year
-    month = date.month
-    day = date.day
-    hour = date.hour
-    minute = date.minute
-    second = date.second
-    microsecond = date.microsecond
-    # Convert time to fractions of a day
-    day = day + hour / 24.0 + minute / 1440.0 + (second + microsecond/1.e6) / 86400.0
-
-    # Start Meeus algorithm (variables are in his notation)
-    if (month < 3):
-        month = month + 12
-        year = year - 1
-
-    jd = int(365. * (year + 4716)) + int(30.6001 * (month + 1)) + \
-        day - 1524.5
-
-    return jd
-
-
-cdef _AllLeapFromDate(date):
-    """
-
-creates a Julian Day for a calendar where all years have 366 days from
-a 'datetime-like' object.
-Returns the fractional Julian Day (approximately millisecond accuracy).
-
-    """
-
-    year = date.year
-    month = date.month
-    day = date.day
-    hour = date.hour
-    minute = date.minute
-    second = date.second
-    microsecond = date.microsecond
-    # Convert time to fractions of a day
-    day = day + hour / 24.0 + minute / 1440.0 + (second + microsecond/1.e6) / 86400.0
-
-    # Start Meeus algorithm (variables are in his notation)
-    if (month < 3):
-        month = month + 12
-        year = year - 1
-
-    jd = int(366. * (year + 4716)) + int(30.6001 * (month + 1)) + \
-        day - 1524.5
-
-    return jd
-
-
-cdef _360DayFromDate(date):
-    """
-
-creates a Julian Day for a calendar where all months have 30 days from
-a 'datetime-like' object.
-Returns the fractional Julian Day (approximately millisecond accuracy).
-
-    """
-
-    year = date.year
-    month = date.month
-    day = date.day
-    hour = date.hour
-    minute = date.minute
-    second = date.second
-    microsecond = date.microsecond
-    # Convert time to fractions of a day
-    day = day + hour / 24.0 + minute / 1440.0 + (second + microsecond/1.e6) / 86400.0
-
-    jd = int(360. * (year + 4716)) + int(30. * (month - 1)) + day
-
-    return jd
-
-
-def DateFromJulianDay(JD, calendar='standard'):
-    """
-
-    returns a 'datetime-like' object given Julian Day. Julian Day is a
-    fractional day with approximately millisecond accuracy.
-
-    if calendar='standard' or 'gregorian' (default), Julian day follows Julian
-    Calendar on and before 1582-10-5, Gregorian calendar after  1582-10-15.
-
-    if calendar='proleptic_gregorian', Julian Day follows gregorian calendar.
-
-    if calendar='julian', Julian Day follows julian calendar.
-
-    The datetime object is a 'real' datetime object if the date falls in
-    the Gregorian calendar (i.e. calendar='proleptic_gregorian', or
-    calendar = 'standard'/'gregorian' and the date is after 1582-10-15).
-    Otherwise, it's a 'phony' datetime object which is actually an instance
-    of netcdftime.datetime.
-
-
-    Algorithm:
-
-    Meeus, Jean (1998) Astronomical Algorithms (2nd Edition). Willmann-Bell,
-    Virginia. p. 63
-    """
-
-    # based on redate.py by David Finlayson.
-
-    julian = np.array(JD, dtype=float)
-
-    if np.min(julian) < 0:
-        raise ValueError('Julian Day must be positive')
-
-    dayofwk = np.atleast_1d(np.int32(np.fmod(np.int32(julian + 1.5), 7)))
-    # get the day (Z) and the fraction of the day (F)
-    # add 0.000005 which is 452 ms in case of jd being after
-    # second 23:59:59 of a day we want to round to the next day see issue #75
-    Z = np.atleast_1d(np.int32(np.round(julian)))
-    F = np.atleast_1d(julian + 0.5 - Z).astype(np.float64)
-    if calendar in ['standard', 'gregorian']:
-        # MC
-        # alpha = int((Z - 1867216.25)/36524.25)
-        # A = Z + 1 + alpha - int(alpha/4)
-        alpha = np.int32(((Z - 1867216.) - 0.25) / 36524.25)
-        A = Z + 1 + alpha - np.int32(0.25 * alpha)
-        # check if dates before oct 5th 1582 are in the array
-        ind_before = np.where(julian < 2299160.5)[0]
-        if len(ind_before) > 0:
-            A[ind_before] = Z[ind_before]
-
-    elif calendar == 'proleptic_gregorian':
-        # MC
-        # alpha = int((Z - 1867216.25)/36524.25)
-        # A = Z + 1 + alpha - int(alpha/4)
-        alpha = np.int32(((Z - 1867216.) - 0.25) / 36524.25)
-        A = Z + 1 + alpha - np.int32(0.25 * alpha)
-    elif calendar == 'julian':
-        A = Z
-    else:
-        raise ValueError(
-            'unknown calendar, must be one of julian,standard,gregorian,proleptic_gregorian, got %s' % calendar)
-
-    B = A + 1524
-    # MC
-    # C = int((B - 122.1)/365.25)
-    # D = int(365.25 * C)
-    C = np.atleast_1d(np.int32(6680. + ((B - 2439870.) - 122.1) / 365.25))
-    D = np.atleast_1d(np.int32(365 * C + np.int32(0.25 * C)))
-    E = np.atleast_1d(np.int32((B - D) / 30.6001))
-
-    # Convert to date
-    day = np.clip(B - D - np.int64(30.6001 * E) + F, 1, None)
-    nday = B - D - 123
-    dayofyr = nday - 305
-    ind_nday_before = np.where(nday <= 305)[0]
-    if len(ind_nday_before) > 0:
-        dayofyr[ind_nday_before] = nday[ind_nday_before] + 60
-    # MC
-    # if E < 14:
-    #     month = E - 1
-    # else:
-    #     month = E - 13
-
-    # if month > 2:
-    #     year = C - 4716
-    # else:
-    #     year = C - 4715
-    month = E - 1
-    month[month > 12] = month[month > 12] - 12
-    year = C - 4715
-    year[month > 2] = year[month > 2] - 1
-    year[year <= 0] = year[year <= 0] - 1
-
-    # a leap year?
-    leap = np.zeros(len(year),dtype=dayofyr.dtype)
-    leap[year % 4 == 0] = 1
-    if calendar == 'proleptic_gregorian':
-        leap[(year % 100 == 0) & (year % 400 != 0)] = 0
-    elif calendar in ['standard', 'gregorian']:
-        leap[(year % 100 == 0) & (year % 400 != 0) & (julian < 2299160.5)] = 0
-
-    inc_idx = np.where((leap == 1) & (month > 2))[0]
-    dayofyr[inc_idx] = dayofyr[inc_idx] + leap[inc_idx]
-
-    # Subtract the offset from JulianDayFromDate from the microseconds (pull
-    # request #433).
-    eps = np.finfo(float).eps
-    eps = np.maximum(eps*julian, eps)
-    hour = np.clip((F * 24.).astype(np.int64), 0, 23)
-    F   -= hour / 24.
-    minute = np.clip((F * 1440.).astype(np.int64), 0, 59)
-    # this is an overestimation due to added offset in JulianDayFromDate
-    second = np.clip((F - minute / 1440.) * 86400., 0, None)
-    microsecond = (second % 1)*1.e6
-    # remove the offset from the microsecond calculation.
-    microsecond = np.clip(microsecond - eps*86400.*1e6, 0, 999999)
-
-    # convert year, month, day, hour, minute, second to int32
-    year = year.astype(np.int32)
-    month = month.astype(np.int32)
-    day = day.astype(np.int32)
-    hour = hour.astype(np.int32)
-    minute = minute.astype(np.int32)
-    second = second.astype(np.int32)
-    microsecond = microsecond.astype(np.int32)
-
-    # check if input was scalar and change return accordingly
-    isscalar = False
-    try:
-        JD[0]
-    except:
-        isscalar = True
-
-    if calendar in 'proleptic_gregorian':
-        # FIXME: datetime.datetime does not support years < 1
-        if (year < 0).any():
-            datetime_type = DatetimeProlepticGregorian
-        else:
-            datetime_type = real_datetime
-    elif calendar in ('standard', 'gregorian'):
-        # return a 'real' datetime instance if calendar is proleptic
-        # Gregorian or Gregorian and all dates are after the
-        # Julian/Gregorian transition
-        if len(ind_before) == 0:
-            datetime_type = real_datetime
-        else:
-            datetime_type = DatetimeGregorian
-    elif calendar == "julian":
-        datetime_type = DatetimeJulian
-    else:
-        raise ValueError("unsupported calendar: {0}".format(calendar))
-
-    if not isscalar:
-        return np.array([datetime_type(*args)
-                         for args in
-                         zip(year, month, day, hour, minute, second,
-                             microsecond)])
-
-    else:
-        return datetime_type(year[0], month[0], day[0], hour[0],
-                             minute[0], second[0], microsecond[0])
-
-
-cdef _DateFromNoLeapDay(JD):
-    """
-
-returns a 'datetime-like' object given Julian Day for a calendar with no leap
-days. Julian Day is a fractional day with approximately millisecond accuracy.
-
-    """
-
-    # based on redate.py by David Finlayson.
-
-    if JD < 0:
-        year_offset = int(-JD) // 365 + 1
-        JD += year_offset * 365
-    else:
-        year_offset = 0
-
-    dayofwk = int(math.fmod(int(JD + 1.5), 7))
-    (F, Z) = math.modf(JD + 0.5)
-    Z = int(Z)
-    A = Z
-    B = A + 1524
-    C = int((B - 122.1) / 365.)
-    D = int(365. * C)
-    E = int((B - D) / 30.6001)
-
-    # Convert to date
-    day = B - D - int(30.6001 * E) + F
-    nday = B - D - 123
-    if nday <= 305:
-        dayofyr = nday + 60
-    else:
-        dayofyr = nday - 305
-    if E < 14:
-        month = E - 1
-    else:
-        month = E - 13
-
-    if month > 2:
-        year = C - 4716
-    else:
-        year = C - 4715
-
-    # Convert fractions of a day to time
-    (dfrac, days) = math.modf(day / 1.0)
-    (hfrac, hours) = math.modf(dfrac * 24.0)
-    (mfrac, minutes) = math.modf(hfrac * 60.0)
-    (sfrac, seconds) = math.modf(mfrac * 60.0)
-    microseconds = sfrac*1.e6
-
-    if year_offset > 0:
-        # correct dayofwk
-
-        # 365 mod 7 = 1, so the day of the week changes by one day for
-        # every year in year_offset
-        dayofwk -= int(math.fmod(year_offset, 7))
-
-        if dayofwk < 0:
-            dayofwk += 7
-
-    return DatetimeNoLeap(year - year_offset, month, int(days), int(hours), int(minutes),
-                          int(seconds), int(microseconds),dayofwk, dayofyr)
-
-
-cdef _DateFromAllLeap(JD):
-    """
-
-returns a 'datetime-like' object given Julian Day for a calendar where all
-years have 366 days.
-Julian Day is a fractional day with approximately millisecond accuracy.
-
-    """
-
-    # based on redate.py by David Finlayson.
-
-    if JD < 0:
-        raise ValueError('Julian Day must be positive')
-
-    dayofwk = int(math.fmod(int(JD + 1.5), 7))
-    (F, Z) = math.modf(JD + 0.5)
-    Z = int(Z)
-    A = Z
-    B = A + 1524
-    C = int((B - 122.1) / 366.)
-    D = int(366. * C)
-    E = int((B - D) / 30.6001)
-
-    # Convert to date
-    day = B - D - int(30.6001 * E) + F
-    nday = B - D - 123
-    if nday <= 305:
-        dayofyr = nday + 60
-    else:
-        dayofyr = nday - 305
-    if E < 14:
-        month = E - 1
-    else:
-        month = E - 13
-    if month > 2:
-        dayofyr = dayofyr + 1
-
-    if month > 2:
-        year = C - 4716
-    else:
-        year = C - 4715
-
-    # Convert fractions of a day to time
-    (dfrac, days) = math.modf(day / 1.0)
-    (hfrac, hours) = math.modf(dfrac * 24.0)
-    (mfrac, minutes) = math.modf(hfrac * 60.0)
-    (sfrac, seconds) = math.modf(mfrac * 60.0)
-    microseconds = sfrac*1.e6
-
-    return DatetimeAllLeap(year, month, int(days), int(hours), int(minutes),
-                           int(seconds), int(microseconds),dayofwk, dayofyr)
-
-
-cdef _DateFrom360Day(JD):
-    """
-
-returns a 'datetime-like' object given Julian Day for a calendar where all
-months have 30 days.
-Julian Day is a fractional day with approximately millisecond accuracy.
-
-    """
-
-    if JD < 0:
-        year_offset = int(-JD) // 360 + 1
-        JD += year_offset * 360
-    else:
-        year_offset = 0
-
-    #jd = int(360. * (year + 4716)) + int(30. * (month - 1)) + day
-    (F, Z) = math.modf(JD)
-    year = int((Z - 0.5) / 360.) - 4716
-    dayofyr = Z - (year + 4716) * 360
-    month = int((dayofyr - 0.5) / 30) + 1
-    day = dayofyr - (month - 1) * 30 + F
-
-    # Convert fractions of a day to time
-    (dfrac, days) = math.modf(day / 1.0)
-    (hfrac, hours) = math.modf(dfrac * 24.0)
-    (mfrac, minutes) = math.modf(hfrac * 60.0)
-    (sfrac, seconds) = math.modf(mfrac * 60.0)
-    microseconds = sfrac*1.e6
-
-    return Datetime360Day(year - year_offset, month, int(days), int(hours), int(minutes),
-                          int(seconds), int(microseconds), -1, dayofyr)
-
-
-cdef _dateparse(timestr):
-    """parse a string of the form time-units since yyyy-mm-dd hh:mm:ss
-    return a tuple (units,utc_offset, datetimeinstance)"""
-    timestr_split = timestr.split()
-    units = timestr_split[0].lower()
-    if units not in _units:
-        raise ValueError(
-            "units must be one of 'seconds', 'minutes', 'hours' or 'days' (or singular version of these), got '%s'" % units)
-    if timestr_split[1].lower() != 'since':
-        raise ValueError("no 'since' in unit_string")
-    # parse the date string.
-    n = timestr.find('since') + 6
-    year, month, day, hour, minute, second, utc_offset = _parse_date(
-        timestr[n:].strip())
-    return units, utc_offset, datetime(year, month, day, hour, minute, second)
-
-
-class utime:
-
-    """
-Performs conversions of netCDF time coordinate
-data to/from datetime objects.
-
-To initialize: C{t = utime(unit_string,calendar='standard')}
-
-where
-
-B{C{unit_string}} is a string of the form
-C{'time-units since <time-origin>'} defining the time units.
-
-Valid time-units are days, hours, minutes and seconds (the singular forms
-are also accepted). An example unit_string would be C{'hours
-since 0001-01-01 00:00:00'}.
-
-The B{C{calendar}} keyword describes the calendar used in the time calculations.
-All the values currently defined in the U{CF metadata convention
-<http://cf-pcmdi.llnl.gov/documents/cf-conventions/1.1/cf-conventions.html#time-coordinate>}
-are accepted. The default is C{'standard'}, which corresponds to the mixed
-Gregorian/Julian calendar used by the C{udunits library}. Valid calendars
-are:
-
-C{'gregorian'} or C{'standard'} (default):
-
-Mixed Gregorian/Julian calendar as defined by udunits.
-
-C{'proleptic_gregorian'}:
-
-A Gregorian calendar extended to dates before 1582-10-15. That is, a year
-is a leap year if either (i) it is divisible by 4 but not by 100 or (ii)
-it is divisible by 400.
-
-C{'noleap'} or C{'365_day'}:
-
-Gregorian calendar without leap years, i.e., all years are 365 days long.
-all_leap or 366_day Gregorian calendar with every year being a leap year,
-i.e., all years are 366 days long.
-
-C{'360_day'}:
-
-All years are 360 days divided into 30 day months.
-
-C{'julian'}:
-
-Proleptic Julian calendar, extended to dates after 1582-10-5. A year is a
-leap year if it is divisible by 4.
-
-The C{L{num2date}} and C{L{date2num}} class methods can used to convert datetime
-instances to/from the specified time units using the specified calendar.
-
-The datetime instances returned by C{num2date} are 'real' python datetime
-objects if the date falls in the Gregorian calendar (i.e.
-C{calendar='proleptic_gregorian', 'standard'} or C{'gregorian'} and
-the date is after 1582-10-15). Otherwise, they are 'phony' datetime
-objects which are actually instances of C{L{netcdftime.datetime}}.  This is
-because the python datetime module cannot handle the weird dates in some
-calendars (such as C{'360_day'} and C{'all_leap'}) which don't exist in any real
-world calendar.
-
-
-Example usage:
-
->>> from netcdftime import utime
->>> from datetime import  datetime
->>> cdftime = utime('hours since 0001-01-01 00:00:00')
->>> date = datetime.now()
->>> print date
-2016-10-05 08:46:27.245015
->>>
->>> t = cdftime.date2num(date)
->>> print t
-17669840.7742
->>>
->>> date = cdftime.num2date(t)
->>> print date
-2016-10-05 08:46:27.244996
->>>
-
-The resolution of the transformation operation is approximately a millisecond.
-
-Warning:  Dates between 1582-10-5 and 1582-10-15 do not exist in the
-C{'standard'} or C{'gregorian'} calendars.  An exception will be raised if you pass
-a 'datetime-like' object in that range to the C{L{date2num}} class method.
-
-Words of Wisdom from the British MetOffice concerning reference dates:
-
-"udunits implements the mixed Gregorian/Julian calendar system, as
-followed in England, in which dates prior to 1582-10-15 are assumed to use
-the Julian calendar. Other software cannot be relied upon to handle the
-change of calendar in the same way, so for robustness it is recommended
-that the reference date be later than 1582. If earlier dates must be used,
-it should be noted that udunits treats 0 AD as identical to 1 AD."
-
-@ivar origin: datetime instance defining the origin of the netCDF time variable.
-@ivar calendar:  the calendar used (as specified by the C{calendar} keyword).
-@ivar unit_string:  a string defining the the netCDF time variable.
-@ivar units:  the units part of C{unit_string} (i.e. 'days', 'hours', 'seconds').
-    """
-
-    def __init__(self, unit_string, calendar='standard'):
-        """
-@param unit_string: a string of the form
-C{'time-units since <time-origin>'} defining the time units.
-
-Valid time-units are days, hours, minutes and seconds (the singular forms
-are also accepted). An example unit_string would be C{'hours
-since 0001-01-01 00:00:00'}.
-
-@keyword calendar: describes the calendar used in the time calculations.
-All the values currently defined in the U{CF metadata convention
-<http://cf-pcmdi.llnl.gov/documents/cf-conventions/1.1/cf-conventions.html#time-coordinate>}
-are accepted. The default is C{'standard'}, which corresponds to the mixed
-Gregorian/Julian calendar used by the C{udunits library}. Valid calendars
-are:
- - C{'gregorian'} or C{'standard'} (default):
- Mixed Gregorian/Julian calendar as defined by udunits.
- - C{'proleptic_gregorian'}:
- A Gregorian calendar extended to dates before 1582-10-15. That is, a year
- is a leap year if either (i) it is divisible by 4 but not by 100 or (ii)
- it is divisible by 400.
- - C{'noleap'} or C{'365_day'}:
- Gregorian calendar without leap years, i.e., all years are 365 days long.
- - C{'all_leap'} or C{'366_day'}:
- Gregorian calendar with every year being a leap year, i.e.,
- all years are 366 days long.
- -C{'360_day'}:
- All years are 360 days divided into 30 day months.
- -C{'julian'}:
- Proleptic Julian calendar, extended to dates after 1582-10-5. A year is a
- leap year if it is divisible by 4.
-
-@returns: A class instance which may be used for converting times from netCDF
-units to datetime objects.
-        """
-        calendar = calendar.lower()
-        if calendar in _calendars:
-            self.calendar = calendar
-        else:
-            raise ValueError(
-                "calendar must be one of %s, got '%s'" % (str(_calendars), calendar))
-        units, tzoffset, self.origin = _dateparse(unit_string)
-        # real-world calendars limited to positive reference years.
-        if self.calendar in ['julian', 'standard', 'gregorian', 'proleptic_gregorian']:
-            if self.origin.year == 0:
-                msg='zero not allowed as a reference year, does not exist in Julian or Gregorian calendars'
-                raise ValueError(msg)
-            elif self.origin.year < 0:
-                msg='negative reference year in time units, must be >= 1'
-                raise ValueError(msg)
-        self.tzoffset = tzoffset  # time zone offset in minutes
-        self.units = units
-        self.unit_string = unit_string
-        if self.calendar in ['noleap', '365_day'] and self.origin.month == 2 and self.origin.day == 29:
-            raise ValueError(
-                'cannot specify a leap day as the reference time with the noleap calendar')
-        if self.calendar == '360_day' and self.origin.day > 30:
-            raise ValueError(
-                'there are only 30 days in every month with the 360_day calendar')
-        if self.calendar in ['noleap', '365_day']:
-            self._jd0 = _NoLeapDayFromDate(self.origin)
-        elif self.calendar in ['all_leap', '366_day']:
-            self._jd0 = _AllLeapFromDate(self.origin)
-        elif self.calendar == '360_day':
-            self._jd0 = _360DayFromDate(self.origin)
-        else:
-            self._jd0 = JulianDayFromDate(self.origin, calendar=self.calendar)
-
-    def date2num(self, date):
-        """
-        Returns C{time_value} in units described by L{unit_string}, using
-        the specified L{calendar}, given a 'datetime-like' object.
-
-        The datetime object must represent UTC with no time-zone offset.
-        If there is a time-zone offset implied by L{unit_string}, it will
-        be applied to the returned numeric values.
-
-        Resolution is approximately a millisecond.
-
-        If C{calendar = 'standard'} or C{'gregorian'} (indicating
-        that the mixed Julian/Gregorian calendar is to be used), an
-        exception will be raised if the 'datetime-like' object describes
-        a date between 1582-10-5 and 1582-10-15.
-
-        Works for scalars, sequences and numpy arrays.
-        Returns a scalar if input is a scalar, else returns a numpy array.
-        """
-        isscalar = False
-        try:
-            date[0]
-        except:
-            isscalar = True
-        if not isscalar:
-            date = numpy.array(date)
-            shape = date.shape
-        if self.calendar in ['julian', 'standard', 'gregorian', 'proleptic_gregorian']:
-            if isscalar:
-                jdelta = JulianDayFromDate(date, self.calendar) - self._jd0
-            else:
-                jdelta = JulianDayFromDate(
-                    date.flat, self.calendar) - self._jd0
-        elif self.calendar in ['noleap', '365_day']:
-            if isscalar:
-                if date.month == 2 and date.day == 29:
-                    raise ValueError(
-                        'there is no leap day in the noleap calendar')
-                jdelta = _NoLeapDayFromDate(date) - self._jd0
-            else:
-                jdelta = []
-                for d in date.flat:
-                    if d.month == 2 and d.day == 29:
-                        raise ValueError(
-                            'there is no leap day in the noleap calendar')
-                    jdelta.append(_NoLeapDayFromDate(d) - self._jd0)
-        elif self.calendar in ['all_leap', '366_day']:
-            if isscalar:
-                jdelta = _AllLeapFromDate(date) - self._jd0
-            else:
-                jdelta = [_AllLeapFromDate(d) - self._jd0 for d in date.flat]
-        elif self.calendar == '360_day':
-            if isscalar:
-                if date.day > 30:
-                    raise ValueError(
-                        'there are only 30 days in every month with the 360_day calendar')
-                jdelta = _360DayFromDate(date) - self._jd0
-            else:
-                jdelta = []
-                for d in date.flat:
-                    if d.day > 30:
-                        raise ValueError(
-                            'there are only 30 days in every month with the 360_day calendar')
-                    jdelta.append(_360DayFromDate(d) - self._jd0)
-        if not isscalar:
-            jdelta = numpy.array(jdelta)
-        # convert to desired units, add time zone offset.
-        if self.units in microsec_units:
-            jdelta = jdelta * 86400. * 1.e6  + self.tzoffset * 60. * 1.e6
-        elif self.units in millisec_units:
-            jdelta = jdelta * 86400. * 1.e3  + self.tzoffset * 60. * 1.e3
-        elif self.units in sec_units:
-            jdelta = jdelta * 86400. + self.tzoffset * 60.
-        elif self.units in min_units:
-            jdelta = jdelta * 1440. + self.tzoffset
-        elif self.units in hr_units:
-            jdelta = jdelta * 24. + self.tzoffset / 60.
-        elif self.units in day_units:
-            jdelta = jdelta + self.tzoffset / 1440.
-        else:
-            raise ValueError('unsupported time units')
-        if isscalar:
-            return jdelta
-        else:
-            return numpy.reshape(jdelta, shape)
-
-    def num2date(self, time_value):
-        """
-        Return a 'datetime-like' object given a C{time_value} in units
-        described by L{unit_string}, using L{calendar}.
-
-        dates are in UTC with no offset, even if L{unit_string} contains
-        a time zone offset from UTC.
-
-        Resolution is approximately a millisecond.
-
-        Works for scalars, sequences and numpy arrays.
-        Returns a scalar if input is a scalar, else returns a numpy array.
-
-        The datetime instances returned by C{num2date} are 'real' python datetime
-        objects if the date falls in the Gregorian calendar (i.e.
-        C{calendar='proleptic_gregorian'}, or C{calendar = 'standard'/'gregorian'} and
-        the date is after 1582-10-15). Otherwise, they are 'phony' datetime
-        objects which are actually instances of netcdftime.datetime.  This is
-        because the python datetime module cannot handle the weird dates in some
-        calendars (such as C{'360_day'} and C{'all_leap'}) which
-        do not exist in any real world calendar.
-        """
-        isscalar = False
-        try:
-            time_value[0]
-        except:
-            isscalar = True
-        ismasked = False
-        if hasattr(time_value, 'mask'):
-            mask = time_value.mask
-            ismasked = True
-        if not isscalar:
-            time_value = numpy.array(time_value, dtype='d')
-            shape = time_value.shape
-        # convert to desired units, subtract time zone offset.
-        if self.units in microsec_units:
-            jdelta = time_value / 86400000000. - self.tzoffset / 1440.
-        elif self.units in millisec_units:
-            jdelta = time_value / 86400000. - self.tzoffset / 1440.
-        elif self.units in sec_units:
-            jdelta = time_value / 86400. - self.tzoffset / 1440.
-        elif self.units in min_units:
-            jdelta = time_value / 1440. - self.tzoffset / 1440.
-        elif self.units in hr_units:
-            jdelta = time_value / 24. - self.tzoffset / 1440.
-        elif self.units in day_units:
-            jdelta = time_value - self.tzoffset / 1440.
-        else:
-            raise ValueError('unsupported time units')
-        jd = self._jd0 + jdelta
-        if self.calendar in ['julian', 'standard', 'gregorian', 'proleptic_gregorian']:
-            if not isscalar:
-                if ismasked:
-                    date = []
-                    for j, m in zip(jd.flat, mask.flat):
-                        if not m:
-                            date.append(DateFromJulianDay(j, self.calendar))
-                        else:
-                            date.append(None)
-                else:
-                    date = DateFromJulianDay(jd.flat, self.calendar)
-            else:
-                if ismasked and mask.item():
-                    date = None
-                else:
-                    date = DateFromJulianDay(jd, self.calendar)
-        elif self.calendar in ['noleap', '365_day']:
-            if not isscalar:
-                date = [_DateFromNoLeapDay(j) for j in jd.flat]
-            else:
-                date = _DateFromNoLeapDay(jd)
-        elif self.calendar in ['all_leap', '366_day']:
-            if not isscalar:
-                date = [_DateFromAllLeap(j) for j in jd.flat]
-            else:
-                date = _DateFromAllLeap(jd)
-        elif self.calendar == '360_day':
-            if not isscalar:
-                date = [_DateFrom360Day(j) for j in jd.flat]
-            else:
-                date = _DateFrom360Day(jd)
-        if isscalar:
-            return date
-        else:
-            return numpy.reshape(numpy.array(date), shape)
-
-
-cdef _parse_timezone(tzstring):
-    """Parses ISO 8601 time zone specs into tzinfo offsets
-
-    Adapted from pyiso8601 (http://code.google.com/p/pyiso8601/)
-    """
-    if tzstring == "Z":
-        return 0
-    # This isn't strictly correct, but it's common to encounter dates without
-    # time zones so I'll assume the default (which defaults to UTC).
-    if tzstring is None:
-        return 0
-    m = TIMEZONE_REGEX.match(tzstring)
-    prefix, hours, minutes1, minutes2 = m.groups()
-    hours = int(hours)
-# Note: Minutes don't have to be specified in tzstring, 
-# so if the group is not found it means minutes is 0.
-# Also, due to the timezone regex definition, there are two mutually
-# exclusive groups that might hold the minutes value, so check both.
-    minutes = int(minutes1) if minutes1 is not None else int(minutes2) if minutes2 is not None else 0
-    if prefix == "-":
-        hours = -hours
-        minutes = -minutes
-    return minutes + hours * 60.
-
-
-cpdef _parse_date(datestring):
-    """Parses ISO 8601 dates into datetime objects
-
-    The timezone is parsed from the date string, assuming UTC
-    by default.
-
-    Adapted from pyiso8601 (http://code.google.com/p/pyiso8601/)
-    """
-    if not isinstance(datestring, str) and not isinstance(datestring, unicode):
-        raise ValueError("Expecting a string %r" % datestring)
-    m = ISO8601_REGEX.match(datestring.strip())
-    if not m:
-        raise ValueError("Unable to parse date string %r" % datestring)
-    groups = m.groupdict()
-    tzoffset_mins = _parse_timezone(groups["timezone"])
-    if groups["hour"] is None:
-        groups["hour"] = 0
-    if groups["minute"] is None:
-        groups["minute"] = 0
-    if groups["second"] is None:
-        groups["second"] = 0
-    # if groups["fraction"] is None:
-    #    groups["fraction"] = 0
-    # else:
-    #    groups["fraction"] = int(float("0.%s" % groups["fraction"]) * 1e6)
-    iyear = int(groups["year"])
-    return iyear, int(groups["month"]), int(groups["day"]),\
-        int(groups["hour"]), int(groups["minute"]), int(groups["second"]),\
-        tzoffset_mins
-
-cdef _check_index(indices, times, nctime, calendar, select):
-    """Return True if the time indices given correspond to the given times,
-    False otherwise.
-
-    Parameters:
-
-    indices : sequence of integers
-    Positive integers indexing the time variable.
-
-    times : sequence of times.
-    Reference times.
-
-    nctime : netCDF Variable object
-    NetCDF time object.
-
-    calendar : string
-    Calendar of nctime.
-
-    select : string
-    Index selection method.
-    """
-    N = nctime.shape[0]
-    if (indices < 0).any():
-        return False
-
-    if (indices >= N).any():
-        return False
-
-    try:
-        t = nctime[indices]
-        nctime = nctime
-    # WORKAROUND TO CHANGES IN SLICING BEHAVIOUR in 1.1.2
-    # this may be unacceptably slow...
-    # if indices are unsorted, or there are duplicate
-    # values in indices, read entire time variable into numpy
-    # array so numpy slicing rules can be used.
-    except IndexError:
-        nctime = nctime[:]
-        t = nctime[indices]
-# if fancy indexing not available, fall back on this.
-#   t=[]
-#   for ind in indices:
-#       t.append(nctime[ind])
-
-    if select == 'exact':
-        return numpy.all(t == times)
-
-    elif select == 'before':
-        ta = nctime[numpy.clip(indices + 1, 0, N - 1)]
-        return numpy.all(t <= times) and numpy.all(ta > times)
-
-    elif select == 'after':
-        tb = nctime[numpy.clip(indices - 1, 0, N - 1)]
-        return numpy.all(t >= times) and numpy.all(tb < times)
-
-    elif select == 'nearest':
-        ta = nctime[numpy.clip(indices + 1, 0, N - 1)]
-        tb = nctime[numpy.clip(indices - 1, 0, N - 1)]
-        delta_after = ta - t
-        delta_before = t - tb
-        delta_check = numpy.abs(times - t)
-        return numpy.all(delta_check <= delta_after) and numpy.all(delta_check <= delta_before)
-
-
-def date2index(dates, nctime, calendar=None, select='exact'):
-    """
-    date2index(dates, nctime, calendar=None, select='exact')
-
-    Return indices of a netCDF time variable corresponding to the given dates.
-
-    @param dates: A datetime object or a sequence of datetime objects.
-    The datetime objects should not include a time-zone offset.
-
-    @param nctime: A netCDF time variable object. The nctime object must have a
-    C{units} attribute. The entries are assumed to be stored in increasing
-    order.
-
-    @param calendar: Describes the calendar used in the time calculation.
-    Valid calendars C{'standard', 'gregorian', 'proleptic_gregorian'
-    'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'}.
-    Default is C{'standard'}, which is a mixed Julian/Gregorian calendar
-    If C{calendar} is None, its value is given by C{nctime.calendar} or
-    C{standard} if no such attribute exists.
-
-    @param select: C{'exact', 'before', 'after', 'nearest'}
-    The index selection method. C{exact} will return the indices perfectly
-    matching the dates given. C{before} and C{after} will return the indices
-    corresponding to the dates just before or just after the given dates if
-    an exact match cannot be found. C{nearest} will return the indices that
-    correspond to the closest dates.
-    """
-    try:
-        nctime.units
-    except AttributeError:
-        raise AttributeError("netcdf time variable is missing a 'units' attribute")
-    # Setting the calendar.
-    if calendar == None:
-        calendar = getattr(nctime, 'calendar', 'standard')
-    cdftime = utime(nctime.units,calendar=calendar)
-    times = cdftime.date2num(dates)
-    return time2index(times, nctime, calendar=calendar, select=select)
-
-
-def time2index(times, nctime, calendar=None, select='exact'):
-    """
-    time2index(times, nctime, calendar=None, select='exact')
-
-    Return indices of a netCDF time variable corresponding to the given times.
-
-    @param times: A numeric time or a sequence of numeric times.
-
-    @param nctime: A netCDF time variable object. The nctime object must have a
-    C{units} attribute. The entries are assumed to be stored in increasing
-    order.
-
-    @param calendar: Describes the calendar used in the time calculation.
-    Valid calendars C{'standard', 'gregorian', 'proleptic_gregorian'
-    'noleap', '365_day', '360_day', 'julian', 'all_leap', '366_day'}.
-    Default is C{'standard'}, which is a mixed Julian/Gregorian calendar
-    If C{calendar} is None, its value is given by C{nctime.calendar} or
-    C{standard} if no such attribute exists.
-
-    @param select: C{'exact', 'before', 'after', 'nearest'}
-    The index selection method. C{exact} will return the indices perfectly
-    matching the times given. C{before} and C{after} will return the indices
-    corresponding to the times just before or just after the given times if
-    an exact match cannot be found. C{nearest} will return the indices that
-    correspond to the closest times.
-    """
-    try:
-        nctime.units
-    except AttributeError:
-        raise AttributeError("netcdf time variable is missing a 'units' attribute")
-    # Setting the calendar.
-    if calendar == None:
-        calendar = getattr(nctime, 'calendar', 'standard')
-
-    num = numpy.atleast_1d(times)
-    N = len(nctime)
-
-    # Trying to infer the correct index from the starting time and the stride.
-    # This assumes that the times are increasing uniformly.
-    if len(nctime) >= 2:
-        t0, t1 = nctime[:2]
-        dt = t1 - t0
-    else:
-        t0 = nctime[0]
-        dt = 1.
-    if select in ['exact', 'before']:
-        index = numpy.array((num - t0) / dt, int)
-    elif select == 'after':
-        index = numpy.array(numpy.ceil((num - t0) / dt), int)
-    else:
-        index = numpy.array(numpy.around((num - t0) / dt), int)
-
-    # Checking that the index really corresponds to the given time.
-    # If the times do not correspond, then it means that the times
-    # are not increasing uniformly and we try the bisection method.
-    if not _check_index(index, times, nctime, calendar, select):
-
-        # Use the bisection method. Assumes nctime is ordered.
-        import bisect
-        index = numpy.array([bisect.bisect_right(nctime, n) for n in num], int)
-        before = index == 0
-
-        index = numpy.array([bisect.bisect_left(nctime, n) for n in num], int)
-        after = index == N
-
-        if select in ['before', 'exact'] and numpy.any(before):
-            raise ValueError(
-                'Some of the times given are before the first time in `nctime`.')
-
-        if select in ['after', 'exact'] and numpy.any(after):
-            raise ValueError(
-                'Some of the times given are after the last time in `nctime`.')
-
-        # Find the times for which the match is not perfect.
-        # Use list comprehension instead of the simpler `nctime[index]` since
-        # not all time objects support numpy integer indexing (eg dap).
-        index[after] = N - 1
-        ncnum = numpy.squeeze([nctime[i] for i in index])
-        mismatch = numpy.nonzero(ncnum != num)[0]
-
-        if select == 'exact':
-            if len(mismatch) > 0:
-                raise ValueError(
-                    'Some of the times specified were not found in the `nctime` variable.')
-
-        elif select == 'before':
-            index[after] = N
-            index[mismatch] -= 1
-
-        elif select == 'after':
-            pass
-
-        elif select == 'nearest':
-            nearest_to_left = num[mismatch] < numpy.array(
-                [float(nctime[i - 1]) + float(nctime[i]) for i in index[mismatch]]) / 2.
-            index[mismatch] = index[mismatch] - 1 * nearest_to_left
-
-        else:
-            raise ValueError(
-                "%s is not an option for the `select` argument." % select)
-
-        # Correct for indices equal to -1
-        index[before] = 0
-
-    # convert numpy scalars or single element arrays to python ints.
-    return _toscalar(index)
-
-
-cdef _toscalar(a):
-    if a.shape in [(), (1,)]:
-        return a.item()
-    else:
-        return a
-
-cdef to_tuple(dt):
-    """Turn a datetime.datetime instance into a tuple of integers. Elements go
-    in the order of decreasing significance, making it easy to compare
-    datetime instances. Parts of the state that don't affect ordering
-    are omitted. Compare to datetime.timetuple()."""
-    return (dt.year, dt.month, dt.day, dt.hour, dt.minute,
-            dt.second, dt.microsecond)
-
-# a cache of converters (utime instances) for different calendars
-cdef dict _converters
-_converters = {}
-for calendar in _calendars:
-    _converters[calendar] = utime("seconds since 1-1-1", calendar)
-
-cdef class datetime(object):
-    """
-The base class implementing most methods of datetime classes that
-mimic datetime.datetime but support calendars other than the proleptic
-Gregorial calendar.
-    """
-    cdef readonly int year, month, day, hour, minute, dayofwk, dayofyr
-    cdef readonly int second, microsecond
-    cdef readonly str calendar
-
-    # Python's datetime.datetime uses the proleptic Gregorian
-    # calendar. This boolean is used to decide whether a
-    # netcdftime.datetime instance can be converted to
-    # datetime.datetime.
-    cdef readonly bint datetime_compatible
-
-    def __init__(self, int year, int month, int day, int hour=0, int minute=0, int second=0,
-                 int microsecond=0, int dayofwk=-1, int dayofyr=1):
-        """dayofyr set to 1 by default - otherwise time.strftime will complain"""
-
-        self.year = year
-        self.month = month
-        self.day = day
-        self.hour = hour
-        self.minute = minute
-        self.dayofwk = dayofwk
-        self.dayofyr = dayofyr
-        self.second = second
-        self.microsecond = microsecond
-        self.calendar = ""
-
-        self.datetime_compatible = True
-
-    @property
-    def format(self):
-        return '%Y-%m-%d %H:%M:%S'
-
-    def strftime(self, format=None):
-        if format is None:
-            format = self.format
-        return _strftime(self, format)
-
-    def replace(self, **kwargs):
-        "Return datetime with new specified fields."
-        args = {"year": self.year,
-                "month": self.month,
-                "day": self.day,
-                "hour": self.hour,
-                "minute": self.minute,
-                "second": self.second,
-                "microsecond": self.microsecond,
-                "dayofwk": self.dayofwk,
-                "dayofyr": self.dayofyr}
-
-        for name, value in kwargs.items():
-            args[name] = value
-
-        return self.__class__(**args)
-
-    def timetuple(self):
-        return (self.year, self.month, self.day, self.hour,
-                self.minute, self.second, self.dayofwk, self.dayofyr, -1)
-
-    cpdef _to_real_datetime(self):
-        return real_datetime(self.year, self.month, self.day,
-                             self.hour, self.minute, self.second,
-                             self.microsecond)
-
-    def __repr__(self):
-        return "{0}.{1}{2}".format(self.__class__.__module__,
-                                   self.__class__.__name__,
-                                   self._getstate())
-
-    def __str__(self):
-        return self.strftime(self.format)
-
-    def __hash__(self):
-        try:
-            d = self._to_real_datetime()
-        except ValueError:
-            return hash(self.timetuple())
-        return hash(d)
-
-    cdef to_tuple(self):
-        return (self.year, self.month, self.day, self.hour, self.minute,
-                self.second, self.microsecond)
-
-    def __richcmp__(self, other, int op):
-        cdef datetime dt, dt_other
-        dt = self
-        if isinstance(other, datetime):
-            dt_other = other
-            # comparing two datetime instances
-            if dt.calendar == dt_other.calendar:
-                return PyObject_RichCompare(dt.to_tuple(), dt_other.to_tuple(), op)
-            else:
-                # Note: it *is* possible to compare datetime
-                # instances that use difference calendars by using
-                # utime.date2num(), but this implementation does
-                # not attempt it.
-                raise TypeError("cannot compare {0!r} and {1!r} (different calendars)".format(dt, dt_other))
-        elif isinstance(other, real_datetime):
-            # comparing datetime and real_datetime
-            if not dt.datetime_compatible:
-                raise TypeError("cannot compare {0!r} and {1!r} (different calendars)".format(self, other))
-            return PyObject_RichCompare(dt.to_tuple(), to_tuple(other), op)
-        else:
-            raise TypeError("cannot compare {0!r} and {1!r}".format(self, other))
-
-    cdef _getstate(self):
-        return (self.year, self.month, self.day, self.hour,
-                self.minute, self.second, self.microsecond,
-                self.dayofwk, self.dayofyr)
-
-    def __reduce__(self):
-        """special method that allows instance to be pickled"""
-        return (self.__class__, self._getstate())
-
-    cdef _add_timedelta(self, other):
-        return NotImplemented
-
-    def __add__(self, other):
-        cdef datetime dt
-        if isinstance(self, datetime) and isinstance(other, timedelta):
-            dt = self
-            delta = other
-        elif isinstance(self, timedelta) and isinstance(other, datetime):
-            dt = other
-            delta = self
-        else:
-            return NotImplemented
-        return dt._add_timedelta(delta)
-
-    def __sub__(self, other):
-        cdef datetime dt
-        if isinstance(self, datetime): # left arg is a datetime instance
-            dt = self
-            if isinstance(other, datetime):
-                # datetime - datetime
-                if dt.calendar != other.calendar:
-                    raise ValueError("cannot compute the time difference between dates with different calendars")
-                if dt.calendar == "":
-                    raise ValueError("cannot compute the time difference between dates that are not calendar-aware")
-                converter = _converters[dt.calendar]
-                return timedelta(seconds=converter.date2num(dt) - converter.date2num(other))
-            elif isinstance(other, real_datetime):
-                # datetime - real_datetime
-                if not dt.datetime_compatible:
-                    raise ValueError("cannot compute the time difference between dates with different calendars")
-                return dt._to_real_datetime() - other
-            elif isinstance(other, timedelta):
-                # datetime - timedelta
-                return dt._add_timedelta(-other)
-            else:
-                return NotImplemented
-        else:
-            if isinstance(self, real_datetime):
-                # real_datetime - datetime
-                if not other.datetime_compatible:
-                    raise ValueError("cannot compute the time difference between dates with different calendars")
-                return self - other._to_real_datetime()
-            else:
-                return NotImplemented
-
-cdef class DatetimeNoLeap(datetime):
-    """
-Phony datetime object which mimics the python datetime object,
-but uses the "noleap" ("365_day") calendar.
-    """
-    def __init__(self, *args, **kwargs):
-        datetime.__init__(self, *args, **kwargs)
-        self.calendar = "noleap"
-        self.datetime_compatible = False
-
-    cdef _add_timedelta(self, delta):
-        return DatetimeNoLeap(*add_timedelta(self, delta, no_leap, False))
-
-cdef class DatetimeAllLeap(datetime):
-    """
-Phony datetime object which mimics the python datetime object,
-but uses the "all_leap" ("366_day") calendar.
-    """
-    def __init__(self, *args, **kwargs):
-        datetime.__init__(self, *args, **kwargs)
-        self.calendar = "all_leap"
-        self.datetime_compatible = False
-
-    cdef _add_timedelta(self, delta):
-        return DatetimeAllLeap(*add_timedelta(self, delta, all_leap, False))
-
-cdef class Datetime360Day(datetime):
-    """
-Phony datetime object which mimics the python datetime object,
-but uses the "360_day" calendar.
-    """
-    def __init__(self, *args, **kwargs):
-        datetime.__init__(self, *args, **kwargs)
-        self.calendar = "360_day"
-        self.datetime_compatible = False
-
-    cdef _add_timedelta(self, delta):
-        return Datetime360Day(*add_timedelta_360_day(self, delta))
-
-cdef class DatetimeJulian(datetime):
-    """
-Phony datetime object which mimics the python datetime object,
-but uses the "julian" calendar.
-    """
-    def __init__(self, *args, **kwargs):
-        datetime.__init__(self, *args, **kwargs)
-        self.calendar = "julian"
-        self.datetime_compatible = False
-
-    cdef _add_timedelta(self, delta):
-        return DatetimeJulian(*add_timedelta(self, delta, is_leap_julian, False))
-
-cdef class DatetimeGregorian(datetime):
-    """
-Phony datetime object which mimics the python datetime object,
-but uses the mixed Julian-Gregorian ("standard", "gregorian") calendar.
-
-The last date of the Julian calendar is 1582-10-4, which is followed
-by 1582-10-15, using the Gregorian calendar.
-
-Instances using the date after 1582-10-15 can be compared to
-datetime.datetime instances and used to compute time differences
-(datetime.timedelta) by subtracting a DatetimeGregorian instance from
-a datetime.datetime instance or vice versa.
-    """
-    def __init__(self, *args, **kwargs):
-        datetime.__init__(self, *args, **kwargs)
-        self.calendar = "gregorian"
-
-        # dates after 1582-10-15 can be converted to and compared to
-        # proleptic Gregorian dates
-        if self.to_tuple() >= (1582, 10, 15, 0, 0, 0, 0):
-            self.datetime_compatible = True
-        else:
-            self.datetime_compatible = False
-
-    cdef _add_timedelta(self, delta):
-        return DatetimeGregorian(*add_timedelta(self, delta, is_leap_gregorian, True))
-
-cdef class DatetimeProlepticGregorian(datetime):
-    """
-Phony datetime object which mimics the python datetime object,
-but allows for dates that don't exist in the proleptic gregorian calendar.
-
-Supports timedelta operations by overloading + and -.
-
-Has strftime, timetuple, replace, __repr__, and __str__ methods. The
-format of the string produced by __str__ is controlled by self.format
-(default %Y-%m-%d %H:%M:%S). Supports comparisons with other phony
-datetime instances using the same calendar; comparison with
-datetime.datetime instances is possible for netcdftime.datetime
-instances using 'gregorian' and 'proleptic_gregorian' calendars.
-
-Instance variables are year,month,day,hour,minute,second,microsecond,dayofwk,dayofyr,
-format, and calendar.
-    """
-    def __init__(self, *args, **kwargs):
-        datetime.__init__(self, *args, **kwargs)
-        self.calendar = "proleptic_gregorian"
-        self.datetime_compatible = True
-
-    cdef _add_timedelta(self, delta):
-        return DatetimeProlepticGregorian(*add_timedelta(self, delta,
-                                                         is_leap_proleptic_gregorian, False))
-
-_illegal_s = re.compile(r"((^|[^%])(%%)*%s)")
-
-
-cdef _findall(text, substr):
-    # Also finds overlaps
-    sites = []
-    i = 0
-    while 1:
-        j = text.find(substr, i)
-        if j == -1:
-            break
-        sites.append(j)
-        i = j + 1
-    return sites
-
-# Every 28 years the calendar repeats, except through century leap
-# years where it's 6 years.  But only if you're using the Gregorian
-# calendar.  ;)
-
-
-cdef _strftime(datetime dt, fmt):
-    if _illegal_s.search(fmt):
-        raise TypeError("This strftime implementation does not handle %s")
-    # don't use strftime method at all.
-    # if dt.year > 1900:
-    #    return dt.strftime(fmt)
-
-    year = dt.year
-    # For every non-leap year century, advance by
-    # 6 years to get into the 28-year repeat cycle
-    delta = 2000 - year
-    off = 6 * (delta // 100 + delta // 400)
-    year = year + off
-
-    # Move to around the year 2000
-    year = year + ((2000 - year) // 28) * 28
-    timetuple = dt.timetuple()
-    s1 = time.strftime(fmt, (year,) + timetuple[1:])
-    sites1 = _findall(s1, str(year))
-
-    s2 = time.strftime(fmt, (year + 28,) + timetuple[1:])
-    sites2 = _findall(s2, str(year + 28))
-
-    sites = []
-    for site in sites1:
-        if site in sites2:
-            sites.append(site)
-
-    s = s1
-    syear = "%4d" % (dt.year,)
-    for site in sites:
-        s = s[:site] + syear + s[site + 4:]
-    return s
-
-cdef bint is_leap_julian(int year):
-    "Return 1 if year is a leap year in the Julian calendar, 0 otherwise."
-    cdef int y
-    y = year if year > 0 else year + 1
-    return (y % 4) == 0
-
-cdef bint is_leap_proleptic_gregorian(int year):
-    "Return 1 if year is a leap year in the Gregorian calendar, 0 otherwise."
-    cdef int y
-    y = year if year > 0 else year + 1
-    return (((y % 4) == 0) and ((y % 100) != 0)) or ((y % 400) == 0)
-
-cdef bint is_leap_gregorian(int year):
-    return (year > 1582 and is_leap_proleptic_gregorian(year)) or (year < 1582 and is_leap_julian(year))
-
-cdef bint all_leap(int year):
-    "Return True for all years."
-    return True
-
-cdef bint no_leap(int year):
-    "Return False for all years."
-    return False
-
-# numbers of days per month for calendars supported by add_timedelta(...)
-cdef int[13] month_lengths_365_day, month_lengths_366_day
-#                  Dummy Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec
-for j,N in enumerate([-1, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]):
-    month_lengths_365_day[j] = N
-
-#                  Dummy Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec
-for j,N in enumerate([-1, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]):
-    month_lengths_366_day[j] = N
-
-cdef int* month_lengths(bint (*is_leap)(int), int year):
-    if is_leap(year):
-        return month_lengths_366_day
-    else:
-        return month_lengths_365_day
-
-# Add a datetime.timedelta to a netcdftime.datetime instance. Uses
-# integer arithmetic to avoid rounding errors and preserve
-# microsecond accuracy.
-#
-# The argument is_leap is the pointer to a function returning 1 for leap years and 0 otherwise.
-#
-# This implementation supports 365_day (no_leap), 366_day (all_leap),
-# julian, proleptic_gregorian, and the mixed Julian/Gregorian
-# (standard, gregorian) calendars by using different is_leap and
-# julian_gregorian_mixed arguments.
-#
-# The date of the transition from the Julian to Gregorian calendar and
-# the number of invalid dates are hard-wired (1582-10-4 is the last day
-# of the Julian calendar, after which follows 1582-10-15).
-cdef tuple add_timedelta(datetime dt, delta, bint (*is_leap)(int), bint julian_gregorian_mixed):
-    cdef int microsecond, second, minute, hour, day, month, year
-    cdef int delta_microseconds, delta_seconds, delta_days
-    cdef int* month_length
-    cdef int extra_days, n_invalid_dates
-
-    # extract these inputs here to avoid type conversion in the code below
-    delta_microseconds = delta.microseconds
-    delta_seconds = delta.seconds
-    delta_days = delta.days
-
-    # shift microseconds, seconds, days
-    microsecond = dt.microsecond + delta_microseconds
-    second = dt.second + delta_seconds
-    minute = dt.minute
-    hour = dt.hour
-    day = dt.day
-    month = dt.month
-    year = dt.year
-
-    # validate inputs:
-    if year == 0:
-        raise ValueError("invalid year in {0!r}".format(dt))
-
-    month_length = month_lengths(is_leap, year)
-
-    if month < 1 or month > 12:
-        raise ValueError("invalid month in {0!r}".format(dt))
-
-    if day < 1 or day > month_length[month]:
-        raise ValueError("invalid day number in {0!r}".format(dt))
-
-    if julian_gregorian_mixed and year == 1582 and month == 10 and day > 4 and day < 15:
-        raise ValueError("{0!r} is not present in the mixed Julian/Gregorian calendar".format(dt))
-
-    n_invalid_dates = 10 if julian_gregorian_mixed else 0
-
-    # Normalize microseconds, seconds, minutes, hours.
-    second += microsecond // 1000000
-    microsecond = microsecond % 1000000
-    minute += second // 60
-    second = second % 60
-    hour += minute // 60
-    minute = minute % 60
-    extra_days = hour // 24
-    hour = hour % 24
-
-    delta_days += extra_days
-
-    while delta_days < 0:
-        if year == 1582 and month == 10 and day > 14 and day + delta_days < 15:
-            delta_days -= n_invalid_dates    # skip over invalid dates
-        if day + delta_days < 1:
-            delta_days += day
-            # decrement month
-            month -= 1
-            if month < 1:
-                month = 12
-                year -= 1
-                if year == 0:
-                    year = -1
-                month_length = month_lengths(is_leap, year)
-            day = month_length[month]
-        else:
-            day += delta_days
-            delta_days = 0
-
-    while delta_days > 0:
-        if year == 1582 and month == 10 and day < 5 and day + delta_days > 4:
-            delta_days += n_invalid_dates    # skip over invalid dates
-        if day + delta_days > month_length[month]:
-            delta_days -= month_length[month] - (day - 1)
-            # increment month
-            month += 1
-            if month > 12:
-                month = 1
-                year += 1
-                if year == 0:
-                    year = 1
-                month_length = month_lengths(is_leap, year)
-            day = 1
-        else:
-            day += delta_days
-            delta_days = 0
-
-    return (year, month, day, hour, minute, second, microsecond, -1, 1)
-
-# Add a datetime.timedelta to a netcdftime.datetime instance with the 360_day calendar.
-#
-# Assumes that the 360_day calendar (unlike the rest of supported
-# calendars) has the year 0. Also, there are no leap years and all
-# months are 30 days long, so we can compute month and year by using
-# "//" and "%".
-cdef tuple add_timedelta_360_day(datetime dt, delta):
-    cdef int microsecond, second, minute, hour, day, month, year
-    cdef int delta_microseconds, delta_seconds, delta_days
-
-    assert dt.month >= 1 and dt.month <= 12
-
-    # extract these inputs here to avoid type conversion in the code below
-    delta_microseconds = delta.microseconds
-    delta_seconds = delta.seconds
-    delta_days = delta.days
-
-    # shift microseconds, seconds, days
-    microsecond = dt.microsecond + delta_microseconds
-    second = dt.second + delta_seconds
-    minute = dt.minute
-    hour = dt.hour
-    day = dt.day + delta_days
-    month = dt.month
-    year = dt.year
-
-    # Normalize microseconds, seconds, minutes, hours, days, and months.
-    second += microsecond // 1000000
-    microsecond = microsecond % 1000000
-    minute += second // 60
-    second = second % 60
-    hour += minute // 60
-    minute = minute % 60
-    day += hour // 24
-    hour = hour % 24
-    # day and month are counted from 1; all months have 30 days
-    month += (day - 1) // 30
-    day = (day - 1) % 30 + 1
-    # all years have 12 months
-    year += (month - 1) // 12
-    month = (month - 1) % 12 + 1
-
-    return (year, month, day, hour, minute, second, microsecond, -1, 1)
diff -pruN 1.3.1-1/PKG-INFO 1.4.0-1/PKG-INFO
--- 1.3.1-1/PKG-INFO	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/PKG-INFO	2018-05-01 17:12:07.000000000 +0000
@@ -1,6 +1,6 @@
 Metadata-Version: 1.1
 Name: netCDF4
-Version: 1.3.1
+Version: 1.4.0
 Author: Jeff Whitaker
 Author-email: jeffrey s whitaker at noaa gov
 Home-page: https://github.com/Unidata/netcdf4-python
diff -pruN 1.3.1-1/README.md 1.4.0-1/README.md
--- 1.3.1-1/README.md	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/README.md	2018-05-01 17:12:07.000000000 +0000
@@ -1,4 +1,4 @@
-# netcdf4-python
+# [netcdf4-python](http://unidata.github.io/netcdf4-python)
 [Python](http://python.org)/[numpy](http://numpy.org) interface to the netCDF [C library](https://github.com/Unidata/netcdf-c).
 
 [![Linux Build Status](https://travis-ci.org/Unidata/netcdf4-python.svg?branch=master)](https://travis-ci.org/Unidata/netcdf4-python)
@@ -8,7 +8,33 @@
 ## News
 For details on the latest updates, see the [Changelog](https://github.com/Unidata/netcdf4-python/blob/master/Changelog).
 
-11/01/2017: Version 1.3.1 released.  Parallel IO support with MPI!
+??/??/2018: Version [1.4.0](https://pypi.python.org/pypi/netCDF4/1.4.0) released. The netcdftime package is no longer
+included, it is now a separate [package](https://pypi.python.org/pypi/cftime) dependency.  In addition to several
+bug fixes, there are a few important changes to the default behaviour to note:
+ * Slicing a netCDF variable will now always return masked array by default, even if there are no 
+   masked values.  The result depended on the slice before, which was too surprising.
+   If auto-masking is turned off (with `set_auto_mask(False)`) a numpy array will always
+   be returned.
+ * `_FillValue` is no longer treated as a valid_min/valid_max.  This was  too surprising, despite
+   the fact the thet netcdf docs [attribute best practices](https://www.unidata.ucar.edu/software/netcdf/docs/attribute_conventions.html) suggests that
+   clients should to this if `valid_min`, `valid_max` and `valid_range` are not set. 
+ * Changed behavior of string attributes so that `nc.stringatt = ['foo','bar']`
+   produces an vlen string array attribute in NETCDF4, instead of concatenating
+   into a single string (`foobar`).  In NETCDF3/NETCDF4_CLASSIC, an IOError
+   is now raised, instead of writing `foobar`.
+ * Retrieved compound-type variable data now returned with character array elements converted to 
+   numpy strings ([issue #773](https://github.com/Unidata/netcdf4-python/issues/773)).
+   Works for assignment also.  Can be disabled using
+   `set_auto_chartostring(False)`. Numpy structured
+   array dtypes with `'SN'` string subtypes can now be used to
+   define netcdf compound types in `createCompoundType` (they get converted to `('S1',N)`
+   character array types automatically).
+ * `valid_min`, `valid_max`, `_FillValue` and `missing_value` are now treated as unsigned
+   integers if `_Unsigned` variable attribute is set (to mimic behaviour of netcdf-java).
+   Conversion to unsigned type now occurs before masking and scale/offset
+   operation ([issue #794](https://github.com/Unidata/netcdf4-python/issues/794))
+
+11/01/2017: Version [1.3.1](https://pypi.python.org/pypi/netCDF4/1.3.1) released.  Parallel IO support with MPI!
 Requires that netcdf-c and hdf5 be built with MPI support, and [mpi4py](http://mpi4py.readthedocs.io/en/stable).
 To open a file for parallel access in a program running in an MPI environment
 using mpi4py, just use `parallel=True` when creating
diff -pruN 1.3.1-1/README.release 1.4.0-1/README.release
--- 1.3.1-1/README.release	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/README.release	2018-05-01 17:12:07.000000000 +0000
@@ -1,9 +1,7 @@
 * create a release branch ('vX.Y.Zrel').  In the release branch...
-* make sure version number in setup.py and netCDF4/_netCDF4.pyx are up to date
+* make sure version number in PKG-INFO, setup.py and netCDF4/_netCDF4.pyx are up to date
   (in _netCDF4.pyx, change 'Version' in first line of docstring at top of file,
-   and __version__ variable). If netcdftime module has any updates,
-  increment __version__ in netcdftime/_netcdftime.pyx. Update version number in 
-  PKG_INFO.
+   and __version__ variable).
 * update Changelog and README.md as needed. 
 * commit and push all of the above changes.
 * install the module (python setup.py install), then run 'sh create_docs.sh'
diff -pruN 1.3.1-1/setup.py 1.4.0-1/setup.py
--- 1.3.1-1/setup.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/setup.py	2018-05-01 17:12:07.000000000 +0000
@@ -4,7 +4,7 @@ from setuptools import setup, Extension
 from distutils.dist import Distribution
 
 setuptools_extra_kwargs = {
-    "install_requires": ["numpy>=1.7"],
+    "install_requires": ["numpy>=1.7","cftime"],
     "setup_requires": ['setuptools>=18.0', "cython>=0.19"],
     "entry_points": {
         'console_scripts': [
@@ -78,10 +78,9 @@ def check_api(inc_dirs):
 
         ncmetapath = os.path.join(d,'netcdf_meta.h')
         if os.path.exists(ncmetapath):
-            has_cdf5 = False
             for line in open(ncmetapath):
                 if line.startswith('#define NC_HAS_CDF5'):
-                    has_cdf5 = True
+                    has_cdf5_format = bool(int(line.split()[2]))
         break
 
     return has_rename_grp, has_nc_inq_path, has_nc_inq_format_extended, \
@@ -463,13 +462,12 @@ netcdf_lib_version = getnetcdfvers(lib_d
 if netcdf_lib_version is None:
     sys.stdout.write('unable to detect netcdf library version\n')
 else:
+    netcdf_lib_version = str(netcdf_lib_version)
     sys.stdout.write('using netcdf library version %s\n' % netcdf_lib_version)
 
 cmdclass = {}
 netcdf4_src_root = osp.join('netCDF4', '_netCDF4')
 netcdf4_src_c = netcdf4_src_root + '.c'
-netcdftime_src_root = osp.join('netcdftime', '_netcdftime')
-netcdftime_src_c = netcdftime_src_root + '.c'
 if 'sdist' not in sys.argv[1:] and 'clean' not in sys.argv[1:]:
     sys.stdout.write('using Cython to compile netCDF4.pyx...\n')
     # remove _netCDF4.c file if it exists, so cython will recompile _netCDF4.pyx.
@@ -478,12 +476,15 @@ if 'sdist' not in sys.argv[1:] and 'clea
     if len(sys.argv) >= 2:
         if os.path.exists(netcdf4_src_c):
             os.remove(netcdf4_src_c)
-        # same for _netcdftime.c
-        if os.path.exists(netcdftime_src_c):
-            os.remove(netcdftime_src_c)
     # this determines whether renameGroup and filepath methods will work.
     has_rename_grp, has_nc_inq_path, has_nc_inq_format_extended, \
         has_cdf5_format, has_nc_open_mem, has_nc_par = check_api(inc_dirs)
+    # for netcdf 4.4.x CDF5 format is always enabled.
+    if netcdf_lib_version is not None and\
+       (netcdf_lib_version > "4.4" and netcdf_lib_version < "4.5"):
+        has_cdf5_format = True
+
+    # disable parallel support if mpi4py not available.
     try:
         import mpi4py
     except ImportError:
@@ -546,15 +547,13 @@ if 'sdist' not in sys.argv[1:] and 'clea
                              libraries=libs,
                              library_dirs=lib_dirs,
                              include_dirs=inc_dirs + ['include'],
-                             runtime_library_dirs=runtime_lib_dirs),
-                   Extension('netcdftime._netcdftime',
-                             [netcdftime_src_root + '.pyx'])]
+                             runtime_library_dirs=runtime_lib_dirs)]
 else:
     ext_modules = None
 
 setup(name="netCDF4",
       cmdclass=cmdclass,
-      version="1.3.1",
+      version="1.4.0",
       long_description="netCDF version 4 has many features not found in earlier versions of the library, such as hierarchical groups, zlib compression, multiple unlimited dimensions, and new data types.  It is implemented on top of HDF5.  This module implements most of the new features, and can read and write netCDF files compatible with older versions of the library.  The API is modelled after Scientific.IO.NetCDF, and should be familiar to users of that module.\n\nThis project is hosted on a `GitHub repository <https://github.com/Unidata/netcdf4-python>`_ where you may access the most up-to-date source.",
       author="Jeff Whitaker",
       author_email="jeffrey.s.whitaker@noaa.gov",
@@ -578,6 +577,6 @@ setup(name="netCDF4",
                    "Topic :: Software Development :: Libraries :: Python Modules",
                    "Topic :: System :: Archiving :: Compression",
                    "Operating System :: OS Independent"],
-      packages=['netcdftime', 'netCDF4'],
+      packages=['netCDF4'],
       ext_modules=ext_modules,
       **setuptools_extra_kwargs)
Binary files 1.3.1-1/test/20171025_2056.Cloud_Top_Height.nc and 1.4.0-1/test/20171025_2056.Cloud_Top_Height.nc differ
diff -pruN 1.3.1-1/test/run_all.py 1.4.0-1/test/run_all.py
--- 1.3.1-1/test/run_all.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/run_all.py	2018-05-01 17:12:07.000000000 +0000
@@ -1,4 +1,4 @@
-import glob, os, sys, unittest
+import glob, os, sys, unittest, struct
 from netCDF4 import getlibversion,__hdf5libversion__,__netcdf4libversion__,__version__
 from netCDF4 import __has_cdf5_format__, __has_nc_inq_path__, __has_nc_par__
 
@@ -21,7 +21,7 @@ if __netcdf4libversion__ < '4.2.1' or __
 if not __has_nc_inq_path__:
     test_files.remove('tst_filepath.py')
     sys.stdout.write('not running tst_filepath.py ...\n')
-if not __has_cdf5_format__:
+if not __has_cdf5_format__ or struct.calcsize("P") < 8:
     test_files.remove('tst_cdf5.py')
     sys.stdout.write('not running tst_cdf5.py ...\n')
 
diff -pruN 1.3.1-1/test/tst_atts.py 1.4.0-1/test/tst_atts.py
--- 1.3.1-1/test/tst_atts.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_atts.py	2018-05-01 17:12:07.000000000 +0000
@@ -31,8 +31,11 @@ INTATT = 1
 FLOATATT = math.pi
 SEQATT = NP.arange(10)
 STRINGSEQATT = ['mary ','','had ','a ','little ','lamb',]
+#ATTDICT = {'stratt':STRATT,'floatatt':FLOATATT,'seqatt':SEQATT,
+#           'stringseqatt':''.join(STRINGSEQATT), # changed in issue #770
+#           'emptystratt':EMPTYSTRATT,'intatt':INTATT}
 ATTDICT = {'stratt':STRATT,'floatatt':FLOATATT,'seqatt':SEQATT,
-           'stringseqatt':''.join(STRINGSEQATT),
+           'stringseqatt':STRINGSEQATT,
            'emptystratt':EMPTYSTRATT,'intatt':INTATT}
 
 class VariablesTestCase(unittest.TestCase):
@@ -126,7 +129,8 @@ class VariablesTestCase(unittest.TestCas
         assert f.stratt == STRATT
         assert f.emptystratt == EMPTYSTRATT
         assert f.seqatt.tolist() == SEQATT.tolist()
-        assert f.stringseqatt == ''.join(STRINGSEQATT)
+        #assert f.stringseqatt == ''.join(STRINGSEQATT) # issue 770
+        assert f.stringseqatt == STRINGSEQATT
         assert f.stringseqatt_array == STRINGSEQATT
         assert f.getncattr('file_format') == 'netcdf4_format'
         # variable attributes.
@@ -141,7 +145,8 @@ class VariablesTestCase(unittest.TestCas
         assert v.floatatt == FLOATATT
         assert v.stratt == STRATT
         assert v.seqatt.tolist() == SEQATT.tolist()
-        assert v.stringseqatt == ''.join(STRINGSEQATT)
+        #assert v.stringseqatt == ''.join(STRINGSEQATT) # issue 770
+        assert v.stringseqatt == STRINGSEQATT
         assert v.stringseqatt_array == STRINGSEQATT
         assert v.getncattr('ndim') == 'three'
         assert v.getncattr('foo') == 1
@@ -178,7 +183,8 @@ class VariablesTestCase(unittest.TestCas
         assert g.stratt == STRATT
         assert g.emptystratt == EMPTYSTRATT
         assert g.seqatt.tolist() == SEQATT.tolist()
-        assert g.stringseqatt == ''.join(STRINGSEQATT)
+        #assert g.stringseqatt == ''.join(STRINGSEQATT) # issue 770
+        assert g.stringseqatt == STRINGSEQATT
         assert g.stringseqatt_array == STRINGSEQATT
         for key,val in ATTDICT.items():
             if type(val) == NP.ndarray:
@@ -190,7 +196,8 @@ class VariablesTestCase(unittest.TestCas
         assert v1.stratt == STRATT
         assert v1.emptystratt == EMPTYSTRATT
         assert v1.seqatt.tolist() == SEQATT.tolist()
-        assert v1.stringseqatt == ''.join(STRINGSEQATT)
+        #assert v1.stringseqatt == ''.join(STRINGSEQATT) # issue 770
+        assert v1.stringseqatt == STRINGSEQATT
         assert v1.stringseqatt_array == STRINGSEQATT
         assert getattr(v1,'nonexistantatt',None) == None
         f.close()
diff -pruN 1.3.1-1/test/tst_compoundatt.py 1.4.0-1/test/tst_compoundatt.py
--- 1.3.1-1/test/tst_compoundatt.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_compoundatt.py	2018-05-01 17:12:07.000000000 +0000
@@ -2,7 +2,7 @@ import sys
 import unittest
 import os
 import tempfile
-from netCDF4 import Dataset, CompoundType, chartostring, stringtoarr
+from netCDF4 import Dataset, CompoundType
 import numpy as np
 from numpy.testing import assert_array_equal, assert_array_almost_equal
 
@@ -16,15 +16,13 @@ GROUP_NAME = 'forecasts'
 dtype=np.dtype([('speed', 'f4'), ('direction', 'f4')])
 TYPE_NAME = 'wind_vector_type'
 TYPE_NAMEC = 'wind_vectorunits_type'
-dtypec=np.dtype([('speed', 'c',(8,)), ('direction', 'c',(8,))])
+dtypec=np.dtype([('speed', 'S8'), ('direction', 'S8')])
 missvals = np.empty(1,dtype)
 missvals['direction']=1.e20
 missvals['speed']=-999.
-windunits = np.zeros(1,dtypec)
-windunits['speed'] = stringtoarr('m/s',\
-        dtypec.fields['speed'][0].itemsize)
-windunits['direction'] = stringtoarr('degrees',\
-        dtypec.fields['direction'][0].itemsize)
+windunits = np.empty(1,dtypec)
+windunits['speed'] = 'm/s'
+windunits['direction'] = 'degrees'
 
 class VariablesTestCase(unittest.TestCase):
 
@@ -65,10 +63,10 @@ class VariablesTestCase(unittest.TestCas
         assert_array_equal(vv.units['speed'], windunits['speed'].squeeze())
         assert_array_equal(vv.units['direction'],\
                 windunits['direction'].squeeze())
-        assert(chartostring(v.units['speed']).item().rstrip() == 'm/s')
-        assert(chartostring(v.units['direction']).item().rstrip() == 'degrees')
-        assert(chartostring(vv.units['speed']).item().rstrip() == 'm/s')
-        assert(chartostring(vv.units['direction']).item().rstrip() == 'degrees')
+        assert(v.units['speed'] == b'm/s')
+        assert(v.units['direction'] == b'degrees')
+        assert(vv.units['speed'] == b'm/s')
+        assert(vv.units['direction'] == b'degrees')
         f.close()
 
 if __name__ == '__main__':
diff -pruN 1.3.1-1/test/tst_compoundvar.py 1.4.0-1/test/tst_compoundvar.py
--- 1.3.1-1/test/tst_compoundvar.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_compoundvar.py	2018-05-01 17:12:07.000000000 +0000
@@ -111,6 +111,30 @@ class VariablesTestCase(unittest.TestCas
         assert_array_almost_equal(dataoutg['y1']['x'],datag['y1']['x'])
         assert_array_almost_equal(dataoutg['y1']['y'],datag['y1']['y'])
         f.close()
+        # issue 773
+        f = Dataset(self.file,'w')
+        dtype = np.dtype([('observation', 'i4'),
+                          ('station_name','S80')])
+        dtype_nest = np.dtype([('observation', 'i4'),
+                               ('station_name','S80'),
+                               ('nested_observation',dtype)])
+        station_data_t1 = f.createCompoundType(dtype,'station_data1')
+        station_data_t2 = f.createCompoundType(dtype_nest,'station_data')
+        f.createDimension('station',None)
+        statdat = f.createVariable('station_obs', station_data_t2, ('station',))
+        assert(statdat.dtype == station_data_t2.dtype)
+        datain = np.empty(2,station_data_t2.dtype_view)
+        datain['observation'][:] = (123,314)
+        datain['station_name'][:] = ('Boulder','New York')
+        datain['nested_observation']['observation'][:] = (-999,999)
+        datain['nested_observation']['station_name'][:] = ('Boston','Chicago')
+        statdat[:] = datain
+        f.close()
+        f = Dataset(self.file)
+        dataout = f['station_obs'][:]
+        assert(dataout.dtype == station_data_t2.dtype_view)
+        assert_array_equal(datain, dataout)
+        f.close()
 
 if __name__ == '__main__':
     from netCDF4 import getlibversion
diff -pruN 1.3.1-1/test/tst_enum.py 1.4.0-1/test/tst_enum.py
--- 1.3.1-1/test/tst_enum.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_enum.py	2018-05-01 17:12:07.000000000 +0000
@@ -12,7 +12,7 @@ ENUM_BASETYPE = np.int8
 VAR_NAME = 'primary_cloud'
 ENUM_DICT = {u'Altocumulus': 7, u'Missing': 127, u'Stratus': 2, u'Clear': 0,
 u'Nimbostratus': 6, u'Cumulus': 4, u'Altostratus': 5, u'Cumulonimbus': 1,
-u'Stratocumulus': 3} 
+u'Stratocumulus': 3}
 datain = np.array([ENUM_DICT['Clear'],ENUM_DICT['Stratus'],ENUM_DICT['Cumulus'],\
                    ENUM_DICT['Missing'],ENUM_DICT['Cumulonimbus']],dtype=ENUM_BASETYPE)
 datain_masked = np.ma.masked_values(datain,ENUM_DICT['Missing'])
@@ -51,6 +51,7 @@ class EnumTestCase(unittest.TestCase):
         v = f.variables[VAR_NAME]
         assert v.datatype.enum_dict == ENUM_DICT
         assert list(f.enumtypes.keys()) == [ENUM_NAME]
+        assert f.enumtypes[ENUM_NAME].name == ENUM_NAME # issue 775
         assert f.enumtypes[ENUM_NAME].dtype == ENUM_BASETYPE
         assert v._FillValue == ENUM_DICT['Missing']
         v.set_auto_mask(False)
diff -pruN 1.3.1-1/test/tst_fancyslicing.py 1.4.0-1/test/tst_fancyslicing.py
--- 1.3.1-1/test/tst_fancyslicing.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_fancyslicing.py	2018-05-01 17:12:07.000000000 +0000
@@ -112,7 +112,9 @@ class VariablesTestCase(unittest.TestCas
         # Empty boolean -- all False
         d1 = f.variables['data1']
         m = np.zeros(xdim, bool)
-        assert_equal(d1[m], ())
+        if np.__version__ > '1.9.0':
+            # fails for old numpy versions
+            assert_equal(d1[m], ())
 
         # Check that no assignment is made
         d1[m] = 0
diff -pruN 1.3.1-1/test/tst_masked4.py 1.4.0-1/test/tst_masked4.py
--- 1.3.1-1/test/tst_masked4.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_masked4.py	2018-05-01 17:12:07.000000000 +0000
@@ -94,7 +94,9 @@ class SetValidMinMax(unittest.TestCase):
         assert_array_almost_equal(v2, self.v_scaled)
         self.assertTrue(np.all(self.v_ma.mask == v.mask))
         self.assertTrue(np.all(self.v_ma.mask == v2.mask))
-        self.assertTrue(np.all(self.v_ma.mask == v3.mask))
+        # treating _FillValue as valid_min/valid_max was
+        # too suprising, revert to old behaviour (issue #761)
+        #self.assertTrue(np.all(self.v_ma.mask == v3.mask))
         # check that underlying data is same as in netcdf file
         v = f.variables['v']
         v.set_auto_scale(False) 
diff -pruN 1.3.1-1/test/tst_masked.py 1.4.0-1/test/tst_masked.py
--- 1.3.1-1/test/tst_masked.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_masked.py	2018-05-01 17:12:07.000000000 +0000
@@ -110,6 +110,14 @@ class PrimitiveTypesTestCase(unittest.Te
         # added test for issue 515
         assert(file['v'][0] is NP.ma.masked)
         file.close()
+        # issue 766
+        NP.seterr(invalid='raise')
+        f = netCDF4.Dataset(self.file, 'w')
+        f.createDimension('dimension', 2)
+        f.createVariable('variable', NP.float32, dimensions=('dimension',))
+        f['variable'][:] = NP.nan
+        data = f['variable'][:] # should not raise an error
+        f.close()
 
 if __name__ == '__main__':
     unittest.main()
diff -pruN 1.3.1-1/test/tst_netcdftime.py 1.4.0-1/test/tst_netcdftime.py
--- 1.3.1-1/test/tst_netcdftime.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_netcdftime.py	2018-05-01 17:12:07.000000000 +0000
@@ -1,6 +1,6 @@
-from netcdftime import utime, JulianDayFromDate, DateFromJulianDay
-from netcdftime import datetime as datetimex
-from netcdftime import DatetimeNoLeap, DatetimeAllLeap, Datetime360Day, DatetimeJulian, \
+from cftime import utime, JulianDayFromDate, DateFromJulianDay
+from cftime import datetime as datetimex
+from cftime import DatetimeNoLeap, DatetimeAllLeap, Datetime360Day, DatetimeJulian, \
     DatetimeGregorian, DatetimeProlepticGregorian, _parse_date
 from netCDF4 import Dataset, num2date, date2num, date2index, num2date
 import copy
@@ -46,7 +46,7 @@ class netcdftimeTestCase(unittest.TestCa
         # check attributes.
         self.assertTrue(self.cdftime_mixed.units == 'hours')
         self.assertTrue(
-            str(self.cdftime_mixed.origin) == '   1-01-01 00:00:00')
+            str(self.cdftime_mixed.origin) == '0001-01-01 00:00:00')
         self.assertTrue(
             self.cdftime_mixed.unit_string == 'hours since 0001-01-01 00:00:00')
         self.assertTrue(self.cdftime_mixed.calendar == 'standard')
@@ -85,7 +85,7 @@ class netcdftimeTestCase(unittest.TestCa
         self.assertTrue(d_check == ''.join(d2))
         # test proleptic gregorian calendar.
         self.assertTrue(self.cdftime_pg.units == 'seconds')
-        self.assertTrue(str(self.cdftime_pg.origin) == '   1-01-01 00:00:00')
+        self.assertTrue(str(self.cdftime_pg.origin) == '0001-01-01 00:00:00')
         self.assertTrue(
             self.cdftime_pg.unit_string == 'seconds since 0001-01-01 00:00:00')
         self.assertTrue(self.cdftime_pg.calendar == 'proleptic_gregorian')
@@ -280,7 +280,7 @@ class netcdftimeTestCase(unittest.TestCa
 
         # Check leading white space
         self.assertEqual(
-            str(self.cdftime_leading_space.origin), ' 850-01-01 00:00:00')
+            str(self.cdftime_leading_space.origin), '0850-01-01 00:00:00')
 
         #issue 330
         units = "seconds since 1970-01-01T00:00:00Z"
@@ -477,12 +477,12 @@ class netcdftimeTestCase(unittest.TestCa
         assert (d.day == 1)
         assert (d.hour == 0)
         # test fix for issue #659 (proper treatment of negative time values).
-        units = 'days since 1800-01-01 00:00:0.0'
-        d = num2date(-657073, units, calendar='standard')
-        assert (d.year == 1)
-        assert (d.month == 1)
-        assert (d.day == 1)
-        assert (d.hour == 0)
+        #units = 'days since 1800-01-01 00:00:0.0'
+        #d = num2date(-657073, units, calendar='standard')
+        #assert (d.year == 1)
+        #assert (d.month == 1)
+        #assert (d.day == 1)
+        #assert (d.hour == 0)
         # issue 685: wrong time zone conversion
         # 'The following times all refer to the same moment: "18:30Z", "22:30+04", "1130-0700", and "15:00-03:30'
         # (https://en.wikipedia.org/w/index.php?title=ISO_8601&oldid=787811367#Time_offsets_from_UTC)
diff -pruN 1.3.1-1/test/tst_scaled.py 1.4.0-1/test/tst_scaled.py
--- 1.3.1-1/test/tst_scaled.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_scaled.py	2018-05-01 17:12:07.000000000 +0000
@@ -63,7 +63,8 @@ class SetAutoScaleFalse(SetAutoScaleTest
 
         self.assertEqual(v.dtype, "i2")
         self.assertTrue(isinstance(v, np.ndarray))
-        self.assertTrue(not isinstance(v, ma.core.MaskedArray))
+        # issue 785: always return masked array by default
+        self.assertTrue(isinstance(v, ma.core.MaskedArray))
         assert_array_almost_equal(v, self.v)
 
         f.close()
@@ -107,7 +108,8 @@ class SetAutoScaleTrue(SetAutoScaleTestB
 
         self.assertEqual(v_scaled.dtype, "f8")
         self.assertTrue(isinstance(v_scaled, np.ndarray))
-        self.assertTrue(not isinstance(v_scaled, ma.core.MaskedArray))
+        # issue 785: always return masked array by default
+        self.assertTrue(isinstance(v_scaled, ma.core.MaskedArray))
         assert_array_almost_equal(v_scaled, self.v_scaled)
         f.close()
 
diff -pruN 1.3.1-1/test/tst_slicing.py 1.4.0-1/test/tst_slicing.py
--- 1.3.1-1/test/tst_slicing.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_slicing.py	2018-05-01 17:12:07.000000000 +0000
@@ -94,6 +94,10 @@ class VariablesTestCase(unittest.TestCas
         v[...] = 10
         assert_array_equal(v[...], 10)
         assert_equal(v.shape, v[...].shape)
+        # issue #785: always return masked array
+        #assert(type(v[...]) == np.ndarray)
+        assert(type(v[...]) == np.ma.core.MaskedArray)
+        f.set_auto_mask(False)
         assert(type(v[...]) == np.ndarray)
         f.close()
 
@@ -194,5 +198,18 @@ class VariablesTestCase(unittest.TestCas
         assert_equal(data.shape, shape)
         f.close()
 
+    def test_issue743(self):
+        nc = Dataset(self.file,'w',format='NETCDF3_CLASSIC')
+        td = nc.createDimension('t',None)
+        xd = nc.createDimension('x',33)
+        yd = nc.createDimension('y',4)
+        v = nc.createVariable('v',np.float,('t','x','y'))
+        nc.close()
+        nc = Dataset(self.file)
+        data = np.empty(nc['v'].shape, nc['v'].dtype)
+        data2 = nc['v'][...]
+        assert_array_equal(data,data2)
+        nc.close()
+
 if __name__ == '__main__':
     unittest.main()
diff -pruN 1.3.1-1/test/tst_unicode3.py 1.4.0-1/test/tst_unicode3.py
--- 1.3.1-1/test/tst_unicode3.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_unicode3.py	2018-05-01 17:12:07.000000000 +0000
@@ -33,7 +33,9 @@ class UnicodeTestCase(unittest.TestCase)
         # check accessing individual attributes.
         assert f.attribute1 == ATT1
         assert f.attribute2 == ATT2
-        assert f.attribute3 == ''.join(ATT3)
+        #assert f.attribute3 == ''.join(ATT3)
+        # behavior changed pull request #771
+        assert f.attribute3 == ATT3
         f.close()
 
 if __name__ == '__main__':
diff -pruN 1.3.1-1/test/tst_unicode.py 1.4.0-1/test/tst_unicode.py
--- 1.3.1-1/test/tst_unicode.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_unicode.py	2018-05-01 17:12:07.000000000 +0000
@@ -33,7 +33,8 @@ class UnicodeTestCase(unittest.TestCase)
         # check accessing individual attributes.
         assert f.attribute1 == ATT1
         assert f.attribute2 == ATT2
-        assert f.attribute3 == ''.join(ATT3)
+        #assert f.attribute3 == ''.join(ATT3)
+        assert f.attribute3 == ATT3 # behavior changed issue 770
         f.close()
 
 if __name__ == '__main__':
diff -pruN 1.3.1-1/test/tst_Unsigned.py 1.4.0-1/test/tst_Unsigned.py
--- 1.3.1-1/test/tst_Unsigned.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_Unsigned.py	2018-05-01 17:12:07.000000000 +0000
@@ -30,6 +30,16 @@ class Test_Unsigned(unittest.TestCase):
         data2 = f['soil_moisture'][:]
         assert(data1.mask.sum() == data2.mask.sum())
         f.close()
+        # issue 794
+        # test that valid_min/valid_max/_FillValue are
+        # treated as unsigned integers.
+        f=netCDF4.Dataset('20171025_2056.Cloud_Top_Height.nc')
+        data = f['HT'][:]
+        assert(data.mask.sum() == 57432)
+        assert(int(data.max()) == 15430)
+        assert(int(data.min()) == 0)
+        assert(data.dtype == np.float32)
+        f.close()
 
 if __name__ == '__main__':
     unittest.main()
diff -pruN 1.3.1-1/test/tst_vlen.py 1.4.0-1/test/tst_vlen.py
--- 1.3.1-1/test/tst_vlen.py	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/test/tst_vlen.py	2018-05-01 17:12:07.000000000 +0000
@@ -105,6 +105,21 @@ class TestScalarVlenString(unittest.Test
         f.close()
         os.remove(FILE_NAME)
 
+class TestIntegerIndex(unittest.TestCase):
+    # issue 526
+    def runTest(self):
+        strtest = Dataset(FILE_NAME, 'w', format='NETCDF4')
+        strtest.createDimension('tenstrings', 10)
+        strtest.createVariable('tenstrings', str, ['tenstrings'])
+        strtest['tenstrings'][np.int32(5)] = 'asdf'
+        strtest['tenstrings'][6.0] = 'asdf'
+        strtest.close()
+        f = Dataset(FILE_NAME)
+        assert f.variables['tenstrings'][np.int32(5)] == 'asdf'
+        assert f.variables['tenstrings'][6.0] == 'asdf'
+        f.close()
+        os.remove(FILE_NAME)
+
 class TestObjectArrayIndexing(unittest.TestCase):
 
     def setUp(self):
diff -pruN 1.3.1-1/.travis.yml 1.4.0-1/.travis.yml
--- 1.3.1-1/.travis.yml	2017-10-30 16:41:03.000000000 +0000
+++ 1.4.0-1/.travis.yml	2018-05-01 17:12:07.000000000 +0000
@@ -11,7 +11,7 @@ addons:
 
 env:
   global:
-    - DEPENDS="numpy>=1.9.0 cython>=0.21 setuptools>=18.0"
+    - DEPENDS="numpy>=1.9.0 cython>=0.21 setuptools>=18.0 cftime"
     - NO_NET=1
     - MPI=0
 
@@ -27,13 +27,13 @@ matrix:
     # Absolute minimum dependencies.
     - python: 2.7
       env:
-        - DEPENDS="numpy==1.9.0 cython==0.21 ordereddict==1.1 setuptools==18.0"
+        - DEPENDS="numpy==1.9.0 cython==0.21 ordereddict==1.1 setuptools==18.0 cftime"
     # test MPI
     - python: 2.7
       env: 
         - MPI=1
         - CC=mpicc
-        - DEPENDS="numpy>=1.9.0 cython>=0.21 setuptools>=18.0 mpi4py>=1.3.1"
+        - DEPENDS="numpy>=1.9.0 cython>=0.21 setuptools>=18.0 mpi4py>=1.3.1 cftime"
         - NETCDF_VERSION=4.4.1.1
         - NETCDF_DIR=$HOME
         - PATH=${NETCDF_DIR}/bin:${PATH} # pick up nc-config here
@@ -48,6 +48,7 @@ notifications:
   email: false
 
 before_install:
+  - pip install Cython # workaround for pip bug
   - pip install $DEPENDS
 
 install:
